# FindFirstFunctions

[![Build Status](https://github.com/SciML/FindFirstFunctions.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/SciML/FindFirstFunctions.jl/actions/workflows/CI.yml?query=branch%3Amain)

FindFirstFunctions.jl is a package for faster `findfirst` type functions. These are specialized to improve performance
over more generic implementations.

## Functions

### `findfirstequal`

```julia
findfirstequal(x::Int64,A::DenseVector{Int64})
```

Finds the first index in `A` where the value equals `x`.

### `bracketstrictlymontonic`

```julia
bracketstrictlymontonic(v, x, guess; lt=<comparison>, by=<transform>, rev=false)
```

Starting from an initial `guess` index, find indices `(lo, hi)` such that `v[lo] ≤ x ≤
v[hi]` according to the specified order, assuming that `x` is actually within the range of
values found in `v`.  If `x` is outside that range, either `lo` will be `firstindex(v)` or
`hi` will be `lastindex(v)`.

Note that the results will not typically satisfy `lo ≤ guess ≤ hi`.  If `x` is precisely
equal to a value that is not unique in the input `v`, there is no guarantee that `(lo, hi)`
will encompass *all* indices corresponding to that value.

This algorithm is essentially an expanding binary search, which can be used as a precursor
to `searchsorted` and related functions, which can take `lo` and `hi` as arguments.  The
purpose of using this function first would be to accelerate convergence in those functions
by using correlated `guess`es for repeated calls.  The best `guess` for the next call of
this function would be the index returned by the previous call to `searchsorted`.

See `Base.sort!` for an explanation of the keyword arguments `by`, `lt` and `rev`.

### `searchsortedfirstcorrelated(v::AbstractVector, x, guess)`

```julia
searchsortedfirstcorrelated(v::AbstractVector, x, guess)
```

An accelerated `findfirst` on sorted vectors using a bracketed search. Requires a `guess`
to start the search from, which is either an integer or an instance of `Guesser`.

An analogous function `searchsortedlastcorrelated` exists.


Some benchmarks:
```julia
using Random, BenchmarkTools, FindFirstFunctions
x = rand(Int, 2048); s = sort(x);
perm = randperm(length(x));

function findbench(f, x, vals)
    @inbounds for i = eachindex(x, vals)
        v = vals[i]
        f(x[v], x) == v || throw("oops")
    end
end

@benchmark findbench(FindFirstFunctions.findfirstequal, $x, $perm)
@benchmark findbench((x,v)->findfirst(==(x), v), $x, $perm)

@benchmark findbench(FindFirstFunctions.findfirstsortedequal, $s, $perm)
@benchmark findbench((x,v)->searchsortedfirst(v, x), $s, $perm)
```
Sample results using `-Cnative,-prefer-256-bit` on an AVX512 capable laptop:
```julia
julia> @benchmark findbench(FindFirstFunctions.findfirstequal, $x, $perm)
BenchmarkTools.Trial: 6794 samples with 1 evaluation.
 Range (min … max):  141.489 μs … 190.383 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     145.892 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   145.978 μs ±   4.697 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

  ▇▅     ▁▁  ▁█▅     ▁▂▁  ▂▃▂     ▁           ▁                 ▁
  ██▆▁▁▁▃██▆▄███▄▃▄▃▄███▁▆████▅▅▅▇█▇▇▆▆▆▆▇▆▅▃▇█▆▇▇▆▅▆▇▇▇▇▆▇█▅▅▅ █
  141 μs        Histogram: log(frequency) by time        163 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> @benchmark findbench((x,v)->findfirst(==(x), v), $x, $perm)
BenchmarkTools.Trial: 1765 samples with 1 evaluation.
 Range (min … max):  547.812 μs … 663.534 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     564.245 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   565.600 μs ±  14.561 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

  ▇▄▄▄    ▄ █▄▅▆▅ ▂▁▂▅▃▃▅       ▁                               ▁
  ████▁▁▁▁█▇████████████████▇█▇██▆▅▆▅▅▄▅▅▄▄▆▁▄▄▅▅▅▁▁▅▅▅▅▆▄▁▁▁▄▅ █
  548 μs        Histogram: log(frequency) by time        628 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> @benchmark findbench(FindFirstFunctions.findfirstsortedequal, $s, $perm)
BenchmarkTools.Trial: 10000 samples with 1 evaluation.
 Range (min … max):  75.857 μs … 125.111 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     85.811 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   86.135 μs ±   3.217 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

                    ▁   ▂██▃                                    
  ▂▁▁▁▂▂▁▁▁▁▁▁▁▂▂▃▅██▆▄▆████▅▄▃▃▃▃▃▃▃▃▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂ ▃
  75.9 μs         Histogram: frequency by time          101 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> @benchmark findbench((x,v)->searchsortedfirst(v, x), $s, $perm)
BenchmarkTools.Trial: 8741 samples with 1 evaluation.
 Range (min … max):  108.941 μs … 152.368 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     113.026 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   113.282 μs ±   3.812 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

     ▂▅▂     ▄█▇▂                                                
  ▁▂▅███▆▃▂▃▆████▆▂▂▂▂▂▂▂▂▂▂▂▂▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁ ▂
  109 μs           Histogram: frequency by time          130 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> versioninfo()
Julia Version 1.10.0
Commit 3120989f39 (2023-12-25 18:01 UTC)
Build Info:

    Note: This is an unofficial build, please report bugs to the project
    responsible for this build and not to the Julia project unless you can
    reproduce the issue using official builds available at https://julialang.org/downloads

Platform Info:
  OS: Linux (x86_64-redhat-linux)
  CPU: 36 × Intel(R) Core(TM) i9-7980XE CPU @ 2.60GHz
  WORD_SIZE: 64
  LIBM: libopenlibm
  LLVM: libLLVM-15.0.7 (ORCJIT, skylake-avx512)
  Threads: 1 on 36 virtual cores
Environment:
  JULIA_PATH = @.
  LD_LIBRARY_PATH = /usr/local/lib/x86_64-unknown-linux-gnu/:/usr/local/lib/:/usr/local/lib/x86_64-unknown-linux-gnu/:/usr/local/lib/
  JULIA_NUM_THREADS = 36
  LD_UN_PATH = /usr/local/lib/x86_64-unknown-linux-gnu/:/usr/local/lib/
```


Note, if you're searching sorted collections and on an x86 CPU, it is worth setting the `ENV` variable `JULIA_LLVM_ARGS="-x86-cmov-converter=false"` before starting Julia, e.g. on an AVX512 capable CPU, you may wish to start Julia from the command line using
```sh
JULIA_LLVM_ARGS="-x86-cmov-converter=false" julia -Cnative,-prefer-256-bit
```
With this, benchmark results are
```julia
julia> @benchmark findbench(FindFirstFunctions.findfirstequal, $x, $perm)
BenchmarkTools.Trial: 6623 samples with 1 evaluation.
 Range (min … max):  141.304 μs … 473.786 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     145.581 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   149.690 μs ±  28.577 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

  █▇▃▄▃▂▁▁▁  ▂                                 ▁                ▁
  ██████████▆█▇▆▇▆▅▄▅▁▅▅▃▄▅▁▃▃▁▃▃▁▁▄▁▁▁▁▁▁▁▁▃▁▁█▄▆▅▅▁▁▃▁▁▁▃▁▁▁▃ █
  141 μs        Histogram: log(frequency) by time        302 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> @benchmark findbench((x,v)->findfirst(==(x), v), $x, $perm)
BenchmarkTools.Trial: 1784 samples with 1 evaluation.
 Range (min … max):  546.395 μs … 660.254 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     560.513 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   559.546 μs ±  14.138 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

  █▆▄▇      ▆▇▄▄█▂▂▁▂▁▁▁▁                                       ▁
  ████▄▁▅▁▇▅█████████████▆▇▇▅▄▅▅▄▁▄▅▆▄▅▆▄▆▄▄▅▄▁▁▁▁▁▅▁▁▄▄▅▆▄▄▄▁▇ █
  546 μs        Histogram: log(frequency) by time        625 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> @benchmark findbench(FindFirstFunctions.findfirstsortedequal, $s, $perm)
BenchmarkTools.Trial: 10000 samples with 1 evaluation.
 Range (min … max):  45.969 μs … 73.354 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     47.674 μs              ┊ GC (median):    0.00%
 Time  (mean ± σ):   47.675 μs ±  1.999 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

  ▃▇▇▅  ▁▆██▅   ▁▂▃▂   ▁▂▁                                    ▂
  █████▅██████▆▇████▇▄▇████▆▅▄▆████▇▆▆▁▁▁▁▄▄▃▃▃▃▁▁▁▁▁▁▃▄▆▅▆▄▆ █
  46 μs        Histogram: log(frequency) by time      58.1 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> @benchmark findbench((x,v)->searchsortedfirst(v, x), $s, $perm)
BenchmarkTools.Trial: 10000 samples with 1 evaluation.
 Range (min … max):  35.988 μs … 224.353 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     37.807 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   38.966 μs ±   7.905 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

   ▁▇▆▅█▅          ▃▂ ▁▂                                       ▂
  ▇██████▄▇█▆▆███▇███▇███▄▄▁▅▃▅▅▄▄▇██▆▇▇▃▅▄▅▄▆▇▅▄▄▆▇▇▅▄▅▅▁▃▁▄▄ █
  36 μs         Histogram: log(frequency) by time        57 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> @benchmark findbench((x,v)->FindFirstFunctions.findfirstsortedequal(x,v,Val(64)), $s, $perm)
BenchmarkTools.Trial: 10000 samples with 1 evaluation.
 Range (min … max):  43.709 μs … 182.914 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     45.227 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   45.954 μs ±   5.377 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

  ▃▇█▅▂▆█▇▃▁▂▂▁  ▁▁▁▁  ▁ ▁                ▁▁                   ▂
  █████████████▆▇████▇████▇▇▆▆▇█▇▅▆▆▅▄▄▅▆███▇▆██▆▅▅▅▃▄▁▄▄▅▆▅▆▆ █
  43.7 μs       Histogram: log(frequency) by time      61.4 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> @benchmark findbench((x,v)->FindFirstFunctions.findfirstsortedequal(x,v,Val(32)), $s, $perm)
BenchmarkTools.Trial: 10000 samples with 1 evaluation.
 Range (min … max):  42.482 μs … 172.067 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     44.422 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   45.765 μs ±   8.329 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

  ▆███▄▂ ▂▁▃▃                                                  ▂
  ████████████▆▆▆▅▆██▇▄▄▃▄▅▇▇▄▄▄▃▄▄▁▃▁▁▁▃▁▃▁▃▁▁▁▃██▇▇▄▁▃▄▁▄▄▄▃ █
  42.5 μs       Histogram: log(frequency) by time      83.3 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> @benchmark findbench((x,v)->FindFirstFunctions.findfirstsortedequal(x,v,Val(16)), $s, $perm)
BenchmarkTools.Trial: 10000 samples with 1 evaluation.
 Range (min … max):  36.870 μs … 154.299 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     39.764 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   40.400 μs ±   2.552 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

   ▁▂▁   ▂▆██▆▅▆▇▆▃▂▃▃▂    ▁▁                                  ▂
  ▆███▃▃▅███████████████▇▇████▇▆▆▇▇▇▇▆▆▆▅▃▃▅▅▅▅▄▆▆▅▅▇▇▅▆▅▅▃▁▃▅ █
  36.9 μs       Histogram: log(frequency) by time        53 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.

julia> @benchmark findbench((x,v)->FindFirstFunctions.findfirstsortedequal(x,v,Val(8)), $s, $perm)
BenchmarkTools.Trial: 10000 samples with 1 evaluation.
 Range (min … max):  26.011 μs … 48.109 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     26.954 μs              ┊ GC (median):    0.00%
 Time  (mean ± σ):   27.046 μs ±  1.677 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

  ▆▆  █▆  ▂                                                   ▂
  ██▁▇██▅▁█▆▁▁▆▇▅▅▅▆▇▇▆▅▆▆▆▅▆▇██▇▅▃▃▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▅▅▅▇▅▃▅ █
  26 μs        Histogram: log(frequency) by time      37.9 μs <

 Memory estimate: 0 bytes, allocs estimate: 0.
```
The branches in a binary search are unpredictable, thus disabling the conversion of `cmov` into branches results in a substantial performance increase.
Additionally, enabling `cmov` (i.e., disabling `cmov` conversion) greatly reduces the optimal base case size for `FindFirstFunctions.findfirstsortedequal`. Without `cmov`, we need a very large base case to avoid too many branches, scanning large swaths contiguously.
With `cmov`, we can reduce the base case size to `8`, taking several additional binary search steps without incurring heavy branch prediction penalties.

However, we default to a large base case size, under the assumptions users are not setting this `ENV` variable; we assume that an expert user concerned about binary search performance who sets this variable will also be able to choose their own basecase size.

Take care when benchmarking `JULIA_LLVM_ARGS="-x86-cmov-converter=false"`: your CPU's branch predictor can probably memorize a sequence of hundreds of perfectly random branches. Branch predcitors are great at defeating microbenchmarks.
Thus, you need a very long unpredictable sequence (which I tried to do in the above benchmark) to prevent the branch predictor from memorizing it.
In "real world" workloads, your branch predictor isn't going to be able to memorize a sequence of left vs right bisections in your binary search, as you won't be performing the same searches over and over again!
Without making your benchmark realistic, the default setting of converting `cmov` into branches will look unrealistically good.

If you actually are, memoize. If you're looking for close answers, look for something like `bracketstrictlymontonic`'s `guess` API.

using FindFirstFunctions, Aqua, ExplicitImports, JET, AllocCheck, Test

@testset "Aqua" begin
    Aqua.find_persistent_tasks_deps(FindFirstFunctions)
    Aqua.test_ambiguities(FindFirstFunctions, recursive = false)
    Aqua.test_deps_compat(FindFirstFunctions)
    Aqua.test_piracies(FindFirstFunctions)
    Aqua.test_project_extras(FindFirstFunctions)
    Aqua.test_stale_deps(FindFirstFunctions)
    Aqua.test_unbound_args(FindFirstFunctions)
    Aqua.test_undefined_exports(FindFirstFunctions)
end

@testset "ExplicitImports" begin
    @test check_no_implicit_imports(FindFirstFunctions) === nothing
    @test check_no_stale_explicit_imports(FindFirstFunctions) === nothing
end

@testset "JET static analysis" begin
    # Test key entry points for type stability and potential runtime errors
    vec_int64 = Int64[1, 2, 3, 4, 5, 6, 7, 8, 9, 10]
    vec_float64 = Float64[1.0, 2.0, 3.0, 4.0, 5.0]

    # findfirstequal - fast SIMD-based search
    rep = JET.report_call(FindFirstFunctions.findfirstequal, (Int64, Vector{Int64}))
    @test length(JET.get_reports(rep)) == 0

    # findfirstsortedequal - binary search variant
    rep = JET.report_call(FindFirstFunctions.findfirstsortedequal, (Int64, Vector{Int64}))
    @test length(JET.get_reports(rep)) == 0

    # bracketstrictlymontonic - bracketing for sorted vectors
    rep = JET.report_call(
        FindFirstFunctions.bracketstrictlymontonic,
        (Vector{Int64}, Int64, Int64, Base.Order.ForwardOrdering)
    )
    @test length(JET.get_reports(rep)) == 0

    # looks_linear - linearity check
    rep = JET.report_call(FindFirstFunctions.looks_linear, (Vector{Float64},))
    @test length(JET.get_reports(rep)) == 0

    # Guesser - test constructor and callable
    guesser = FindFirstFunctions.Guesser(vec_float64)
    rep = JET.report_call(guesser, (Float64,))
    @test length(JET.get_reports(rep)) == 0

    # searchsortedfirstcorrelated with Integer guess
    rep = JET.report_call(
        FindFirstFunctions.searchsortedfirstcorrelated,
        (Vector{Int64}, Int64, Int64)
    )
    @test length(JET.get_reports(rep)) == 0

    # searchsortedlastcorrelated with Integer guess
    rep = JET.report_call(
        FindFirstFunctions.searchsortedlastcorrelated,
        (Vector{Int64}, Int64, Int64)
    )
    @test length(JET.get_reports(rep)) == 0

    # searchsortedfirstexp - exponential search
    rep = JET.report_call(
        FindFirstFunctions.searchsortedfirstexp,
        (Vector{Int64}, Int64, Int64, Int64)
    )
    @test length(JET.get_reports(rep)) == 0

    # searchsortedfirstvec - vectorized search
    rep = JET.report_call(
        FindFirstFunctions.searchsortedfirstvec,
        (Vector{Int64}, Vector{Int64})
    )
    @test length(JET.get_reports(rep)) == 0

    # searchsortedlastvec - vectorized search
    rep = JET.report_call(
        FindFirstFunctions.searchsortedlastvec,
        (Vector{Int64}, Vector{Int64})
    )
    @test length(JET.get_reports(rep)) == 0
end

@testset "AllocCheck - Static Allocation Analysis" begin
    # Use AllocCheck's static analysis (check_allocs) instead of runtime @allocated.
    # This is more robust as it analyzes LLVM IR for allocation sites rather than
    # measuring runtime allocations which can be noisy due to GC artifacts.

    @testset "findfirstequal" begin
        # Int64 vector (SIMD path)
        allocs = check_allocs(FindFirstFunctions.findfirstequal, (Int64, Vector{Int64}))
        @test isempty(allocs)
    end

    @testset "findfirstsortedequal" begin
        # Int64 vector (binary search + SIMD)
        allocs = check_allocs(FindFirstFunctions.findfirstsortedequal, (Int64, Vector{Int64}))
        @test isempty(allocs)
    end

    @testset "bracketstrictlymontonic" begin
        # Int64 vector with Forward ordering
        allocs = check_allocs(
            FindFirstFunctions.bracketstrictlymontonic,
            (Vector{Int64}, Int64, Int64, Base.Order.ForwardOrdering)
        )
        @test isempty(allocs)

        # Float64 vector with Forward ordering
        allocs = check_allocs(
            FindFirstFunctions.bracketstrictlymontonic,
            (Vector{Float64}, Float64, Int64, Base.Order.ForwardOrdering)
        )
        @test isempty(allocs)
    end

    @testset "looks_linear" begin
        # Float64 vector
        allocs = check_allocs(FindFirstFunctions.looks_linear, (Vector{Float64},))
        @test isempty(allocs)

        # Int64 vector
        allocs = check_allocs(FindFirstFunctions.looks_linear, (Vector{Int64},))
        @test isempty(allocs)
    end

    @testset "Guesser callable" begin
        # Test the Guesser callable with Float64 input
        # Note: We test a concrete Guesser type, not the constructor
        GuesserType = FindFirstFunctions.Guesser{Vector{Float64}}
        allocs = check_allocs(
            (g, x) -> g(x),
            (GuesserType, Float64)
        )
        @test isempty(allocs)
    end

    @testset "searchsortedfirstcorrelated" begin
        # Int64 vector with integer guess
        allocs = check_allocs(
            FindFirstFunctions.searchsortedfirstcorrelated,
            (Vector{Int64}, Int64, Int64)
        )
        @test isempty(allocs)

        # Float64 vector with integer guess
        allocs = check_allocs(
            FindFirstFunctions.searchsortedfirstcorrelated,
            (Vector{Float64}, Float64, Int64)
        )
        @test isempty(allocs)
    end

    @testset "searchsortedlastcorrelated" begin
        # Int64 vector with integer guess
        allocs = check_allocs(
            FindFirstFunctions.searchsortedlastcorrelated,
            (Vector{Int64}, Int64, Int64)
        )
        @test isempty(allocs)

        # Float64 vector with integer guess
        allocs = check_allocs(
            FindFirstFunctions.searchsortedlastcorrelated,
            (Vector{Float64}, Float64, Int64)
        )
        @test isempty(allocs)
    end

    @testset "searchsortedfirstexp" begin
        # Int64 vector
        allocs = check_allocs(
            FindFirstFunctions.searchsortedfirstexp,
            (Vector{Int64}, Int64, Int64, Int64)
        )
        @test isempty(allocs)

        # Float64 vector
        allocs = check_allocs(
            FindFirstFunctions.searchsortedfirstexp,
            (Vector{Float64}, Float64, Int64, Int64)
        )
        @test isempty(allocs)
    end
end

using Pkg
using SafeTestsets, Test

const GROUP = get(ENV, "GROUP", "All")

function activate_qa_env()
    Pkg.activate("qa")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    return Pkg.instantiate()
end

@testset "FindFirstFunctions" begin
    if GROUP == "All" || GROUP == "Core"
        @safetestset "FindFirstFunctions.jl" begin
            using FindFirstFunctions
            for n in 0:128
                x = unique!(rand(Int, n))
                s = sort(x)
                for i in eachindex(x)
                    @test FindFirstFunctions.findfirstequal(x[i], x) == i
                    @test FindFirstFunctions.findfirstequal(s[i], s) == i
                    @test FindFirstFunctions.findfirstsortedequal(s[i], s) == i
                end
                if length(x) > 0
                    @test FindFirstFunctions.findfirstequal(x[begin], @view(x[begin:end])) === 1
                    @test FindFirstFunctions.findfirstequal(x[begin], @view(x[(begin + 1):end])) ===
                        nothing
                    @test FindFirstFunctions.findfirstequal(x[end], @view(x[begin:(end - 1)])) ===
                        nothing
                end
                y = rand(Int)
                ff = findfirst(==(y), x)
                @test FindFirstFunctions.findfirstequal(y, x) === ff
                ff === nothing &&
                    @test FindFirstFunctions.findfirstsortedequal(y, x) === nothing
            end
        end

        @safetestset "Guesser" begin
            using FindFirstFunctions:
                Guesser, searchsortedfirstcorrelated,
                searchsortedlastcorrelated
            v = collect(LinRange(0, 10, 4))
            guesser_linear = Guesser(v)
            guesser_prev = Guesser(v, Ref(1), false)
            @test guesser_linear.linear_lookup
            @test searchsortedfirstcorrelated(v, 4.0, guesser_linear) == 3
            @test searchsortedfirstcorrelated(v, 1.4234326478e24, guesser_linear) == 5
            @test searchsortedlastcorrelated(v, 4.0, guesser_prev) == 2
            @test guesser_prev.idx_prev[] == 2

            # Edge case
            v1 = [42.0]
            guesser = Guesser(v1)
            @test guesser_linear.linear_lookup
            @test guesser(100) == 1
            @test guesser(42.0) == 1
            @test guesser(0) == 1
            @test searchsortedfirstcorrelated(v1, 0, guesser) == 1
            @test searchsortedfirstcorrelated(v1, 100, guesser) == 1 + 1  # see searchsortedfirst
            @test searchsortedfirstcorrelated(v1, 42.0, guesser) == 1
            @test searchsortedlastcorrelated(v1, 0, guesser) == 1 - 1 # see searchsortedlast
            @test searchsortedlastcorrelated(v1, 100, guesser) == 1
            @test searchsortedlastcorrelated(v1, 42.0, guesser) == 1
        end

        @safetestset "Custom ordering in searchsorted*correlated" begin
            using FindFirstFunctions:
                Guesser, searchsortedfirstcorrelated,
                searchsortedlastcorrelated

            # Test with reverse-sorted vector
            v_rev = collect(10.0:-1.0:1.0)  # [10.0, 9.0, ..., 1.0]

            # Test searchsortedfirstcorrelated with Reverse order
            @test searchsortedfirstcorrelated(v_rev, 5.0, 1; order = Base.Order.Reverse) ==
                searchsortedfirst(v_rev, 5.0, Base.Order.Reverse)
            @test searchsortedfirstcorrelated(v_rev, 10.0, 1; order = Base.Order.Reverse) ==
                searchsortedfirst(v_rev, 10.0, Base.Order.Reverse)
            @test searchsortedfirstcorrelated(v_rev, 1.0, 1; order = Base.Order.Reverse) ==
                searchsortedfirst(v_rev, 1.0, Base.Order.Reverse)
            @test searchsortedfirstcorrelated(v_rev, 0.0, 1; order = Base.Order.Reverse) ==
                searchsortedfirst(v_rev, 0.0, Base.Order.Reverse)
            @test searchsortedfirstcorrelated(v_rev, 11.0, 1; order = Base.Order.Reverse) ==
                searchsortedfirst(v_rev, 11.0, Base.Order.Reverse)

            # Test searchsortedlastcorrelated with Reverse order
            @test searchsortedlastcorrelated(v_rev, 5.0, 1; order = Base.Order.Reverse) ==
                searchsortedlast(v_rev, 5.0, Base.Order.Reverse)
            @test searchsortedlastcorrelated(v_rev, 10.0, 1; order = Base.Order.Reverse) ==
                searchsortedlast(v_rev, 10.0, Base.Order.Reverse)
            @test searchsortedlastcorrelated(v_rev, 1.0, 1; order = Base.Order.Reverse) ==
                searchsortedlast(v_rev, 1.0, Base.Order.Reverse)
            @test searchsortedlastcorrelated(v_rev, 0.0, 1; order = Base.Order.Reverse) ==
                searchsortedlast(v_rev, 0.0, Base.Order.Reverse)
            @test searchsortedlastcorrelated(v_rev, 11.0, 1; order = Base.Order.Reverse) ==
                searchsortedlast(v_rev, 11.0, Base.Order.Reverse)

            # Test with Guesser and reverse order
            guesser_rev = Guesser(v_rev)
            @test searchsortedfirstcorrelated(v_rev, 5.0, guesser_rev; order = Base.Order.Reverse) ==
                searchsortedfirst(v_rev, 5.0, Base.Order.Reverse)
            @test searchsortedlastcorrelated(v_rev, 5.0, guesser_rev; order = Base.Order.Reverse) ==
                searchsortedlast(v_rev, 5.0, Base.Order.Reverse)

            # Test that default order (Forward) still works correctly
            v_fwd = collect(1.0:1.0:10.0)  # [1.0, 2.0, ..., 10.0]
            @test searchsortedfirstcorrelated(v_fwd, 5.0, 1) ==
                searchsortedfirst(v_fwd, 5.0)
            @test searchsortedlastcorrelated(v_fwd, 5.0, 1) ==
                searchsortedlast(v_fwd, 5.0)
        end

        @safetestset "Exponential Search (searchsortedfirstexp)" begin
            using FindFirstFunctions: searchsortedfirstexp

            # Basic functionality - should match searchsortedfirst
            v = collect(1:100)
            for x in [1, 5, 10, 50, 99, 100]
                @test searchsortedfirstexp(v, x) == searchsortedfirst(v, x)
            end

            # Edge cases - value not in array
            @test searchsortedfirstexp(v, 0) == searchsortedfirst(v, 0)
            @test searchsortedfirstexp(v, 101) == searchsortedfirst(v, 101)
            @test searchsortedfirstexp(v, 50.5) == searchsortedfirst(v, 50.5)

            # With custom bounds
            @test searchsortedfirstexp(v, 50, 40, 60) == searchsortedfirst(v, 50, 40, 60, Base.Order.Forward)
            @test searchsortedfirstexp(v, 45, 40, 60) == searchsortedfirst(v, 45, 40, 60, Base.Order.Forward)

            # Float vectors
            vf = collect(0.0:0.1:10.0)
            for x in [0.0, 0.5, 1.0, 5.0, 9.9, 10.0]
                @test searchsortedfirstexp(vf, x) == searchsortedfirst(vf, x)
            end

            # Empty and small vectors
            @test searchsortedfirstexp(Int[], 5) == 1
            @test searchsortedfirstexp([1], 0) == 1
            @test searchsortedfirstexp([1], 1) == 1
            @test searchsortedfirstexp([1], 2) == 2

            # Vector with repeated elements
            vr = [1, 2, 2, 2, 3, 4, 5]
            @test searchsortedfirstexp(vr, 2) == searchsortedfirst(vr, 2)

            # Large vector
            big_v = collect(1:10000)
            for x in [1, 100, 1000, 5000, 9999, 10000]
                @test searchsortedfirstexp(big_v, x) == searchsortedfirst(big_v, x)
            end
        end

        @safetestset "Vectorized Search (searchsortedfirstvec and searchsortedlastvec)" begin
            using FindFirstFunctions: searchsortedfirstvec, searchsortedlastvec

            # Basic functionality
            v = collect(1:100)
            x_sorted = [5, 10, 20, 50, 90]

            # searchsortedfirstvec should match element-wise searchsortedfirst
            result_first = searchsortedfirstvec(v, x_sorted)
            expected_first = searchsortedfirst.(Ref(v), x_sorted)
            @test result_first == expected_first

            # searchsortedlastvec should match element-wise searchsortedlast
            result_last = searchsortedlastvec(v, x_sorted)
            expected_last = searchsortedlast.(Ref(v), x_sorted)
            @test result_last == expected_last

            # Unsorted input falls back to element-wise
            x_unsorted = [50, 10, 90, 5, 20]
            @test searchsortedfirstvec(v, x_unsorted) == searchsortedfirst.(Ref(v), x_unsorted)
            @test searchsortedlastvec(v, x_unsorted) == searchsortedlast.(Ref(v), x_unsorted)

            # Float vectors
            vf = collect(0.0:0.1:10.0)
            xf_sorted = [0.5, 1.0, 2.5, 5.0, 9.5]
            @test searchsortedfirstvec(vf, xf_sorted) == searchsortedfirst.(Ref(vf), xf_sorted)
            @test searchsortedlastvec(vf, xf_sorted) == searchsortedlast.(Ref(vf), xf_sorted)

            # Edge cases - values outside range
            x_edges = [-5, 0, 1, 100, 150]
            @test searchsortedfirstvec(v, x_edges) == searchsortedfirst.(Ref(v), x_edges)
            @test searchsortedlastvec(v, x_edges) == searchsortedlast.(Ref(v), x_edges)

            # Empty input vector
            @test searchsortedfirstvec(v, Int[]) == Int[]
            @test searchsortedlastvec(v, Int[]) == Int[]

            # Single element search
            @test searchsortedfirstvec(v, [50]) == [50]
            @test searchsortedlastvec(v, [50]) == [50]

            # Values between grid points
            x_between = [1.5, 10.5, 50.5, 99.5]
            @test searchsortedfirstvec(v, x_between) == searchsortedfirst.(Ref(v), x_between)
            @test searchsortedlastvec(v, x_between) == searchsortedlast.(Ref(v), x_between)
        end
    end

    if GROUP == "QA"
        activate_qa_env()
        @safetestset "Quality Assurance" include("qa/qa_tests.jl")
    end
end

using Documenter, FindFirstFunctions

cp(joinpath(@__DIR__, "Manifest.toml"), joinpath(@__DIR__, "src/assets/Manifest.toml"), force = true)
cp(joinpath(@__DIR__, "Project.toml"), joinpath(@__DIR__, "src/assets/Project.toml"), force = true)

ENV["GKSwstype"] = "100"

makedocs(
    modules = [FindFirstFunctions],
    sitename = "FindFirstFunctions.jl",
    clean = true,
    doctest = false,
    linkcheck = true,
    format = Documenter.HTML(
        assets = ["assets/favicon.ico"],
        canonical = "https://docs.sciml.ai/FindFirstFunctions/stable/"
    ),
    pages = [
        "Home" => "index.md",
        "Interface and extension rules" => "interface.md",
        "Search strategies" => "strategies.md",
        "Guessers" => "guessers.md",
        "Auto: heuristics and benchmarks" => "auto.md",
        "Equality search" => "equality.md",
    ]
)

deploydocs(repo = "github.com/SciML/FindFirstFunctions.jl"; push_preview = true)

# SIMD LLVM IR scaffolding shared by every "find first lane matching
# predicate" routine in the package:
#
#   - `FFE_IR` / `_findfirstequal`     — exact equality scan, Int64
#                                         (predicate `icmp eq`)
#   - `_SIMD_GT_I64_IR` / `_simd_first_gt(::Int64, …)`     — `icmp sgt`
#   - `_SIMD_GE_I64_IR` / `_simd_first_ge(::Int64, …)`     — `icmp sge`
#   - `_SIMD_GT_F64_IR` / `_simd_first_gt(::Float64, …)`   — `fcmp ogt`
#   - `_SIMD_GE_F64_IR` / `_simd_first_ge(::Float64, …)`   — `fcmp oge`
#
# All five IR strings are generated from the same template, keyed on scalar
# LLVM type (`i64`, `double`) and compare predicate. Adding a new predicate
# is a single `_simd_scan_ir(t, pred)` call plus a corresponding
# `Base.llvmcall` wrapper.

# Generate the SIMD "find first lane matching predicate" IR for an arbitrary
# scalar type and LLVM compare predicate. Load 8 lanes at a time, compare
# against a broadcast of the search value, bitcast the i1×8 mask to i8,
# `cttz` to find the first set bit. The tail past the last full chunk is
# handled scalar-wise.
function _simd_scan_ir(t, pred)
    cmp = pred[1] in ('o', 'u') ? "fcmp" : "icmp"
    return """
    declare i8 @llvm.cttz.i8(i8, i1);
    define i64 @entry($t %0, $(USE_PTR ? "ptr" : "i64") %1, i64 %2) #0 {
    top:
      $(USE_PTR ? "" : "%ivars = inttoptr i64 %1 to $t*")
      %btmp = insertelement <8 x $t> undef, $t %0, i64 0
      %var = shufflevector <8 x $t> %btmp, <8 x $t> undef, <8 x i32> zeroinitializer
      %lenm7 = add nsw i64 %2, -7
      %dosimditer = icmp ugt i64 %2, 7
      br i1 %dosimditer, label %L9.lr.ph, label %L32

    L9.lr.ph:
      %len8 = and i64 %2, 9223372036854775800
      br label %L9

    L9:
      %i = phi i64 [ 0, %L9.lr.ph ], [ %vinc, %L30 ]
      %ivarsi = getelementptr inbounds $t, $(USE_PTR ? "ptr %1" : "$t* %ivars"), i64 %i
      $(USE_PTR ? "" : "%vpvi = bitcast $t* %ivarsi to <8 x $t>*")
      %v = load <8 x $t>, $(USE_PTR ? "ptr %ivarsi" : "<8 x $t> * %vpvi"), align 8
      %m = $cmp $pred <8 x $t> %v, %var
      %mu = bitcast <8 x i1> %m to i8
      %matchnotfound = icmp eq i8 %mu, 0
      br i1 %matchnotfound, label %L30, label %L17

    L17:
      %tz8 = call i8 @llvm.cttz.i8(i8 %mu, i1 true)
      %tz64 = zext i8 %tz8 to i64
      %vis = add nuw i64 %i, %tz64
      br label %common.ret

    common.ret:
      %retval = phi i64 [ %vis, %L17 ], [ -1, %L32 ], [ %si, %L51 ], [ -1, %L67 ]
      ret i64 %retval

    L30:
      %vinc = add nuw nsw i64 %i, 8
      %continue = icmp slt i64 %vinc, %lenm7
      br i1 %continue, label %L9, label %L32

    L32:
      %cumi = phi i64 [ 0, %top ], [ %len8, %L30 ]
      %done = icmp eq i64 %cumi, %2
      br i1 %done, label %common.ret, label %L51

    L51:
      %si = phi i64 [ %inc, %L67 ], [ %cumi, %L32 ]
      %spi = getelementptr inbounds $t, $(USE_PTR ? "ptr %1" : "$t* %ivars"), i64 %si
      %svi = load $t, $(USE_PTR ? "ptr" : "$t*") %spi, align 8
      %match = $cmp $pred $t %svi, %0
      br i1 %match, label %common.ret, label %L67

    L67:
      %inc = add i64 %si, 1
      %dobreak = icmp eq i64 %inc, %2
      br i1 %dobreak, label %common.ret, label %L51

    }
    attributes #0 = { alwaysinline }
    """
end

# Portable scalar implementation of the primitives' contract: the 0-based
# offset of the first element with `pred(v[i], x)`, or -1 if there is none.
# Backs the primitives on non-64-bit platforms, where the SIMD kernels
# (64-bit lengths and pointer lowering) are unavailable.
function _scalar_first(pred::P, x::T, ptr::Ptr{T}, len::Int64) where {P, T}
    for i in 1:len
        pred(unsafe_load(ptr, i), x) && return i - 1
    end
    return Int64(-1)
end

@static if Sys.WORD_SIZE == 64

    const FFE_IR = _simd_scan_ir("i64", "eq")

    function _findfirstequal(vpivot::Int64, ptr::Ptr{Int64}, len::Int64)
        return Base.llvmcall(
            (FFE_IR, "entry"),
            Int64,
            Tuple{Int64, Ptr{Int64}, Int64},
            vpivot,
            ptr,
            len
        )
    end

    const _SIMD_GT_I64_IR = _simd_scan_ir("i64", "sgt")
    const _SIMD_GE_I64_IR = _simd_scan_ir("i64", "sge")
    const _SIMD_GT_F64_IR = _simd_scan_ir("double", "ogt")
    const _SIMD_GE_F64_IR = _simd_scan_ir("double", "oge")

    # Reverse-direction predicates: used by `SIMDLinearScan` under
    # `Base.Order.Reverse` ordering, where the array is decreasing and we want
    # to find the first lane where `v[i] < x` (searchsortedlast) or `v[i] <= x`
    # (searchsortedfirst).
    const _SIMD_LT_I64_IR = _simd_scan_ir("i64", "slt")
    const _SIMD_LE_I64_IR = _simd_scan_ir("i64", "sle")
    const _SIMD_LT_F64_IR = _simd_scan_ir("double", "olt")
    const _SIMD_LE_F64_IR = _simd_scan_ir("double", "ole")

    # Backing primitives for SIMDLinearScan. Each returns the 0-based offset of
    # the first lane satisfying the predicate, or -1 if none. Caveat: NaN inputs
    # always compare false under the ordered `o*` float predicates, so NaN in `v`
    # or `x` produces "no match" rather than an exception — consistent with the
    # undefined-input contract for sorted Float64 vectors containing NaN.
    function _simd_first_gt(x::Int64, ptr::Ptr{Int64}, len::Int64)
        return Base.llvmcall(
            (_SIMD_GT_I64_IR, "entry"),
            Int64, Tuple{Int64, Ptr{Int64}, Int64},
            x, ptr, len
        )
    end
    function _simd_first_ge(x::Int64, ptr::Ptr{Int64}, len::Int64)
        return Base.llvmcall(
            (_SIMD_GE_I64_IR, "entry"),
            Int64, Tuple{Int64, Ptr{Int64}, Int64},
            x, ptr, len
        )
    end
    function _simd_first_gt(x::Float64, ptr::Ptr{Float64}, len::Int64)
        return Base.llvmcall(
            (_SIMD_GT_F64_IR, "entry"),
            Int64, Tuple{Float64, Ptr{Float64}, Int64},
            x, ptr, len
        )
    end
    function _simd_first_ge(x::Float64, ptr::Ptr{Float64}, len::Int64)
        return Base.llvmcall(
            (_SIMD_GE_F64_IR, "entry"),
            Int64, Tuple{Float64, Ptr{Float64}, Int64},
            x, ptr, len
        )
    end

    # Reverse-direction primitives.
    function _simd_first_lt(x::Int64, ptr::Ptr{Int64}, len::Int64)
        return Base.llvmcall(
            (_SIMD_LT_I64_IR, "entry"),
            Int64, Tuple{Int64, Ptr{Int64}, Int64},
            x, ptr, len
        )
    end
    function _simd_first_le(x::Int64, ptr::Ptr{Int64}, len::Int64)
        return Base.llvmcall(
            (_SIMD_LE_I64_IR, "entry"),
            Int64, Tuple{Int64, Ptr{Int64}, Int64},
            x, ptr, len
        )
    end
    function _simd_first_lt(x::Float64, ptr::Ptr{Float64}, len::Int64)
        return Base.llvmcall(
            (_SIMD_LT_F64_IR, "entry"),
            Int64, Tuple{Float64, Ptr{Float64}, Int64},
            x, ptr, len
        )
    end
    function _simd_first_le(x::Float64, ptr::Ptr{Float64}, len::Int64)
        return Base.llvmcall(
            (_SIMD_LE_F64_IR, "entry"),
            Int64, Tuple{Float64, Ptr{Float64}, Int64},
            x, ptr, len
        )
    end

else

    _findfirstequal(vpivot::Int64, ptr::Ptr{Int64}, len::Int64) = _scalar_first(==, vpivot, ptr, len)
    _simd_first_gt(x::Int64, ptr::Ptr{Int64}, len::Int64) = _scalar_first(>, x, ptr, len)
    _simd_first_ge(x::Int64, ptr::Ptr{Int64}, len::Int64) = _scalar_first(>=, x, ptr, len)
    _simd_first_lt(x::Int64, ptr::Ptr{Int64}, len::Int64) = _scalar_first(<, x, ptr, len)
    _simd_first_le(x::Int64, ptr::Ptr{Int64}, len::Int64) = _scalar_first(<=, x, ptr, len)
    _simd_first_gt(x::Float64, ptr::Ptr{Float64}, len::Int64) = _scalar_first(>, x, ptr, len)
    _simd_first_ge(x::Float64, ptr::Ptr{Float64}, len::Int64) = _scalar_first(>=, x, ptr, len)
    _simd_first_lt(x::Float64, ptr::Ptr{Float64}, len::Int64) = _scalar_first(<, x, ptr, len)
    _simd_first_le(x::Float64, ptr::Ptr{Float64}, len::Int64) = _scalar_first(<=, x, ptr, len)

end

@safetestset "FindFirstFunctions.jl" begin
    using FindFirstFunctions
    for n in 0:128
        x = unique!(rand(Int, n))
        s = sort(x)
        for i in eachindex(x)
            @test FindFirstFunctions.findfirstequal(x[i], x) == i
            @test FindFirstFunctions.findfirstequal(s[i], s) == i
            @test FindFirstFunctions.findfirstsortedequal(s[i], s) == i
        end
        if length(x) > 0
            @test FindFirstFunctions.findfirstequal(x[begin], @view(x[begin:end])) === 1
            @test FindFirstFunctions.findfirstequal(x[begin], @view(x[(begin + 1):end])) ===
                nothing
            @test FindFirstFunctions.findfirstequal(x[end], @view(x[begin:(end - 1)])) ===
                nothing
        end
        y = rand(Int)
        ff = findfirst(==(y), x)
        @test FindFirstFunctions.findfirstequal(y, x) === ff
        ff === nothing &&
            @test FindFirstFunctions.findfirstsortedequal(y, x) === nothing
    end
end

@safetestset "Guesser" begin
    using FindFirstFunctions: Guesser, GuesserHint, searchsorted_last, searchsorted_first
    v = collect(LinRange(0, 10, 4))
    guesser_linear = Guesser(v)
    guesser_prev = Guesser(v, Ref(1), false)
    @test guesser_linear.linear_lookup

    # Guesser feeds the dispatched API via GuesserHint.
    @test searchsorted_first(GuesserHint(guesser_linear), v, 4.0) == 3
    @test searchsorted_first(GuesserHint(guesser_linear), v, 1.4234326478e24) == 5
    @test searchsorted_last(GuesserHint(guesser_prev), v, 4.0) == 2
    @test guesser_prev.idx_prev[] == 2

    # Edge case: single-element v.
    v1 = [42.0]
    guesser = Guesser(v1)
    @test guesser_linear.linear_lookup
    @test guesser(100) == 1
    @test guesser(42.0) == 1
    @test guesser(0) == 1
    @test searchsorted_first(GuesserHint(guesser), v1, 0) == 1
    @test searchsorted_first(GuesserHint(guesser), v1, 100) == 2  # see Base.searchsortedfirst
    @test searchsorted_first(GuesserHint(guesser), v1, 42.0) == 1
    @test searchsorted_last(GuesserHint(guesser), v1, 0) == 0  # see Base.searchsortedlast
    @test searchsorted_last(GuesserHint(guesser), v1, 100) == 1
    @test searchsorted_last(GuesserHint(guesser), v1, 42.0) == 1
end

@safetestset "Native reverse-order paths (issue #67)" begin
    using FindFirstFunctions, StableRNGs

    # ExpFromLeft, InterpolationSearch, SIMDLinearScan, and
    # BitInterpolationSearch all used to fall back to BinaryBracket
    # for `Base.Order.Reverse`. They now have native Reverse paths;
    # verify parity vs `Base.searchsorted*(v, x, Reverse)` across
    # eltypes and hint positions.

    rng = StableRNG(2027)
    order = Base.Order.Reverse

    @testset "Float64 reverse-sorted parity, m=200" begin
        # Decreasing sorted Float64 vector.
        v = sort!(randn(rng, 200); rev = true)
        for _ in 1:500
            x = (rand(rng) - 0.5) * 6
            hint = rand(rng, 1:length(v))
            expected_last = searchsortedlast(v, x, order)
            expected_first = searchsortedfirst(v, x, order)
            for strategy in (
                    BinaryBracket(), LinearScan(), SIMDLinearScan(),
                    BracketGallop(), ExpFromLeft(),
                    InterpolationSearch(), BitInterpolationSearch(),
                    Auto(),
                )
                @test searchsorted_last(strategy, v, x, hint; order = order) ==
                    expected_last
                @test searchsorted_first(strategy, v, x, hint; order = order) ==
                    expected_first
            end
        end
    end

    @testset "Int64 reverse-sorted parity, m=200" begin
        v = sort!(rand(rng, Int64(-100):Int64(100), 200); rev = true)
        for _ in 1:500
            x = rand(rng, Int64(-110):Int64(110))
            hint = rand(rng, 1:length(v))
            expected_last = searchsortedlast(v, x, order)
            expected_first = searchsortedfirst(v, x, order)
            for strategy in (
                    BinaryBracket(), LinearScan(), SIMDLinearScan(),
                    BracketGallop(), ExpFromLeft(),
                    InterpolationSearch(), Auto(),
                )
                @test searchsorted_last(strategy, v, x, hint; order = order) ==
                    expected_last
                @test searchsorted_first(strategy, v, x, hint; order = order) ==
                    expected_first
            end
        end
    end

    @testset "BitInterp reverse-sorted positive Float64" begin
        # Reverse log-spaced — exercises the bit-pattern Reverse path.
        v = sort!(collect(exp.(range(0.0, log(1.0e6); length = 1024))); rev = true)
        for _ in 1:200
            x = exp(rand(rng) * log(1.0e6))
            expected_last = searchsortedlast(v, x, order)
            expected_first = searchsortedfirst(v, x, order)
            @test searchsorted_last(
                BitInterpolationSearch(), v, x; order = order
            ) == expected_last
            @test searchsorted_first(
                BitInterpolationSearch(), v, x; order = order
            ) == expected_first
        end
        # Non-positive endpoint falls back to BinaryBracket cleanly.
        v_signed = sort!(randn(rng, 100); rev = true)
        for x in (-0.5, 0.0, 0.5, -2.0, 2.0)
            @test searchsorted_last(
                BitInterpolationSearch(), v_signed, x; order = order
            ) == searchsortedlast(v_signed, x, order)
        end
    end

    @testset "Edge cases under Reverse" begin
        # Out-of-range queries: x larger than first, smaller than last.
        v = collect(10.0:-0.5:1.0)
        # x > v[1] → searchsortedfirst returns 1, searchsortedlast returns 0.
        for strategy in (
                SIMDLinearScan(), ExpFromLeft(),
                InterpolationSearch(), BitInterpolationSearch(),
            )
            @test searchsorted_last(strategy, v, 100.0, 5; order = order) ==
                searchsortedlast(v, 100.0, order)
            @test searchsorted_last(strategy, v, -100.0, 5; order = order) ==
                searchsortedlast(v, -100.0, order)
            @test searchsorted_first(strategy, v, 100.0, 5; order = order) ==
                searchsortedfirst(v, 100.0, order)
            @test searchsorted_first(strategy, v, -100.0, 5; order = order) ==
                searchsortedfirst(v, -100.0, order)
        end
    end
end

@safetestset "UniformStep + Auto on AbstractRange (issue #7)" begin
    using FindFirstFunctions

    ranges_forward = (
        1:100,
        Int64(1):Int64(100),
        0:5:500,
        0.0:0.1:10.0,
        LinRange(0.0, 10.0, 101),
        LinRange(-5.0, 5.0, 50),
        Float32(0):Float32(0.5):Float32(20),
    )
    ranges_reverse = (
        100:-1:1,
        10.0:-0.1:0.0,
        LinRange(10.0, 0.0, 101),
        Float64(20):-Float64(0.5):Float64(0),
    )

    for r in ranges_forward
        for x in (
                first(r) - 1, first(r),
                first(r) + (last(r) - first(r)) / 2,
                last(r), last(r) + 1, 0,
            )
            @test searchsorted_last(UniformStep(), r, x) ==
                searchsortedlast(r, x)
            @test searchsorted_first(UniformStep(), r, x) ==
                searchsortedfirst(r, x)
            @test searchsorted_last(Auto(), r, x) == searchsortedlast(r, x)
            @test searchsorted_first(Auto(), r, x) == searchsortedfirst(r, x)
            h = max(1, length(r) ÷ 2)
            @test searchsorted_last(UniformStep(), r, x, h) ==
                searchsortedlast(r, x)
            @test searchsorted_first(UniformStep(), r, x, h) ==
                searchsortedfirst(r, x)
            @test searchsorted_last(Auto(), r, x, h) == searchsortedlast(r, x)
        end
    end

    for r in ranges_reverse
        order = Base.Order.Reverse
        for x in (
                first(r) + 1, first(r),
                (first(r) + last(r)) / 2,
                last(r), last(r) - 1, 0,
            )
            @test searchsorted_last(UniformStep(), r, x; order = order) ==
                searchsortedlast(r, x, order)
            @test searchsorted_first(UniformStep(), r, x; order = order) ==
                searchsortedfirst(r, x, order)
            @test searchsorted_last(Auto(), r, x; order = order) ==
                searchsortedlast(r, x, order)
            @test searchsorted_first(Auto(), r, x; order = order) ==
                searchsortedfirst(r, x, order)
        end
    end

    # Edge cases.
    r_empty = 1:0
    @test searchsorted_last(UniformStep(), r_empty, 5) == 0
    @test searchsorted_first(UniformStep(), r_empty, 5) == 1
    @test searchsorted_last(Auto(), r_empty, 5) == 0
    r_single = 42:42
    @test searchsorted_last(UniformStep(), r_single, 41) == 0
    @test searchsorted_last(UniformStep(), r_single, 42) == 1
    @test searchsorted_last(UniformStep(), r_single, 43) == 1
    @test searchsorted_first(UniformStep(), r_single, 41) == 1
    @test searchsorted_first(UniformStep(), r_single, 42) == 1
    @test searchsorted_first(UniformStep(), r_single, 43) == 2

    # Non-Range vector falls back to BinaryBracket.
    v = collect(0.0:0.1:10.0)
    for x in (-1.0, 0.0, 5.5, 10.0, 100.0)
        @test searchsorted_last(UniformStep(), v, x) == searchsortedlast(v, x)
        @test searchsorted_first(UniformStep(), v, x) == searchsortedfirst(v, x)
    end

    # Auto() answers match Base's range-aware overload and the call
    # is near-zero overhead: no heap traffic beyond Julia 1.10's
    # kwarg trampoline, which boxes the NamedTuple at exactly 64
    # bytes for the 32-byte `Auto{Float64}` argument (1.11 elides
    # the allocation entirely) — hence the `<= 64` bound below.
    r_big = 0.0:0.001:100.0
    @test searchsorted_last(Auto(), r_big, 50.5) == searchsortedlast(r_big, 50.5)
    @test searchsorted_first(Auto(), r_big, 50.5) ==
        searchsortedfirst(r_big, 50.5)
    # Warm up once, then verify allocation is tiny (kwarg trampoline only).
    searchsorted_last(Auto(), r_big, 50.5)
    @test @allocated(searchsorted_last(Auto(), r_big, 50.5)) <= 64
    @test @allocated(searchsorted_first(Auto(), r_big, 50.5)) <= 64

    # Batched path on AbstractRange.
    r = 0.0:0.5:100.0
    queries = sort!([5.3, 17.2, 42.9, 80.1, 99.5])
    out = Vector{Int}(undef, length(queries))
    searchsortedlast!(out, r, queries; strategy = Auto())
    @test out == searchsortedlast.(Ref(r), queries)
    searchsortedfirst!(out, r, queries; strategy = Auto())
    @test out == searchsortedfirst.(Ref(r), queries)
    unsorted_queries = [42.0, 5.0, 80.0, 17.0]
    out2 = Vector{Int}(undef, length(unsorted_queries))
    searchsortedlast!(out2, r, unsorted_queries; strategy = Auto())
    @test out2 == searchsortedlast.(Ref(r), unsorted_queries)
end

@safetestset "Custom ordering for strategy dispatch" begin
    using FindFirstFunctions:
        Guesser, GuesserHint, BracketGallop, LinearScan,
        ExpFromLeft, BinaryBracket, Auto, searchsorted_last, searchsorted_first

    v_rev = collect(10.0:-1.0:1.0)
    for x in (5.0, 10.0, 1.0, 0.0, 11.0),
            hint in (1, 5, 10),
            strategy in (
                BracketGallop(), LinearScan(), ExpFromLeft(), Auto(),
            )

        @test searchsorted_first(strategy, v_rev, x, hint; order = Base.Order.Reverse) ==
            searchsortedfirst(v_rev, x, Base.Order.Reverse)
        @test searchsorted_last(strategy, v_rev, x, hint; order = Base.Order.Reverse) ==
            searchsortedlast(v_rev, x, Base.Order.Reverse)
    end
    # BinaryBracket ignores any hint.
    for x in (5.0, 10.0, 1.0, 0.0, 11.0)
        @test searchsorted_first(BinaryBracket(), v_rev, x; order = Base.Order.Reverse) ==
            searchsortedfirst(v_rev, x, Base.Order.Reverse)
        @test searchsorted_last(BinaryBracket(), v_rev, x; order = Base.Order.Reverse) ==
            searchsortedlast(v_rev, x, Base.Order.Reverse)
    end

    # GuesserHint with reverse order.
    guesser_rev = Guesser(v_rev)
    @test searchsorted_first(GuesserHint(guesser_rev), v_rev, 5.0; order = Base.Order.Reverse) ==
        searchsortedfirst(v_rev, 5.0, Base.Order.Reverse)
    @test searchsorted_last(GuesserHint(guesser_rev), v_rev, 5.0; order = Base.Order.Reverse) ==
        searchsortedlast(v_rev, 5.0, Base.Order.Reverse)

    # Default (Forward) order still resolves correctly.
    v_fwd = collect(1.0:1.0:10.0)
    for strategy in (BracketGallop(), LinearScan(), ExpFromLeft(), Auto())
        @test searchsorted_first(strategy, v_fwd, 5.0, 1) == searchsortedfirst(v_fwd, 5.0)
        @test searchsorted_last(strategy, v_fwd, 5.0, 1) == searchsortedlast(v_fwd, 5.0)
    end
end

@safetestset "SearchStrategy dispatch (single query)" begin
    using FindFirstFunctions:
        SearchStrategy, LinearScan, BracketGallop, BinaryBracket, Auto,
        searchsorted_last, searchsorted_first

    for n in (0, 1, 2, 8, 33, 257)
        v = collect(1:n)
        isempty(v) && continue

        # Probe targets that include hits, misses, boundaries
        xs = unique!(sort!([0, 1, n ÷ 2, n, n + 1, -3, 2 * n + 1]))
        for x in xs
            expected_last = searchsortedlast(v, x)
            expected_first = searchsortedfirst(v, x)

            # BinaryBracket — ignores any hint
            @test searchsorted_last(BinaryBracket(), v, x) == expected_last
            @test searchsorted_first(BinaryBracket(), v, x) == expected_first
            @test searchsorted_last(BinaryBracket(), v, x, 1) == expected_last
            @test searchsorted_first(BinaryBracket(), v, x, 1) == expected_first

            # Strategy with hint anywhere in 1..n agrees with Base
            for h in unique!([1, max(1, n ÷ 4), n ÷ 2, max(1, 3n ÷ 4), n])
                @test searchsorted_last(LinearScan(), v, x, h) == expected_last
                @test searchsorted_first(LinearScan(), v, x, h) == expected_first
                @test searchsorted_last(BracketGallop(), v, x, h) == expected_last
                @test searchsorted_first(BracketGallop(), v, x, h) == expected_first
                @test searchsorted_last(Auto(), v, x, h) == expected_last
                @test searchsorted_first(Auto(), v, x, h) == expected_first
            end

            # No-hint forms fall back to BinaryBracket
            @test searchsorted_last(LinearScan(), v, x) == expected_last
            @test searchsorted_first(LinearScan(), v, x) == expected_first
            @test searchsorted_last(BracketGallop(), v, x) == expected_last
            @test searchsorted_first(BracketGallop(), v, x) == expected_first
            @test searchsorted_last(Auto(), v, x) == expected_last
            @test searchsorted_first(Auto(), v, x) == expected_first

            # Out-of-range hint → Auto falls back to BinaryBracket
            @test searchsorted_last(Auto(), v, x, 0) == expected_last
            @test searchsorted_first(Auto(), v, x, 0) == expected_first
            @test searchsorted_last(Auto(), v, x, n + 1) == expected_last
            @test searchsorted_first(Auto(), v, x, n + 1) == expected_first
        end
    end

    # Reverse order
    v_rev = collect(10.0:-1.0:1.0)
    for x in (0.5, 1.0, 5.0, 10.0, 11.0), h in (1, 5, 10)
        @test searchsorted_last(BracketGallop(), v_rev, x, h; order = Base.Order.Reverse) ==
            searchsortedlast(v_rev, x, Base.Order.Reverse)
        @test searchsorted_first(BracketGallop(), v_rev, x, h; order = Base.Order.Reverse) ==
            searchsortedfirst(v_rev, x, Base.Order.Reverse)
        @test searchsorted_last(LinearScan(), v_rev, x, h; order = Base.Order.Reverse) ==
            searchsortedlast(v_rev, x, Base.Order.Reverse)
        @test searchsorted_first(LinearScan(), v_rev, x, h; order = Base.Order.Reverse) ==
            searchsortedfirst(v_rev, x, Base.Order.Reverse)
        @test searchsorted_last(Auto(), v_rev, x, h; order = Base.Order.Reverse) ==
            searchsortedlast(v_rev, x, Base.Order.Reverse)
        @test searchsorted_first(Auto(), v_rev, x, h; order = Base.Order.Reverse) ==
            searchsortedfirst(v_rev, x, Base.Order.Reverse)
    end

    # Strategy abstract type hierarchy
    @test LinearScan <: SearchStrategy
    @test BracketGallop <: SearchStrategy
    @test BinaryBracket <: SearchStrategy
    @test Auto <: SearchStrategy
end

@safetestset "ExpFromLeft and InterpolationSearch" begin
    using FindFirstFunctions:
        ExpFromLeft, InterpolationSearch, BinaryBracket,
        searchsorted_last, searchsorted_first

    # ExpFromLeft on uniform Int range
    v = collect(1:1000)
    for x in (0, 1, 50, 250, 500, 999, 1000, 1001), h in (1, 50, 500, 1000)
        @test searchsorted_last(ExpFromLeft(), v, x, h) ==
            searchsortedlast(v, x)
        @test searchsorted_first(ExpFromLeft(), v, x, h) ==
            searchsortedfirst(v, x)
    end
    # ExpFromLeft without hint falls back to BinaryBracket
    @test searchsorted_last(ExpFromLeft(), v, 500) == searchsortedlast(v, 500)
    @test searchsorted_first(ExpFromLeft(), v, 500) == searchsortedfirst(v, 500)

    # InterpolationSearch on uniform Float64 range
    vf = collect(0.0:0.1:10.0)
    for x in (-1.0, 0.0, 0.05, 1.0, 5.5, 9.95, 10.0, 11.0)
        @test searchsorted_last(InterpolationSearch(), vf, x) ==
            searchsortedlast(vf, x)
        @test searchsorted_first(InterpolationSearch(), vf, x) ==
            searchsortedfirst(vf, x)
    end

    # InterpolationSearch on log-spaced (non-uniform) — must still be correct
    vlog = exp.(range(log(0.1), log(100.0); length = 256))
    for x in (0.05, 0.1, 1.0, 50.0, 100.0, 150.0)
        @test searchsorted_last(InterpolationSearch(), vlog, x) ==
            searchsortedlast(vlog, x)
        @test searchsorted_first(InterpolationSearch(), vlog, x) ==
            searchsortedfirst(vlog, x)
    end

    # InterpolationSearch ignores hint (computes its own guess)
    for h in (1, 100, 256)
        @test searchsorted_last(InterpolationSearch(), vlog, 50.0, h) ==
            searchsortedlast(vlog, 50.0)
    end

    # InterpolationSearch falls back to BinaryBracket on non-Number eltypes
    vs = ["a", "b", "c", "d"]
    @test searchsorted_last(InterpolationSearch(), vs, "c") ==
        searchsortedlast(vs, "c")
    @test searchsorted_first(InterpolationSearch(), vs, "c", 2) ==
        searchsortedfirst(vs, "c")

    # InterpolationSearch on a constant vector (span=0) shouldn't divide
    # by zero; should fall through to a bounded search and return a
    # correct result.
    vc = fill(3.0, 16)
    @test searchsorted_last(InterpolationSearch(), vc, 3.0) ==
        searchsortedlast(vc, 3.0)
    @test searchsorted_last(InterpolationSearch(), vc, 2.0) ==
        searchsortedlast(vc, 2.0)
    @test searchsorted_last(InterpolationSearch(), vc, 4.0) ==
        searchsortedlast(vc, 4.0)

    # Edge: 1-element and 2-element vectors
    @test searchsorted_last(ExpFromLeft(), [5], 4, 1) == 0
    @test searchsorted_last(ExpFromLeft(), [5], 5, 1) == 1
    @test searchsorted_last(ExpFromLeft(), [5], 6, 1) == 1
    @test searchsorted_first(ExpFromLeft(), [5, 10], 7, 1) == 2
    @test searchsorted_last(InterpolationSearch(), [5], 4) == 0
    @test searchsorted_last(InterpolationSearch(), [5, 10], 7) == 1
end

@safetestset "Batched Auto heuristic" begin
    using FindFirstFunctions:
        Auto, LinearScan, ExpFromLeft, BracketGallop, BinaryBracket,
        searchsortedlast!
    using StableRNGs

    # Dense queries: Auto's avg-gap heuristic should land on LinearScan
    # (verified by output correctness, not by introspecting the picked
    # strategy — that's an implementation detail).
    v = collect(0.0:0.01:10.0)   # n=1001
    tt_dense = sort!(rand(StableRNG(1), 4096) .* 10.0)
    out_auto = Vector{Int}(undef, length(tt_dense))
    out_linear = Vector{Int}(undef, length(tt_dense))
    searchsortedlast!(out_auto, v, tt_dense; strategy = Auto())
    searchsortedlast!(out_linear, v, tt_dense; strategy = LinearScan())
    @test out_auto == out_linear

    # Sparse queries on a long vector: same correctness check.
    v_long = collect(0.0:0.001:100.0)  # n=100001
    tt_sparse = sort!(rand(StableRNG(2), 10) .* 100.0)
    out_a = Vector{Int}(undef, length(tt_sparse))
    out_e = Vector{Int}(undef, length(tt_sparse))
    searchsortedlast!(out_a, v_long, tt_sparse; strategy = Auto())
    searchsortedlast!(out_e, v_long, tt_sparse; strategy = ExpFromLeft())
    @test out_a == out_e

    # Dense burst — queries clustered inside one segment of v.
    # The span-based gap detection should send Auto to LinearScan.
    seg_lo = v[length(v) ÷ 2]
    seg_hi = v[length(v) ÷ 2 + 1]
    tt_burst = sort!(seg_lo .+ (seg_hi - seg_lo) .* rand(StableRNG(3), 2048))
    out_b = Vector{Int}(undef, length(tt_burst))
    out_l = Vector{Int}(undef, length(tt_burst))
    searchsortedlast!(out_b, v, tt_burst; strategy = Auto())
    searchsortedlast!(out_l, v, tt_burst; strategy = LinearScan())
    @test out_b == out_l

    # m=1 fast path — bypass span heuristic
    out1 = Vector{Int}(undef, 1)
    searchsortedlast!(out1, v, [5.123]; strategy = Auto())
    @test out1[1] == searchsortedlast(v, 5.123)

    # m=0 returns the output untouched (empty vector)
    empty_out = Int[]
    @test searchsortedlast!(empty_out, v, Float64[]; strategy = Auto()) === empty_out
    @test isempty(empty_out)

    # Non-numeric eltype: span heuristic falls back to length-ratio.
    vs = ["a", "b", "c", "d", "e", "f", "g", "h"]
    qs = ["b", "d", "f"]
    outs = Vector{Int}(undef, length(qs))
    searchsortedlast!(outs, vs, qs; strategy = Auto())
    @test outs == searchsortedlast.(Ref(vs), qs)
end

@safetestset "SearchProperties cache" begin
    using FindFirstFunctions:
        Auto, SearchProperties, searchsortedlast!, searchsortedfirst!
    using StableRNGs

    # The sentinel struct.
    @test !SearchProperties().has_props

    # A populated SearchProperties from a linear, NaN-free vector.
    v = collect(0.0:0.001:100.0)
    props = SearchProperties(v)
    @test props.has_props
    @test props.is_linear
    @test !props.has_nan

    # Output equivalence: Auto(props) returns the same answers as Auto()
    # on a sparse-on-long-linear regime (where InterpolationSearch is
    # the picked strategy via the cached `is_linear`).
    tt = sort!(rand(StableRNG(10), 16) .* 100.0)
    out_cached = Vector{Int}(undef, length(tt))
    out_baseline = Vector{Int}(undef, length(tt))
    out_truth = searchsortedlast.(Ref(v), tt)
    searchsortedlast!(out_cached, v, tt; strategy = Auto(props))
    searchsortedlast!(out_baseline, v, tt; strategy = Auto())
    @test out_cached == out_truth
    @test out_baseline == out_truth

    # searchsortedfirst path takes the same branch.
    searchsortedfirst!(out_cached, v, tt; strategy = Auto(props))
    searchsortedfirst!(out_baseline, v, tt; strategy = Auto())
    @test out_cached == searchsortedfirst.(Ref(v), tt)
    @test out_baseline == searchsortedfirst.(Ref(v), tt)

    # Float vector with a NaN: props.has_nan is true. The cache
    # currently isn't consumed for has_nan in Auto's decision tree,
    # but the field is populated correctly.
    vnan = [1.0, 2.0, NaN, 4.0, 5.0]
    propsnan = SearchProperties(vnan)
    @test propsnan.has_nan

    # Non-float eltype: has_nan is always false.
    vi = collect(Int64, 1:100)
    @test !SearchProperties(vi).has_nan

    # Lying SearchProperties (claims is_linear=true on non-linear data)
    # is still correctness-preserving — Auto's "InterpolationSearch on
    # linear data" branch handles the false positive gracefully
    # because InterpolationSearch's bad guess just makes BracketGallop
    # wider, never incorrect.
    v_log = exp.(range(0.0, 10.0; length = 4096))
    lying = SearchProperties{Float64}(true, true, false, false, false, 0.0, 0.0)
    tt_log = sort!(rand(StableRNG(11), 8) .* (v_log[end] - v_log[1]) .+ v_log[1])
    out_lying = Vector{Int}(undef, length(tt_log))
    searchsortedlast!(out_lying, v_log, tt_log; strategy = Auto(lying))
    @test out_lying == searchsortedlast.(Ref(v_log), tt_log)

    # Bits-ness: SearchProperties{T} must be isbits so it doesn't allocate.
    @test isbitstype(SearchProperties{Float64})
    @test isbitstype(SearchProperties{Float32})

    # is_log_linear field: populated by SearchProperties(v) on
    # geometric data, rejected on linear / two-scale data.
    v_log = collect(exp.(range(0.0, log(1.0e6); length = 65536)))
    p_log = SearchProperties(v_log)
    @test p_log.is_log_linear

    v_lin = collect(0.0:0.001:65.0)
    p_lin = SearchProperties(v_lin)
    @test !p_lin.is_log_linear

    # Two-scale data should fail both linearity probes.
    v_2s = sort!(vcat(range(0.0, 1.0; length = 32768), range(1.0, 100.0; length = 32768)))
    p_2s = SearchProperties(v_2s)
    @test !p_2s.is_log_linear

    # is_log_linear requires strictly positive v; mixed-sign rejects.
    v_signed = collect(-100.0:0.001:65.0)
    p_signed = SearchProperties(v_signed)
    @test !p_signed.is_log_linear

    # is_uniform: detected for any uniformly-spaced vector. The
    # 9-point linearity probe at a tight 1e-12 tolerance flags
    # exact uniformity (a few ulp of accumulated float roundoff).
    # AbstractRange short-circuits to true with no probe.
    @test SearchProperties(1:100).is_uniform                      # range
    @test SearchProperties(0.0:0.1:10.0).is_uniform               # StepRangeLen
    @test SearchProperties(LinRange(0.0, 10.0, 100)).is_uniform   # LinRange
    @test SearchProperties(collect(1:100)).is_uniform             # uniform Vector
    @test SearchProperties(collect(0.0:0.1:10.0)).is_uniform      # uniform Vector
    # Non-uniform vectors are rejected.
    v_log_collected = collect(exp.(range(0.0, log(1.0e6); length = 100)))
    @test !SearchProperties(v_log_collected).is_uniform
    v_random = sort!(rand(StableRNG(42), 100))
    @test !SearchProperties(v_random).is_uniform
    # Manual override: `is_uniform = false` forces rejection even
    # if the probe would accept; `is_uniform = true` accepts even
    # if the probe would reject.
    v_uniform_collected = collect(0.0:0.5:50.0)
    @test !SearchProperties(v_uniform_collected; is_uniform = false).is_uniform
    @test SearchProperties(v_log_collected; is_uniform = true).is_uniform
end

@safetestset "SearchProperties{T} parametric eltype" begin
    using FindFirstFunctions
    using FindFirstFunctions: SearchProperties, _ratio_type

    # Float64 vector / Float64 range → SearchProperties{Float64}.
    @test SearchProperties(collect(0.0:0.1:10.0)) isa SearchProperties{Float64}
    @test SearchProperties(0.0:0.1:10.0) isa SearchProperties{Float64}
    @test SearchProperties(LinRange(0.0, 10.0, 101)) isa SearchProperties{Float64}

    # Float32 vector / range → SearchProperties{Float32}.
    @test SearchProperties(collect(Float32(0):Float32(0.1):Float32(10))) isa
        SearchProperties{Float32}
    @test SearchProperties(Float32(0):Float32(0.1):Float32(10)) isa
        SearchProperties{Float32}
    @test SearchProperties(LinRange(Float32(0), Float32(10), 101)) isa
        SearchProperties{Float32}

    # Int vector / range → SearchProperties{Float64} (ratio promotes).
    @test SearchProperties(collect(1:100)) isa SearchProperties{Float64}
    @test SearchProperties(1:100) isa SearchProperties{Float64}
    @test _ratio_type(Int) === Float64
    @test _ratio_type(Float64) === Float64
    @test _ratio_type(Float32) === Float32

    # Non-numeric eltype → SearchProperties{Float64} sentinel,
    # has_props = false.
    ps = SearchProperties(["a", "b", "c"])
    @test ps isa SearchProperties{Float64}
    @test !ps.has_props
    @test !ps.is_uniform
    @test ps.first_val == 0.0
    @test ps.inv_step == 0.0

    # Default sentinel.
    @test SearchProperties() isa SearchProperties{Float64}
    @test !SearchProperties().has_props

    # first_val / inv_step are populated when is_uniform = true.
    p = SearchProperties(0.0:0.5:10.0)
    @test p.first_val == 0.0
    @test p.inv_step == 2.0    # 1/0.5

    # Vector path matches range path on uniform data.
    v = collect(0.0:0.5:10.0)
    p_v = SearchProperties(v)
    @test p_v.first_val == 0.0
    @test p_v.inv_step ≈ 2.0   # (n-1)/(v[end]-v[1]) = 20/10 = 2

    # Non-uniform vector: first_val / inv_step are zero.
    p_nonuniform = SearchProperties(sort!(rand(100)))
    @test !p_nonuniform.is_uniform
    @test p_nonuniform.first_val == 0.0
    @test p_nonuniform.inv_step == 0.0
end

@safetestset "SearchProperties with ForwardDiff.Dual knots" begin
    using FindFirstFunctions
    using FindFirstFunctions: SearchProperties, Auto, searchsorted_last, searchsorted_first
    using ForwardDiff

    # `ForwardDiff.Dual <: Real`, so a Dual-valued knot vector — as produced
    # when an interpolation is reconstructed inside `ForwardDiff` and the
    # knots are promoted to Duals — dispatches to the `<:Real` probe. The
    # probes must not force a `Float64(::Dual)` conversion (which errors);
    # they must classify from the primal values and keep partials intact.
    ForwardDiff.derivative(2.0) do p
        t = collect(range(0.0, 1.0; length = 15)) .* p    # linear Dual knots
        props = SearchProperties(t)
        @test props.has_props
        @test props.is_linear                              # linear in index
        @test props.is_uniform                             # evenly spaced
        # first_val / inv_step carry the derivative w.r.t. p.
        @test ForwardDiff.value(props.first_val) == 0.0
        # sum(t) = 7.5p, so d/dp = 7.5; exercise a value that depends on the
        # branch chosen from the probe result.
        props.is_linear ? sum(t) : 2 * sum(t)
    end == 7.5

    # Non-uniform Dual knots must probe without error and report not-uniform.
    ForwardDiff.derivative(3.0) do p
        t = (Float64[0, 1, 2, 4, 8, 16, 20, 21, 22, 40, 41, 100]) .* p
        props = SearchProperties(t)
        @test props.has_props
        @test !props.is_uniform
        sum(t)
    end

    # Full search path on uniform Dual knots exercises the closed-form
    # UniformStep kernel (`Auto` resolves to `KIND_UNIFORM_STEP`). It must
    # return the same index as `Base` on the primal values.
    ForwardDiff.derivative(2.0) do p
        t = collect(range(0.0, 10.0; length = 40)) .* p
        tv = map(ForwardDiff.value, t)
        auto = Auto(t)
        for q in (t[1], t[7], t[end], 5.0 * p, -1.0 * p, 11.0 * p)
            @test searchsorted_last(auto, t, q) == searchsortedlast(tv, ForwardDiff.value(q))
            @test searchsorted_first(auto, t, q) == searchsortedfirst(tv, ForwardDiff.value(q))
        end
        sum(t)
    end
end

@safetestset "Auto{T} parametric + props-aware UniformStep kernel" begin
    using FindFirstFunctions
    using FindFirstFunctions:
        SearchProperties, Auto, KIND_UNIFORM_STEP,
        searchsorted_last, searchsorted_first

    # Auto{T} carries SearchProperties{T}.
    @test Auto() isa Auto{Float64}
    @test Auto(collect(1:100)) isa Auto{Float64}
    @test Auto(collect(0.0:0.5:10.0)) isa Auto{Float64}
    @test Auto(collect(Float32(0):Float32(0.5):Float32(10))) isa Auto{Float32}
    @test Auto(0.0:0.5:10.0) isa Auto{Float64}
    @test Auto(Float32(0):Float32(0.5):Float32(10)) isa Auto{Float32}

    # The props-aware UniformStep path is taken when kind ===
    # KIND_UNIFORM_STEP. For uniform data, Auto resolves to
    # KIND_UNIFORM_STEP and `searchsorted_last(::Auto, ...)` uses the
    # precomputed first_val + inv_step closed-form path.
    for r in (
            0.0:0.5:100.0,
            LinRange(0.0, 100.0, 201),
            collect(0.0:0.5:100.0),
            collect(1:1000),
        )
        a = Auto(r)
        @test a.kind === KIND_UNIFORM_STEP
        for x in (-1.0, 0.0, 1.7, 42.5, 99.9, 100.0, 1000.0)
            if x > maximum(r) + 1 && eltype(r) <: Integer && !isinteger(x)
                # skip mixed-type Int range queries with non-int x
                continue
            end
            want_last = searchsortedlast(r, x)
            want_first = searchsortedfirst(r, x)
            @test searchsorted_last(a, r, x) == want_last
            @test searchsorted_first(a, r, x) == want_first
            # Hinted form takes the same path.
            @test searchsorted_last(a, r, x, 1) == want_last
            @test searchsorted_first(a, r, x, 1) == want_first
        end
    end

    # Reverse-order range.
    r_rev = 10.0:-0.5:0.0
    a_rev = Auto(r_rev)
    @test a_rev.kind === KIND_UNIFORM_STEP
    for x in (-1.0, 0.0, 2.7, 5.0, 10.5)
        @test searchsorted_last(a_rev, r_rev, x; order = Base.Order.Reverse) ==
            searchsortedlast(r_rev, x, Base.Order.Reverse)
        @test searchsorted_first(a_rev, r_rev, x; order = Base.Order.Reverse) ==
            searchsortedfirst(r_rev, x, Base.Order.Reverse)
    end

    # An Auto built from props alone (no v) still routes to the
    # props-aware kernel when kind === KIND_UNIFORM_STEP.
    p = SearchProperties(0.0:0.5:10.0)
    a_p = Auto(p)
    @test a_p.kind === KIND_UNIFORM_STEP
    for x in (0.0, 1.7, 5.0, 9.9, 10.0)
        @test searchsorted_last(a_p, 0.0:0.5:10.0, x) ==
            searchsortedlast(0.0:0.5:10.0, x)
    end

    # An Auto with KIND_UNIFORM_STEP but the unpopulated sentinel
    # props (has_props = false, inv_step = 0) must not take the
    # props-aware closed form — it falls through to the fld-based
    # range kernel, which stays O(1) and correct.
    a_sent = Auto(0.0:0.5:10.0, SearchProperties())
    @test a_sent.kind === KIND_UNIFORM_STEP
    @test !a_sent.props.has_props
    for x in (-1.0, 0.0, 1.7, 5.0, 10.0, 11.0)
        @test searchsorted_last(a_sent, 0.0:0.5:10.0, x) ==
            searchsortedlast(0.0:0.5:10.0, x)
        @test searchsorted_first(a_sent, 0.0:0.5:10.0, x) ==
            searchsortedfirst(0.0:0.5:10.0, x)
    end

    # Data uniform at the 11 sampled probe points but jittered
    # between them must NOT be flagged uniform — the exact
    # validation scan rejects what the sampled pre-filter misses.
    v_trick = collect(1.0:101.0)
    v_trick[52:60] .= range(54.5, 60.0, length = 9)
    @test issorted(v_trick)
    p_trick = SearchProperties(v_trick)
    @test !p_trick.is_uniform

    # Even when a caller forces is_uniform = true on such data,
    # the kernel's correction walk keeps the searchsorted
    # contract (slower, but never silently wrong).
    p_forced = SearchProperties(v_trick; is_uniform = true)
    @test p_forced.is_uniform
    a_trick = Auto(p_forced)
    @test a_trick.kind === KIND_UNIFORM_STEP
    for x in (54.0, 54.5, 55.1875, 0.5, 101.0, 60.0)
        @test searchsorted_last(a_trick, v_trick, x) ==
            searchsortedlast(v_trick, x)
        @test searchsorted_first(a_trick, v_trick, x) ==
            searchsortedfirst(v_trick, x)
    end

    # Extreme finite queries: `diff * inv_step` exceeds typemax(Int),
    # so the kernel must clamp in the float domain before truncating.
    v_u = collect(0.0:1.0:99.0)
    a_u = Auto(v_u)
    @test a_u.kind === KIND_UNIFORM_STEP
    for x in (1.0e300, -1.0e300, floatmax(Float64), -floatmax(Float64))
        @test searchsorted_last(a_u, v_u, x) == searchsortedlast(v_u, x)
        @test searchsorted_first(a_u, v_u, x) == searchsortedfirst(v_u, x)
    end

    # Caller-supplied is_uniform = true on a zero-span vector makes
    # inv_step = Inf and f = NaN at x == first_val; must fall back
    # rather than hit unsafe_trunc(NaN).
    c = fill(5.0, 10)
    p_c = SearchProperties(c; is_uniform = true)
    a_c = Auto(p_c)
    for x in (5.0, 4.0, 6.0)
        @test searchsorted_last(a_c, c, x) == searchsortedlast(c, x)
        @test searchsorted_first(a_c, c, x) == searchsortedfirst(c, x)
    end

    # Reverse-ordered uniform Vector through the props kernel.
    v_rev = collect(100.0:-1.0:1.0)
    p_rev = SearchProperties(v_rev)
    @test p_rev.is_uniform
    a_vrev = Auto(p_rev)
    for x in (50.5, 1.0, 100.0, 1.0e300, -3.0)
        @test searchsorted_last(a_vrev, v_rev, x; order = Base.Order.Reverse) ==
            searchsortedlast(v_rev, x, Base.Order.Reverse)
        @test searchsorted_first(a_vrev, v_rev, x; order = Base.Order.Reverse) ==
            searchsortedfirst(v_rev, x, Base.Order.Reverse)
    end
end

@safetestset "Batched in-place searchsorted!" begin
    using FindFirstFunctions:
        LinearScan, BracketGallop, BinaryBracket, Auto,
        searchsortedlast!, searchsortedfirst!

    # Sorted queries
    v = collect(1:100)
    x_sorted = [5, 10, 20, 50, 90]
    out_last = Vector{Int}(undef, length(x_sorted))
    out_first = Vector{Int}(undef, length(x_sorted))

    @test searchsortedlast!(out_last, v, x_sorted) ==
        searchsortedlast.(Ref(v), x_sorted)
    @test searchsortedfirst!(out_first, v, x_sorted) ==
        searchsortedfirst.(Ref(v), x_sorted)
    @test out_last === searchsortedlast!(out_last, v, x_sorted)  # in-place

    # Each strategy gives the same result on sorted input
    for strategy in
        (LinearScan(), BracketGallop(), BinaryBracket(), Auto())
        fill!(out_last, 0)
        fill!(out_first, 0)
        searchsortedlast!(out_last, v, x_sorted; strategy = strategy)
        searchsortedfirst!(out_first, v, x_sorted; strategy = strategy)
        @test out_last == searchsortedlast.(Ref(v), x_sorted)
        @test out_first == searchsortedfirst.(Ref(v), x_sorted)
    end

    # Unsorted falls back to per-element regardless of strategy
    x_unsorted = [50, 10, 90, 5, 20]
    out = Vector{Int}(undef, length(x_unsorted))
    for strategy in (LinearScan(), BracketGallop(), Auto())
        searchsortedlast!(out, v, x_unsorted; strategy = strategy)
        @test out == searchsortedlast.(Ref(v), x_unsorted)
        searchsortedfirst!(out, v, x_unsorted; strategy = strategy)
        @test out == searchsortedfirst.(Ref(v), x_unsorted)
    end

    # Reverse-order vector + reverse-sorted queries
    v_rev = collect(10.0:-1.0:1.0)
    x_rev_sorted = [9.5, 7.5, 5.0, 2.5, 0.5]   # sorted descending
    out_r = Vector{Int}(undef, length(x_rev_sorted))
    searchsortedlast!(
        out_r, v_rev, x_rev_sorted; order = Base.Order.Reverse
    )
    @test out_r ==
        [searchsortedlast(v_rev, x, Base.Order.Reverse) for x in x_rev_sorted]

    # Floats + values between grid points
    vf = collect(0.0:0.1:10.0)
    xf = [0.5, 1.0, 2.5, 5.0, 9.5]
    outf = Vector{Int}(undef, length(xf))
    searchsortedlast!(outf, vf, xf)
    @test outf == searchsortedlast.(Ref(vf), xf)

    # Edge cases: out-of-range queries on each side
    x_edges = [-5.0, 0.0, 5.0, 10.0, 15.0]
    sort!(x_edges)
    oute = Vector{Int}(undef, length(x_edges))
    searchsortedlast!(oute, vf, x_edges)
    @test oute == searchsortedlast.(Ref(vf), x_edges)
    searchsortedfirst!(oute, vf, x_edges)
    @test oute == searchsortedfirst.(Ref(vf), x_edges)

    # Empty queries
    @test searchsortedlast!(Int[], v, Int[]) == Int[]
    @test searchsortedfirst!(Int[], v, Int[]) == Int[]

    # DimensionMismatch
    @test_throws DimensionMismatch searchsortedlast!(zeros(Int, 2), v, [1, 2, 3])
    @test_throws DimensionMismatch searchsortedfirst!(zeros(Int, 2), v, [1, 2, 3])

    # Sparse queries on a long vector — exercises the BracketGallop hint path
    v_big = collect(1:100_000)
    x_sparse = [100, 50_000, 99_900]
    outb = Vector{Int}(undef, length(x_sparse))
    searchsortedlast!(outb, v_big, x_sparse)
    @test outb == searchsortedlast.(Ref(v_big), x_sparse)

    # Range fast paths route through the strategy dispatch.
    r = 1:100
    outr = Vector{Int}(undef, length(x_sorted))
    for strategy in (LinearScan(), BracketGallop(), Auto())
        searchsortedlast!(outr, r, x_sorted; strategy = strategy)
        @test outr == searchsortedlast.(Ref(r), x_sorted)
    end
end

@safetestset "searchsortedrange" begin
    using FindFirstFunctions, StableRNGs
    v = collect(0.0:0.5:50.0)
    # Compare against Base composition for several (lo, hi) pairs.
    for (lo, hi) in [
            (5.0, 7.0), (0.0, 100.0), (-1.0, 5.5), (10.0, 10.0),
            (45.0, 60.0), (51.0, 100.0),
        ]
        expected = searchsortedfirst(v, lo):searchsortedlast(v, hi)
        for strategy in (
                Auto(), BinaryBracket(), BracketGallop(), LinearScan(),
                InterpolationSearch(), ExpFromLeft(), SIMDLinearScan(),
            )
            @test searchsortedrange(strategy, v, lo, hi) == expected
            # Hinted form.
            h = clamp(searchsortedfirst(v, lo), 1, length(v))
            @test searchsortedrange(strategy, v, lo, hi, h) == expected
        end
    end
    # Random fuzz on Int64.
    rng = StableRNG(2026)
    vi = sort!(rand(rng, Int64(-100):Int64(100), 200))
    for _ in 1:200
        lo, hi = sort([rand(rng, Int64(-110):Int64(110)) for _ in 1:2])
        want = searchsortedfirst(vi, lo):searchsortedlast(vi, hi)
        @test searchsortedrange(Auto(), vi, lo, hi) == want
        @test searchsortedrange(BracketGallop(), vi, lo, hi, 100) == want
    end
    # Type stability: result is UnitRange{Int}.
    @test typeof(searchsortedrange(Auto(), v, 5.0, 7.0)) === UnitRange{Int}
end

@safetestset "queries_sorted kwarg" begin
    using FindFirstFunctions, StableRNGs
    v = collect(0.0:0.5:100.0)
    rng = StableRNG(2026)
    sorted_q = sort!(rand(rng, 64) .* 100.0)
    unsorted_q = rand(rng, 64) .* 100.0
    out = Vector{Int}(undef, 64)
    expected_sorted = searchsortedlast.(Ref(v), sorted_q)
    expected_unsorted = searchsortedlast.(Ref(v), unsorted_q)

    # Default behaviour (nothing) — runtime issorted check.
    searchsortedlast!(out, v, sorted_q; strategy = Auto())
    @test out == expected_sorted
    searchsortedlast!(out, v, unsorted_q; strategy = Auto())
    @test out == expected_unsorted

    # Explicit queries_sorted = true: trust the caller's sortedness.
    searchsortedlast!(out, v, sorted_q; strategy = Auto(), queries_sorted = true)
    @test out == expected_sorted
    # Across every shipped strategy.
    for strategy in (
            LinearScan(), SIMDLinearScan(), BracketGallop(),
            ExpFromLeft(), InterpolationSearch(), BinaryBracket(),
        )
        searchsortedlast!(
            out, v, sorted_q;
            strategy = strategy, queries_sorted = true
        )
        @test out == expected_sorted
        searchsortedfirst!(
            out, v, sorted_q;
            strategy = strategy, queries_sorted = true
        )
        @test out == searchsortedfirst.(Ref(v), sorted_q)
    end

    # Explicit queries_sorted = false: take the unsorted-loop path
    # unconditionally, even on sorted input — answers must still be
    # correct (the unsorted loop is per-query unhinted Base call).
    searchsortedlast!(out, v, sorted_q; strategy = Auto(), queries_sorted = false)
    @test out == expected_sorted
    searchsortedlast!(out, v, unsorted_q; strategy = Auto(), queries_sorted = false)
    @test out == expected_unsorted
end

@safetestset "SIMDLinearScan correctness" begin
    using FindFirstFunctions, StableRNGs
    F = FindFirstFunctions

    @testset "Int64 fuzz vs Base" begin
        rng = StableRNG(2026)
        for _ in 1:5_000
            n = rand(rng, 1:512)
            v = sort!(rand(rng, Int64(-1000):Int64(1000), n))
            x = rand(rng, Int64(-1100):Int64(1100))
            hint = rand(rng, 1:n)
            @test searchsorted_last(F.SIMDLinearScan(), v, x, hint) ==
                searchsortedlast(v, x)
            @test searchsorted_first(F.SIMDLinearScan(), v, x, hint) ==
                searchsortedfirst(v, x)
        end
    end

    @testset "Float64 fuzz vs Base" begin
        rng = StableRNG(2027)
        for _ in 1:5_000
            n = rand(rng, 1:512)
            v = sort!(randn(rng, n))
            x = (rand(rng) - 0.5) * 6
            hint = rand(rng, 1:n)
            @test searchsorted_last(F.SIMDLinearScan(), v, x, hint) ==
                searchsortedlast(v, x)
            @test searchsorted_first(F.SIMDLinearScan(), v, x, hint) ==
                searchsortedfirst(v, x)
        end
    end

    @testset "Edge cases (Int64)" begin
        v = collect(Int64, 1:100)
        # Out-of-range hint is clamped.
        @test searchsorted_last(F.SIMDLinearScan(), v, Int64(50), -5) == 50
        @test searchsorted_last(F.SIMDLinearScan(), v, Int64(50), 1_000) == 50
        # x below/above the range.
        @test searchsorted_last(F.SIMDLinearScan(), v, Int64(-10), 50) == 0
        @test searchsorted_last(F.SIMDLinearScan(), v, Int64(1_000), 50) == 100
        @test searchsorted_first(F.SIMDLinearScan(), v, Int64(-10), 50) == 1
        @test searchsorted_first(F.SIMDLinearScan(), v, Int64(1_000), 50) == 101
        # Empty and single-element vectors.
        vempty = Int64[]
        @test searchsorted_last(F.SIMDLinearScan(), vempty, Int64(5), 1) == 0
        @test searchsorted_first(F.SIMDLinearScan(), vempty, Int64(5), 1) == 1
        v1 = Int64[42]
        @test searchsorted_last(F.SIMDLinearScan(), v1, Int64(42), 1) == 1
        @test searchsorted_first(F.SIMDLinearScan(), v1, Int64(42), 1) == 1
        # Duplicates.
        vd = Int64[1, 2, 2, 2, 5]
        @test searchsorted_last(F.SIMDLinearScan(), vd, Int64(2), 1) == 4
        @test searchsorted_first(F.SIMDLinearScan(), vd, Int64(2), 5) == 2
    end

    @testset "Fallback: non-Int64/Float64 eltypes" begin
        # Int32 vectors must hit the generic LinearScan fallback,
        # not the Int64 SIMD primitive.
        v32 = Int32[1, 5, 10, 20, 50, 100, 200]
        for x in (Int32(0), Int32(7), Int32(20), Int32(300))
            for hint in 1:length(v32)
                @test searchsorted_last(F.SIMDLinearScan(), v32, x, hint) ==
                    searchsortedlast(v32, x)
                @test searchsorted_first(F.SIMDLinearScan(), v32, x, hint) ==
                    searchsortedfirst(v32, x)
            end
        end
        # Float32 same.
        v32f = Float32[1.0, 5.0, 10.0, 20.0, 50.0]
        for x in (Float32(0.0), Float32(7.0), Float32(20.0), Float32(100.0))
            @test searchsorted_last(F.SIMDLinearScan(), v32f, x, 2) ==
                searchsortedlast(v32f, x)
        end
        # Non-numeric.
        vs = sort!(["alpha", "beta", "gamma", "delta", "epsilon"])
        @test searchsorted_last(F.SIMDLinearScan(), vs, "gamma", 2) ==
            searchsortedlast(vs, "gamma")
    end

    @testset "Fallback: no hint, reverse order" begin
        v = collect(Int64, 1:100)
        # No hint → BinaryBracket.
        @test searchsorted_last(F.SIMDLinearScan(), v, Int64(50)) ==
            searchsortedlast(v, Int64(50))
        # Reverse order → scalar LinearScan.
        v_rev = collect(Int64, 100:-1:1)
        @test searchsorted_last(
            F.SIMDLinearScan(), v_rev, Int64(50), 1; order = Base.Order.Reverse
        ) == searchsortedlast(v_rev, Int64(50), Base.Order.Reverse)
    end
end

@safetestset "findequal + BisectThenSIMD" begin
    using FindFirstFunctions, StableRNGs
    F = FindFirstFunctions

    # Reference: an Int sentinel-returning equality search built from
    # Base.searchsortedfirst.
    function ref_findequal(v, x)
        i = searchsortedfirst(v, x)
        return (i > lastindex(v) || !isequal(v[i], x)) ?
            (firstindex(v) - 1) : i
    end

    @testset "Strategy parity on Int64 (1-based)" begin
        rng = StableRNG(3001)
        for _ in 1:2_000
            n = rand(rng, 1:256)
            v = sort!(rand(rng, Int64(-50):Int64(50), n))
            x = rand(rng, Int64(-60):Int64(60))
            hint = rand(rng, 1:n)
            want = ref_findequal(v, x)
            for strategy in (
                    F.BinaryBracket(), F.BracketGallop(),
                    F.SIMDLinearScan(), F.LinearScan(),
                    F.ExpFromLeft(), F.InterpolationSearch(),
                    F.Auto(), F.BisectThenSIMD(),
                )
                @test F.findequal(strategy, v, x) == want
                @test F.findequal(strategy, v, x, hint) == want
            end
        end
    end

    @testset "Strategy parity on Float64" begin
        rng = StableRNG(3002)
        for _ in 1:500
            n = rand(rng, 1:256)
            v = sort!(randn(rng, n))
            # Mix queries that hit elements with ones that don't.
            x = rand(rng) < 0.4 ? v[rand(rng, 1:n)] :
                (rand(rng) - 0.5) * 6
            hint = rand(rng, 1:n)
            want = ref_findequal(v, x)
            for strategy in (
                    F.BinaryBracket(), F.BracketGallop(),
                    F.SIMDLinearScan(), F.Auto(), F.BisectThenSIMD(),
                )
                @test F.findequal(strategy, v, x) == want
                @test F.findequal(strategy, v, x, hint) == want
            end
        end
    end

    @testset "BisectThenSIMD shortcut uses SIMD on DenseVector{Int64}" begin
        # Compare against findfirstsortedequal directly.
        v = collect(Int64, 1:10_000)
        for x in (
                Int64(1), Int64(5_000), Int64(10_000),
                Int64(0), Int64(10_001), Int64(-100), Int64(20_000),
            )
            a = F.findequal(F.BisectThenSIMD(), v, x)
            b = F.findfirstsortedequal(x, v)
            @test (a == 0 ? nothing : a) == b
        end
    end

    @testset "Sentinel for OffsetArray-style indexing" begin
        # Manually shift the index base by using a UnitRange directly.
        v = collect(Int64, 10:20)
        @test F.findequal(F.Auto(), v, Int64(15)) == 6
        @test F.findequal(F.Auto(), v, Int64(100)) == 0
        @test F.findequal(F.Auto(), v, Int64(-5)) == 0
    end

    @testset "Reverse ordering" begin
        v_rev = collect(Int64, 10:-1:1)
        # Forward findequal on a reverse-sorted vector with the
        # Reverse ordering should still find the element if present.
        @test F.findequal(
            F.BinaryBracket(), v_rev, Int64(5);
            order = Base.Order.Reverse,
        ) == 6
        @test F.findequal(
            F.BinaryBracket(), v_rev, Int64(99);
            order = Base.Order.Reverse,
        ) == 0
        # BisectThenSIMD on reverse order falls back to generic path.
        @test F.findequal(
            F.BisectThenSIMD(), v_rev, Int64(5);
            order = Base.Order.Reverse,
        ) == 6
    end

    @testset "Empty and single-element" begin
        vempty = Int64[]
        @test F.findequal(F.Auto(), vempty, Int64(0)) == 0
        @test F.findequal(F.BisectThenSIMD(), vempty, Int64(0)) == 0
        v1 = Int64[42]
        @test F.findequal(F.Auto(), v1, Int64(42)) == 1
        @test F.findequal(F.Auto(), v1, Int64(7)) == 0
        @test F.findequal(F.BisectThenSIMD(), v1, Int64(42)) == 1
    end

    @testset "BisectThenSIMD in positional dispatch falls back" begin
        # When used with searchsortedfirst/last, BisectThenSIMD just
        # delegates to BinaryBracket — its purpose is findequal.
        v = collect(Int64, 1:100)
        @test searchsorted_first(F.BisectThenSIMD(), v, Int64(50)) ==
            searchsortedfirst(v, Int64(50))
        @test searchsorted_last(F.BisectThenSIMD(), v, Int64(50)) ==
            searchsortedlast(v, Int64(50))
    end
end

@safetestset "Enum-tagged dispatch (v3 API)" begin
    using FindFirstFunctions
    using FindFirstFunctions: searchsorted_last, searchsorted_first, strategy_kind
    using StableRNGs

    # Mapping from struct → kind, and kind enum value coverage.
    @testset "strategy_kind coverage" begin
        @test strategy_kind(BinaryBracket()) === KIND_BINARY_BRACKET
        @test strategy_kind(LinearScan()) === KIND_LINEAR_SCAN
        @test strategy_kind(SIMDLinearScan()) === KIND_SIMD_LINEAR_SCAN
        @test strategy_kind(BracketGallop()) === KIND_BRACKET_GALLOP
        @test strategy_kind(ExpFromLeft()) === KIND_EXP_FROM_LEFT
        @test strategy_kind(InterpolationSearch()) === KIND_INTERPOLATION_SEARCH
        @test strategy_kind(BitInterpolationSearch()) === KIND_BIT_INTERPOLATION_SEARCH
        @test strategy_kind(UniformStep()) === KIND_UNIFORM_STEP
        @test strategy_kind(BisectThenSIMD()) === KIND_BISECT_THEN_SIMD
    end

    @testset "Per-kind searchsorted_last parity vs Base" begin
        # Each hint-using kind should match Base when given a valid
        # in-range hint. Hint-ignoring kinds (BinaryBracket,
        # InterpolationSearch, UniformStep, BisectThenSIMD) match
        # Base regardless of hint.
        v = collect(1:100)
        for x in (-1, 0, 1, 17, 50, 99, 100, 101, 200), h in (1, 30, 60, 90, 100)
            want_last = searchsortedlast(v, x)
            want_first = searchsortedfirst(v, x)
            for kind in (
                    KIND_BINARY_BRACKET, KIND_LINEAR_SCAN,
                    KIND_BRACKET_GALLOP, KIND_EXP_FROM_LEFT,
                    KIND_INTERPOLATION_SEARCH,
                )
                @test searchsorted_last(kind, v, x, h) == want_last
                @test searchsorted_first(kind, v, x, h) == want_first
            end
            # No-hint forms.
            @test searchsorted_last(KIND_BINARY_BRACKET, v, x) == want_last
            @test searchsorted_first(KIND_BINARY_BRACKET, v, x) == want_first
            @test searchsorted_last(KIND_INTERPOLATION_SEARCH, v, x) == want_last
            @test searchsorted_first(KIND_INTERPOLATION_SEARCH, v, x) == want_first
        end
    end

    @testset "Per-kind Float64 parity (incl. SIMD)" begin
        rng = StableRNG(7001)
        v = sort!(randn(rng, 256))
        for _ in 1:200
            x = (rand(rng) - 0.5) * 6
            h = rand(rng, 1:length(v))
            want_last = searchsortedlast(v, x)
            want_first = searchsortedfirst(v, x)
            for kind in (
                    KIND_BINARY_BRACKET, KIND_LINEAR_SCAN,
                    KIND_SIMD_LINEAR_SCAN, KIND_BRACKET_GALLOP,
                    KIND_EXP_FROM_LEFT, KIND_INTERPOLATION_SEARCH,
                )
                @test searchsorted_last(kind, v, x, h) == want_last
                @test searchsorted_first(kind, v, x, h) == want_first
            end
        end
    end

    @testset "Per-kind Int64 SIMD parity" begin
        rng = StableRNG(7002)
        v = sort!(rand(rng, Int64(-200):Int64(200), 256))
        for _ in 1:200
            x = rand(rng, Int64(-220):Int64(220))
            h = rand(rng, 1:length(v))
            want_last = searchsortedlast(v, x)
            want_first = searchsortedfirst(v, x)
            @test searchsorted_last(KIND_SIMD_LINEAR_SCAN, v, x, h) == want_last
            @test searchsorted_first(KIND_SIMD_LINEAR_SCAN, v, x, h) == want_first
        end
    end

    @testset "UniformStep kind on AbstractRange" begin
        for r in (1:100, 0.0:0.1:10.0, LinRange(0.0, 10.0, 101))
            for x in (first(r) - 1, first(r), last(r), last(r) + 1)
                @test searchsorted_last(KIND_UNIFORM_STEP, r, x) ==
                    searchsortedlast(r, x)
                @test searchsorted_first(KIND_UNIFORM_STEP, r, x) ==
                    searchsortedfirst(r, x)
            end
        end
    end

    @testset "BitInterpolationSearch kind on positive Float64" begin
        v = exp.(range(0.0, log(1.0e6); length = 1024))
        rng = StableRNG(7003)
        for _ in 1:100
            x = exp(rand(rng) * log(1.0e6))
            @test searchsorted_last(KIND_BIT_INTERPOLATION_SEARCH, v, x) ==
                searchsortedlast(v, x)
            @test searchsorted_first(KIND_BIT_INTERPOLATION_SEARCH, v, x) ==
                searchsortedfirst(v, x)
        end
    end

    @testset "Reverse order under enum dispatch" begin
        v = collect(10.0:-1.0:1.0)
        for kind in (
                KIND_BINARY_BRACKET, KIND_LINEAR_SCAN,
                KIND_BRACKET_GALLOP, KIND_EXP_FROM_LEFT,
                KIND_INTERPOLATION_SEARCH,
            )
            for x in (0.5, 1.0, 5.0, 10.0, 11.0), h in (1, 5, 10)
                @test searchsorted_last(kind, v, x, h; order = Base.Order.Reverse) ==
                    searchsortedlast(v, x, Base.Order.Reverse)
                @test searchsorted_first(kind, v, x, h; order = Base.Order.Reverse) ==
                    searchsortedfirst(v, x, Base.Order.Reverse)
            end
        end
    end

    @testset "Auto inferred return type" begin
        # Auto(v) was previously Union-returning in the v2 design
        # — the `_auto_pick` branch returned BinaryBracket vs
        # BracketGallop depending on length, and each branch had
        # different return types feeding the per-query dispatch.
        # In v3 the kind is stored as a UInt8-backed enum, so
        # both branches return Int.
        v = collect(1:100)
        a = Auto(v)
        @test isbits(a)
        @test @inferred(Auto(v)) isa Auto
        @test @inferred(Auto(SearchProperties(v))) isa Auto
        # `searchsorted_last(::Auto, ...)` is concretely Int-returning.
        @test @inferred(searchsorted_last(a, v, 50, 1)) === 50
        @test @inferred(searchsorted_first(a, v, 50, 1)) === 50
        @test @inferred(searchsorted_last(a, v, 50)) === 50
    end

    @testset "Vector{Auto{T}} has concrete eltype" begin
        # Mixed-underlying-kind Vector{Auto{T}}: even when each Auto
        # was constructed from a different v / props (but with the
        # same ratio eltype T), the element type is `Auto{T}`
        # (concrete), not `Union{...}` or `Any`. `Vector{Int}` and
        # `Vector{Float64}` both ratio-promote to `Float64`, so
        # `Auto(collect(1:100))` and `Auto(rand(100))` are both
        # `Auto{Float64}`.
        a1 = Auto(collect(1:100))          # KIND_UNIFORM_STEP (Int → Float64)
        a2 = Auto(rand(StableRNG(10), 100))  # KIND_BRACKET_GALLOP (Float64)
        a3 = Auto(collect(1:8))            # KIND_LINEAR_SCAN (Int → Float64)
        @test a1 isa Auto{Float64}
        @test a2 isa Auto{Float64}
        @test a3 isa Auto{Float64}
        v = Auto{Float64}[a1, a2, a3]
        @test eltype(v) === Auto{Float64}
        @test isconcretetype(eltype(v))
    end

    @testset "Struct form forwards through strategy_kind" begin
        # `searchsorted_last(::S, v, x[, hint])` forwards through
        # `strategy_kind(S())` to `searchsorted_last(KIND_X, ...)`.
        # Verify both forms produce identical answers.
        v = collect(1:1000)
        rng = StableRNG(7004)
        pairs = (
            (BracketGallop(), KIND_BRACKET_GALLOP),
            (LinearScan(), KIND_LINEAR_SCAN),
            (ExpFromLeft(), KIND_EXP_FROM_LEFT),
            (InterpolationSearch(), KIND_INTERPOLATION_SEARCH),
            (BinaryBracket(), KIND_BINARY_BRACKET),
        )
        for (s, kind) in pairs
            for _ in 1:50
                x = rand(rng, 1:1000)
                h = rand(rng, 1:1000)
                @test searchsorted_last(s, v, x, h) ==
                    searchsorted_last(kind, v, x, h)
                @test searchsorted_first(s, v, x, h) ==
                    searchsorted_first(kind, v, x, h)
            end
        end
    end

    @testset "GuesserHint stays on multimethod path" begin
        using FindFirstFunctions: Guesser, GuesserHint
        v = collect(LinRange(0, 10, 100))
        g = Guesser(v)
        gh = GuesserHint(g)
        @test searchsorted_last(gh, v, 4.0) == searchsortedlast(v, 4.0)
        @test searchsorted_first(gh, v, 4.0) == searchsortedfirst(v, 4.0)
        # strategy_kind on a GuesserHint must error — it has no tag.
        @test_throws ArgumentError strategy_kind(gh)
    end

    @testset "No Base.searchsorted strategy extensions" begin
        # v3 removed the v2 `Base.searchsortedlast(::S, ...)` /
        # `Base.searchsortedfirst(::S, ...)` methods entirely.
        # Guard against accidental reintroduction.
        using FindFirstFunctions:
            BracketGallop, Auto, GuesserHint, Guesser, UniformStep
        V = Vector{Float64}
        for S in (
                BracketGallop, UniformStep, Auto{Float64},
                GuesserHint{Guesser{V}},
            )
            @test !hasmethod(searchsortedlast, Tuple{S, V, Float64})
            @test !hasmethod(searchsortedfirst, Tuple{S, V, Float64})
            @test !hasmethod(searchsortedlast, Tuple{S, V, Float64, Int})
            @test !hasmethod(searchsortedfirst, Tuple{S, V, Float64, Int})
        end
    end
end

@safetestset "Scalar primitive parity" begin
    using FindFirstFunctions, StableRNGs
    F = FindFirstFunctions

    # `_scalar_first` backs the SIMD primitives on non-64-bit platforms;
    # check it against `findfirst` on all platforms.
    rng = StableRNG(2028)
    for _ in 1:2_000
        n = rand(rng, 0:64)
        vi = rand(rng, Int64(-50):Int64(50), n)
        xi = rand(rng, Int64(-60):Int64(60))
        vf = randn(rng, n)
        xf = randn(rng)
        for (pred, v, x) in (
                (==, vi, xi), (>, vi, xi), (>=, vi, xi), (<, vi, xi), (<=, vi, xi),
                (>, vf, xf), (>=, vf, xf), (<, vf, xf), (<=, vf, xf),
            )
            ref = findfirst(e -> pred(e, x), v)
            got = GC.@preserve v F._scalar_first(pred, x, pointer(v), Int64(length(v)))
            @test got == (ref === nothing ? -1 : ref - 1)
        end
    end
end

@safetestset "findfirstsortedequal generic fallback" begin
    using FindFirstFunctions, StableRNGs
    F = FindFirstFunctions

    # The `(Int64, DenseVector{Int64})` method is the SIMD fast path; every
    # other type (e.g. `Int32`, which is the native `Int` on 32-bit platforms)
    # takes the generic searchsortedfirst fallback. Exercise it explicitly here
    # so both paths are covered regardless of the host word size.
    rng = StableRNG(2029)
    for T in (Int32, Int16, Float32), _ in 1:500
        n = rand(rng, 0:64)
        v = sort!(rand(rng, T(-40):T(40), n))
        for i in eachindex(v)
            @test F.findfirstsortedequal(v[i], v) == searchsortedfirst(v, v[i])
        end
        x = rand(rng, T(-50):T(50))
        ref = insorted(x, v) ? searchsortedfirst(v, x) : nothing
        @test F.findfirstsortedequal(x, v) == ref
    end
end

@safetestset "UniformStep kernel across non-primitive Real eltypes" begin
    using FindFirstFunctions
    using FindFirstFunctions: SearchProperties, Auto, searchsorted_last, searchsorted_first

    # `Rational` ratio types don't define `unsafe_trunc(Int, ·)`, so a uniform
    # `Rational` vector — which `Auto` resolves to the closed-form
    # `KIND_UNIFORM_STEP` path — must fall back to `floor/ceil(Int, ·)` rather
    # than erroring. `BigFloat` exercises the non-`IEEEFloat` AbstractFloat
    # branch of the same helper.
    uniform_vectors = (
        Rational{Int}[i // 4 for i in 0:4:160],
        Rational{BigInt}[big(i) // 4 for i in 0:4:160],
        BigFloat[BigFloat(i) for i in range(0.0, 10.0; length = 40)],
    )
    for v in uniform_vectors
        @test SearchProperties(v).is_uniform
        auto = Auto(v)
        @test auto isa Auto
        for i in eachindex(v)
            @test searchsorted_last(auto, v, v[i]) == searchsortedlast(v, v[i])
            @test searchsorted_first(auto, v, v[i]) == searchsortedfirst(v, v[i])
        end
        # Between-knot and out-of-range queries.
        for q in (v[1] - one(eltype(v)), (v[3] + v[4]) / 2, v[end] + one(eltype(v)))
            @test searchsorted_last(auto, v, q) == searchsortedlast(v, q)
            @test searchsorted_first(auto, v, q) == searchsortedfirst(v, q)
        end
    end
end

using FindFirstFunctions, JET, AllocCheck, Test

# Beyond the package-wide JET pass in run_qa (qa.jl), assert type stability on the
# specific hot-path call signatures, and assert they allocate nothing — guarantees
# `JET.test_package` / `Aqua` do not make on their own.

@testset "JET static analysis (hot-path signatures)" begin
    vec_float64 = Float64[1.0, 2.0, 3.0, 4.0, 5.0]

    # findfirstequal - fast SIMD-based search
    rep = JET.report_call(FindFirstFunctions.findfirstequal, (Int64, Vector{Int64}))
    @test length(JET.get_reports(rep)) == 0

    # findfirstsortedequal - binary search variant
    rep = JET.report_call(FindFirstFunctions.findfirstsortedequal, (Int64, Vector{Int64}))
    @test length(JET.get_reports(rep)) == 0

    # bracketstrictlymonotonic - bracketing for sorted vectors
    rep = JET.report_call(
        FindFirstFunctions.bracketstrictlymonotonic,
        (Vector{Int64}, Int64, Int64, Base.Order.ForwardOrdering)
    )
    @test length(JET.get_reports(rep)) == 0

    # looks_linear - linearity check
    rep = JET.report_call(FindFirstFunctions.looks_linear, (Vector{Float64},))
    @test length(JET.get_reports(rep)) == 0

    # Guesser - test constructor and callable
    guesser = FindFirstFunctions.Guesser(vec_float64)
    rep = JET.report_call(guesser, (Float64,))
    @test length(JET.get_reports(rep)) == 0

    # searchsorted_last with each StrategyKind - the v3 enum-dispatch hot path.
    for kind in (
            KIND_BINARY_BRACKET, KIND_LINEAR_SCAN, KIND_BRACKET_GALLOP,
            KIND_EXP_FROM_LEFT, KIND_INTERPOLATION_SEARCH,
        )
        rep = JET.report_call(
            (k, v, x, h) -> FindFirstFunctions.searchsorted_last(k, v, x, h),
            (typeof(kind), Vector{Int64}, Int64, Int64),
        )
        @test length(JET.get_reports(rep)) == 0
    end

    # searchsorted_first with each StrategyKind
    for kind in (
            KIND_BINARY_BRACKET, KIND_LINEAR_SCAN, KIND_BRACKET_GALLOP,
            KIND_EXP_FROM_LEFT, KIND_INTERPOLATION_SEARCH,
        )
        rep = JET.report_call(
            (k, v, x, h) -> FindFirstFunctions.searchsorted_first(k, v, x, h),
            (typeof(kind), Vector{Int64}, Int64, Int64),
        )
        @test length(JET.get_reports(rep)) == 0
    end

    # searchsortedfirstexp - exponential search helper (internal)
    rep = JET.report_call(
        FindFirstFunctions.searchsortedfirstexp,
        (Vector{Int64}, Int64, Int64, Int64)
    )
    @test length(JET.get_reports(rep)) == 0

    # Batched API
    rep = JET.report_call(
        FindFirstFunctions.searchsortedlast!,
        (Vector{Int}, Vector{Int64}, Vector{Int64}),
    )
    @test length(JET.get_reports(rep)) == 0
end

@testset "AllocCheck - Static Allocation Analysis" begin
    @testset "findfirstequal" begin
        allocs = check_allocs(FindFirstFunctions.findfirstequal, (Int64, Vector{Int64}))
        @test isempty(allocs)
    end

    @testset "findfirstsortedequal" begin
        allocs = check_allocs(FindFirstFunctions.findfirstsortedequal, (Int64, Vector{Int64}))
        @test isempty(allocs)
    end

    @testset "bracketstrictlymonotonic" begin
        allocs = check_allocs(
            FindFirstFunctions.bracketstrictlymonotonic,
            (Vector{Int64}, Int64, Int64, Base.Order.ForwardOrdering)
        )
        @test isempty(allocs)

        allocs = check_allocs(
            FindFirstFunctions.bracketstrictlymonotonic,
            (Vector{Float64}, Float64, Int64, Base.Order.ForwardOrdering)
        )
        @test isempty(allocs)
    end

    @testset "looks_linear" begin
        allocs = check_allocs(FindFirstFunctions.looks_linear, (Vector{Float64},))
        @test isempty(allocs)

        allocs = check_allocs(FindFirstFunctions.looks_linear, (Vector{Int64},))
        @test isempty(allocs)
    end

    @testset "Guesser callable" begin
        GuesserType = FindFirstFunctions.Guesser{Vector{Float64}}
        allocs = check_allocs(
            (g, x) -> g(x),
            (GuesserType, Float64)
        )
        @test isempty(allocs)
    end

    @testset "searchsorted_last via enum tag" begin
        # Each kind on Int64 dense vectors: no allocations.
        for kind in (
                KIND_BINARY_BRACKET, KIND_LINEAR_SCAN,
                KIND_BRACKET_GALLOP, KIND_EXP_FROM_LEFT,
            )
            allocs = check_allocs(
                (k, v, x, h) -> FindFirstFunctions.searchsorted_last(k, v, x, h),
                (typeof(kind), Vector{Int64}, Int64, Int64),
            )
            @test isempty(allocs)
            allocs = check_allocs(
                (k, v, x, h) -> FindFirstFunctions.searchsorted_first(k, v, x, h),
                (typeof(kind), Vector{Int64}, Int64, Int64),
            )
            @test isempty(allocs)
        end
    end

    @testset "searchsortedfirstexp" begin
        allocs = check_allocs(
            FindFirstFunctions.searchsortedfirstexp,
            (Vector{Int64}, Int64, Int64, Int64)
        )
        @test isempty(allocs)

        allocs = check_allocs(
            FindFirstFunctions.searchsortedfirstexp,
            (Vector{Float64}, Float64, Int64, Int64)
        )
        @test isempty(allocs)
    end
end

using DelimitedFiles, Statistics, Printf

const CSV = joinpath(@__DIR__, "results.csv")

# Read raw data
raw, header = readdlm(CSV, ','; header = true)
header = vec(string.(header))
function col(name)
    j = findfirst(==(name), header)
    j === nothing && error("no column $name")
    return j
end

const STRATS = ["LinearScan", "SIMDLinearScan", "BracketGallop", "ExpFromLeft", "InterpolationSearch"]

function row_winner(row)
    times = Float64[parse(Float64, string(row[col(s)])) for s in STRATS]
    j = argmin(times)
    return STRATS[j], times[j]
end

function ratio_to(row, strat_name)
    times = Float64[parse(Float64, string(row[col(s)])) for s in STRATS]
    best = minimum(times)
    return parse(Float64, string(row[col(strat_name)])) / best
end

println("==> Where does SIMDLinearScan win?")
simd_wins = []
for i in axes(raw, 1)
    local row = raw[i, :]
    local winner, _ = row_winner(row)
    if winner == "SIMDLinearScan"
        push!(
            simd_wins, (
                eltype = string(row[col("eltype")]),
                v = string(row[col("v_kind")]),
                q = string(row[col("q_kind")]),
                n = parse(Int, string(row[col("n")])),
                m = parse(Int, string(row[col("m")])),
            )
        )
    end
end
n_simd_wins = length(simd_wins)
println("  SIMDLinearScan wins in $n_simd_wins cells")
println()

# Tabulate where SIMD wins by m (gap proxy)
println("==> SIMDLinearScan wins by m (proxy for batched-gap regime):")
by_m = Dict{Int, Int}()
for c in simd_wins
    by_m[c.m] = get(by_m, c.m, 0) + 1
end
for m in sort(collect(keys(by_m)))
    @printf("  m=%5d:  %d cells\n", m, by_m[m])
end
println()

# By eltype
println("==> SIMDLinearScan wins by eltype:")
by_eltype = Dict{String, Int}()
for c in simd_wins
    by_eltype[c.eltype] = get(by_eltype, c.eltype, 0) + 1
end
for k in sort(collect(keys(by_eltype)))
    println("  $k: $(by_eltype[k]) cells")
end
println()

# Now show: for sorted-batched cells where SIMDLinearScan wins, what's the
# ratio of LinearScan/ExpFromLeft to SIMDLinearScan? This tells us the
# magnitude of the improvement.
println("==> SIMDLinearScan win margin over LinearScan and ExpFromLeft:")
println("    (Higher = bigger SIMD speedup over the second-best Auto candidate)")
margins = []
for i in axes(raw, 1)
    row = raw[i, :]
    winner, best = row_winner(row)
    if winner == "SIMDLinearScan"
        t_simd = best
        t_lin = parse(Float64, string(row[col("LinearScan")]))
        t_exp = parse(Float64, string(row[col("ExpFromLeft")]))
        push!(
            margins, (
                ratio_lin = t_lin / t_simd,
                ratio_exp = t_exp / t_simd,
                n = parse(Int, string(row[col("n")])),
                m = parse(Int, string(row[col("m")])),
            )
        )
    end
end
println("  SIMD vs LinearScan: median $(median(m.ratio_lin for m in margins))x, max $(maximum(m.ratio_lin for m in margins))x")
println("  SIMD vs ExpFromLeft: median $(median(m.ratio_exp for m in margins))x, max $(maximum(m.ratio_exp for m in margins))x")
println()

# What does Auto pick in the cells where SIMDLinearScan would win?
# Find the m, n, gap regime where SIMDLinearScan beats LinearScan AND ExpFromLeft.
println("==> Best regime for SIMDLinearScan (cells where SIMD wins by >20%):")
significant_simd_wins = filter(c -> c.ratio_lin > 1.2 && c.ratio_exp > 1.2, margins)
println("  $(length(significant_simd_wins)) cells where SIMD beats both LinearScan and ExpFromLeft by >20%")
n_by_m_n = Dict{Tuple{Int, Int}, Int}()
for c in significant_simd_wins
    n_by_m_n[(c.n, c.m)] = get(n_by_m_n, (c.n, c.m), 0) + 1
end
for (n, m) in sort(collect(keys(n_by_m_n)))
    @printf("  n=%5d m=%5d: %d cells\n", n, m, n_by_m_n[(n, m)])
end
println()

# Compute: in each cell, the GAP. gap = n * span(queries)/span(v) / m
# (the same heuristic Auto uses). Use n/m as a rough proxy since exact gap
# depends on the query distribution which isn't recoverable from CSV alone.
println("==> n/m ratio for SIMD-winning cells (rough gap proxy):")
nm_buckets = Dict{Int, Int}()
for c in simd_wins
    bucket = c.n ÷ c.m
    # Round to a power-of-2 bucket
    log_bucket = bucket == 0 ? 0 : floor(Int, log2(bucket))
    nm_buckets[log_bucket] = get(nm_buckets, log_bucket, 0) + 1
end
for b in sort(collect(keys(nm_buckets)))
    @printf("  n/m in [2^%d, 2^%d):  %d cells\n", b, b + 1, nm_buckets[b])
end
println()

println("==> What strategy does Auto pick in cells where SIMD would win?")
auto_picks_when_simd = Dict{String, Int}()
for i in axes(raw, 1)
    row = raw[i, :]
    winner, _ = row_winner(row)
    if winner == "SIMDLinearScan"
        # We don't know Auto's pick from the CSV, but we know Auto's time.
        # The closest strategy time to Auto's time tells us the pick.
        t_auto = parse(Float64, string(row[col("Auto")]))
        candidates = [(s, parse(Float64, string(row[col(s)]))) for s in STRATS]
        # Pick the strategy whose time is closest to Auto's
        # (within 20% — heuristic).
        closest = argmin(c -> abs(c[2] - t_auto), candidates)
        auto_picks_when_simd[closest[1]] = get(auto_picks_when_simd, closest[1], 0) + 1
    end
end
for (s, n) in sort(collect(pairs(auto_picks_when_simd)); by = x -> -x[2])
    println("  Auto -> $s: $n cells (out of $(length(simd_wins)))")
end

# Strategy structs as values: the `strategy_kind` mapping from a strategy
# struct to its `StrategyKind` tag, plus `searchsorted_last` / `searchsorted_first`
# methods that accept a singleton strategy struct directly and forward
# through the mapping. For a literal strategy argument
# (`searchsorted_last(BracketGallop(), v, x, hint)`) the mapping constant-folds,
# so the struct form costs nothing over the kind form.
#
# v3 does not extend `Base.searchsortedlast` / `Base.searchsortedfirst`
# with strategy methods — `searchsorted_last` / `searchsorted_first` are the only
# search entry points.

# `strategy_kind(s)` — the public mapping from strategy struct → tag.
strategy_kind(::BinaryBracket) = KIND_BINARY_BRACKET
strategy_kind(::LinearScan) = KIND_LINEAR_SCAN
strategy_kind(::SIMDLinearScan) = KIND_SIMD_LINEAR_SCAN
strategy_kind(::BracketGallop) = KIND_BRACKET_GALLOP
strategy_kind(::ExpFromLeft) = KIND_EXP_FROM_LEFT
strategy_kind(::InterpolationSearch) = KIND_INTERPOLATION_SEARCH
strategy_kind(::BitInterpolationSearch) = KIND_BIT_INTERPOLATION_SEARCH
strategy_kind(::UniformStep) = KIND_UNIFORM_STEP
strategy_kind(::BisectThenSIMD) = KIND_BISECT_THEN_SIMD

# Stateful strategies (`GuesserHint`, `Auto`) don't map to a single tag.
strategy_kind(s::Auto) = s.kind
strategy_kind(::GuesserHint) = throw(
    ArgumentError(
        "GuesserHint is a stateful strategy with no StrategyKind tag; use its own dispatch.",
    ),
)

# Struct-valued entry points. `Auto` and `GuesserHint` define their own,
# more specific `searchsorted_last` / `searchsorted_first` methods (in `auto.jl` and
# `guesser.jl`), so this fallback only ever sees the zero-state singletons.
@inline searchsorted_last(
    s::SearchStrategy, v::AbstractVector, x;
    order::Base.Order.Ordering = Base.Order.Forward,
) = searchsorted_last(strategy_kind(s), v, x; order = order)
@inline searchsorted_first(
    s::SearchStrategy, v::AbstractVector, x;
    order::Base.Order.Ordering = Base.Order.Forward,
) = searchsorted_first(strategy_kind(s), v, x; order = order)
@inline searchsorted_last(
    s::SearchStrategy, v::AbstractVector, x, hint::Integer;
    order::Base.Order.Ordering = Base.Order.Forward,
) = searchsorted_last(strategy_kind(s), v, x, hint; order = order)
@inline searchsorted_first(
    s::SearchStrategy, v::AbstractVector, x, hint::Integer;
    order::Base.Order.Ordering = Base.Order.Forward,
) = searchsorted_first(strategy_kind(s), v, x, hint; order = order)

# Strategy-framework equality search: `findequal(strategy, v, x[, hint])`.
# Returns an `Int` with the sentinel `firstindex(v) - 1` for "not found"
# (matching `Base.searchsortedlast`'s convention).
#
# Most strategies compose: run `searchsorted_first(strategy, v, x[, hint])` to
# find the candidate insertion point, then post-check whether `v[i] == x`.
# The `BisectThenSIMD` shortcut for `DenseVector{Int64}` dispatches into
# `findfirstsortedequal` directly.

"""
    findequal(strategy, v, x[, hint]; order = Base.Order.Forward) -> Int

Return the index of `x` in sorted `v` if present, or the sentinel
`firstindex(v) - 1` if `x` is absent. Type-stable `Int` return — the
sentinel matches the convention `Base.searchsortedlast` already uses for
"x precedes all of v".

The `strategy` argument can be:

  - A singleton strategy struct (`BinaryBracket()`, `BracketGallop()`,
    …) — forwards through the struct → kind mapping.
  - A [`StrategyKind`](@ref) enum value (`KIND_BRACKET_GALLOP`, …).
  - A stateful strategy (`Auto`, `GuesserHint`) — dispatched via
    multimethod.

Most strategies are handled generically. The shortcut method on
[`BisectThenSIMD`](@ref) for `DenseVector{Int64}` skips the
`searchsortedfirst` path entirely.

For unsorted vectors, use [`findfirstequal`](@ref).
"""
@inline function findequal(
        strategy::SearchStrategy, v::AbstractVector, x;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    return _findequal_generic_strategy(strategy, v, x, order)
end

@inline function findequal(
        strategy::SearchStrategy, v::AbstractVector, x, hint::Integer;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    i = searchsorted_first(strategy, v, x, hint; order = order)
    return _findequal_postcheck(v, x, i)
end

# Enum-tagged form. `KIND_BISECT_THEN_SIMD` forwards to the struct form so
# the `DenseVector{Int64}` bisect-then-SIMD shortcut is reached — the
# generic `searchsorted_first` path would silently lose it.
@inline function findequal(
        kind::StrategyKind, v::AbstractVector, x;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    kind === KIND_BISECT_THEN_SIMD &&
        return findequal(BisectThenSIMD(), v, x; order = order)
    i = searchsorted_first(kind, v, x; order = order)
    return _findequal_postcheck(v, x, i)
end

@inline function findequal(
        kind::StrategyKind, v::AbstractVector, x, hint::Integer;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    kind === KIND_BISECT_THEN_SIMD &&
        return findequal(BisectThenSIMD(), v, x, hint; order = order)
    i = searchsorted_first(kind, v, x, hint; order = order)
    return _findequal_postcheck(v, x, i)
end

@inline function _findequal_generic_strategy(strategy, v, x, order)
    i = searchsorted_first(strategy, v, x; order = order)
    return _findequal_postcheck(v, x, i)
end

@inline function _findequal_postcheck(v::AbstractVector, x, i::Integer)
    if i > lastindex(v)
        return firstindex(v) - 1
    end
    @inbounds return isequal(v[i], x) ? Int(i) : (firstindex(v) - 1)
end

# Shortcut: BisectThenSIMD on DenseVector{Int64} uses the dedicated
# bisect-then-SIMD equality scan.
function findequal(
        ::BisectThenSIMD, v::DenseVector{Int64}, x::Int64;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    if order !== Base.Order.Forward
        return _findequal_postcheck(v, x, searchsorted_first(KIND_BINARY_BRACKET, v, x; order = order))
    end
    r = findfirstsortedequal(x, v)
    return r === nothing ? (firstindex(v) - 1) : r
end
findequal(
    s::BisectThenSIMD, v::DenseVector{Int64}, x::Int64, ::Integer;
    order::Base.Order.Ordering = Base.Order.Forward,
) = findequal(s, v, x; order = order)

# Non-Int64 fallback for BisectThenSIMD.
function findequal(
        ::BisectThenSIMD, v::AbstractVector, x;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    i = searchsorted_first(KIND_BINARY_BRACKET, v, x; order = order)
    return _findequal_postcheck(v, x, i)
end
findequal(
    s::BisectThenSIMD, v::AbstractVector, x, ::Integer;
    order::Base.Order.Ordering = Base.Order.Forward,
) = findequal(s, v, x; order = order)

# PrecompileTools workload — exercises the most commonly used public
# entry points across typical eltypes so `using FindFirstFunctions` is hot
# without a startup compile spike on the first call.

using PrecompileTools: @compile_workload, @setup_workload

@setup_workload begin
    vec_int64 = Int64[1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16]
    linear_vec = collect(1.0:0.5:10.0)

    @compile_workload begin
        # findfirstequal: fast SIMD-based search in Int64 vectors.
        findfirstequal(Int64(5), vec_int64)
        findfirstequal(Int64(100), vec_int64)

        # findfirstsortedequal: binary search in sorted Int64 vectors.
        findfirstsortedequal(Int64(8), vec_int64)
        findfirstsortedequal(Int64(100), vec_int64)

        # looks_linear: check if vector is evenly spaced.
        looks_linear(linear_vec)

        # Guesser: hint provider for correlated repeated searches.
        guesser = Guesser(linear_vec)
        guesser(5.0)

        # Strategy dispatch — single-query forms across the standard strategies.
        for strategy in (
                LinearScan(), SIMDLinearScan(), BracketGallop(), ExpFromLeft(),
                InterpolationSearch(), BinaryBracket(), Auto(),
                Auto(SearchProperties(linear_vec)),
                Auto(linear_vec),
            )
            searchsorted_first(strategy, vec_int64, Int64(8), Int64(1))
            searchsorted_last(strategy, vec_int64, Int64(8), Int64(1))
        end
        # Auto-with-uniform-range — exercises the props-aware UniformStep kernel.
        let r = 0.0:0.5:10.0
            auto_r = Auto(r)
            searchsorted_last(auto_r, r, 3.7)
            searchsorted_first(auto_r, r, 3.7)
            searchsorted_last(auto_r, r, 3.7, 1)
        end
        # findequal: generic + BisectThenSIMD shortcut for Int64 dense vectors.
        for strategy in (
                BinaryBracket(), BracketGallop(), SIMDLinearScan(),
                BisectThenSIMD(), Auto(),
            )
            findequal(strategy, vec_int64, Int64(8))
            findequal(strategy, vec_int64, Int64(8), Int64(1))
        end
        # SIMDLinearScan's Float64 specialization.
        let vec_f64 = collect(1.0:1.0:16.0)
            searchsorted_first(SIMDLinearScan(), vec_f64, 8.0, 1)
            searchsorted_last(SIMDLinearScan(), vec_f64, 8.0, 1)
        end
        searchsorted_first(GuesserHint(Guesser(vec_int64)), vec_int64, Int64(8))
        searchsorted_last(GuesserHint(Guesser(vec_int64)), vec_int64, Int64(8))

        # Strategy dispatch — batched in-place forms.
        idx_out = Vector{Int}(undef, 4)
        queries = Int64[2, 5, 8, 12]
        searchsortedfirst!(idx_out, vec_int64, queries)
        searchsortedlast!(idx_out, vec_int64, queries)
    end
end

# Enum-tagged dispatch for singleton search strategies.
#
# Each value of `StrategyKind` names one of the singleton, zero-state
# strategies. The pair `searchsorted_last` / `searchsorted_first` is the single public
# entry point: a runtime-tag dispatcher that branches on the enum and
# inlines into the matching kernel function (defined in `kernels.jl`).
#
# An `if/elseif/...` over a `StrategyKind` value is ~0 ns overhead in hot
# loops: the branch is well-predicted (or eliminated by constant
# propagation when the kind is known at the call site), the kernel bodies
# inline, and the return path stays a concrete `Int` even when the kind is
# chosen from runtime data — type-parameter dispatch over `SearchStrategy`
# subtypes would produce `Union` returns in that situation.
#
# Stateful strategies (`GuesserHint(::Guesser)`) do *not* live in the enum.
# They carry per-instance data, so a singleton tag would lose information.
# Instead they dispatch directly via their wrapper struct
# (`searchsorted_last(::GuesserHint, ...)`).

"""
    StrategyKind

Enum tag identifying a singleton search strategy. Use values of this
enum as the first positional argument to [`searchsorted_last`](@ref) and
[`searchsorted_first`](@ref):

```julia
searchsorted_last(KIND_BRACKET_GALLOP, v, x, hint)
```

Each tag corresponds to one of the singleton strategy types
(e.g. `KIND_BRACKET_GALLOP` ↔ `BracketGallop`). Stateful strategies
(`GuesserHint`) do not have an enum tag — they dispatch through their
wrapper struct directly.

The enum is stored as `UInt8` so passing it through to dispatcher
functions costs the same as a `Bool` and does not enlarge any struct
that carries it.
"""
@enum StrategyKind::UInt8 begin
    KIND_BINARY_BRACKET
    KIND_LINEAR_SCAN
    KIND_SIMD_LINEAR_SCAN
    KIND_BRACKET_GALLOP
    KIND_EXP_FROM_LEFT
    KIND_INTERPOLATION_SEARCH
    KIND_BIT_INTERPOLATION_SEARCH
    KIND_UNIFORM_STEP
    KIND_BISECT_THEN_SIMD
end

# Julia 1.10's `@enum` does not accept inline docstrings for individual
# values, so keep per-kind docs immediately next to the enum definition.
"""
    KIND_BINARY_BRACKET::StrategyKind

Select [`BinaryBracket`](@ref FindFirstFunctions.BinaryBracket), the plain
binary-search fallback for positional sorted searches.
""" KIND_BINARY_BRACKET

"""
    KIND_LINEAR_SCAN::StrategyKind

Select [`LinearScan`](@ref FindFirstFunctions.LinearScan), the hinted
strategy that walks linearly from a nearby index.
""" KIND_LINEAR_SCAN

"""
    KIND_SIMD_LINEAR_SCAN::StrategyKind

Select [`SIMDLinearScan`](@ref FindFirstFunctions.SIMDLinearScan), the
hinted linear scan with SIMD-specialized forward walks for supported dense
vectors.
""" KIND_SIMD_LINEAR_SCAN

"""
    KIND_BRACKET_GALLOP::StrategyKind

Select [`BracketGallop`](@ref FindFirstFunctions.BracketGallop), the hinted
strategy that expands a bidirectional exponential bracket before binary
searching inside it.
""" KIND_BRACKET_GALLOP

"""
    KIND_EXP_FROM_LEFT::StrategyKind

Select [`ExpFromLeft`](@ref FindFirstFunctions.ExpFromLeft), the hinted
strategy that treats the hint as a left bound and searches forward
exponentially.
""" KIND_EXP_FROM_LEFT

"""
    KIND_INTERPOLATION_SEARCH::StrategyKind

Select [`InterpolationSearch`](@ref FindFirstFunctions.InterpolationSearch),
the strategy that guesses from linear extrapolation across the vector
endpoints.
""" KIND_INTERPOLATION_SEARCH

"""
    KIND_BIT_INTERPOLATION_SEARCH::StrategyKind

Select
[`BitInterpolationSearch`](@ref FindFirstFunctions.BitInterpolationSearch),
the opt-in interpolation strategy that guesses from Float64 bit patterns.
""" KIND_BIT_INTERPOLATION_SEARCH

"""
    KIND_UNIFORM_STEP::StrategyKind

Select [`UniformStep`](@ref FindFirstFunctions.UniformStep), the direct
arithmetic lookup strategy for uniformly-spaced vectors and ranges.
""" KIND_UNIFORM_STEP

"""
    KIND_BISECT_THEN_SIMD::StrategyKind

Select [`BisectThenSIMD`](@ref FindFirstFunctions.BisectThenSIMD), the
sorted-equality strategy used by [`findequal`](@ref FindFirstFunctions.findequal).
The positional sorted-search dispatch falls back to
[`BinaryBracket`](@ref FindFirstFunctions.BinaryBracket).
""" KIND_BISECT_THEN_SIMD

"""
    searchsorted_last(kind::StrategyKind, v, x[, hint]; order = Base.Order.Forward)
    searchsorted_last(s, v, x[, hint]; order = Base.Order.Forward)

FFF-owned positional search for the largest index `i` with `v[i] ≤ x`
under `order` (or `v[i] ≥ x` under `Base.Order.Reverse`). The polarity
matches `Base.searchsortedlast`.

`v` must be sorted in ascending order under `order`. Like
`Base.searchsortedlast`, the precondition is assumed, not checked — the
result on unsorted `v` is undefined.

When the first argument is a [`StrategyKind`](@ref) value the call
dispatches via a runtime `if/elseif` branch on the enum into the matching
kernel. When the first argument is a stateful strategy wrapper (`Auto`,
`GuesserHint`) the call dispatches via multimethod into that wrapper's
own `searchsorted_last` method.

This is the only search entry point: as of v3, FindFirstFunctions no
longer extends `Base.searchsortedlast` / `Base.searchsortedfirst` with
strategy methods.
"""
@inline function searchsorted_last(
        kind::StrategyKind, v::AbstractVector, x;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    return _searchsorted_last_nohint(kind, v, x, order)
end

@inline function searchsorted_last(
        kind::StrategyKind, v::AbstractVector, x, hint::Integer;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    return _searchsorted_last_hinted(kind, v, x, hint, order)
end

"""
    searchsorted_first(kind::StrategyKind, v, x[, hint]; order = Base.Order.Forward)
    searchsorted_first(s, v, x[, hint]; order = Base.Order.Forward)

FFF-owned positional search for the smallest index `i` with `v[i] ≥ x`
under `order` (or `v[i] ≤ x` under `Base.Order.Reverse`). As with
[`searchsorted_last`](@ref), `v` must be sorted in ascending order under
`order` (assumed, not checked). See [`searchsorted_last`](@ref) for the
dispatch story.
"""
@inline function searchsorted_first(
        kind::StrategyKind, v::AbstractVector, x;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    return _searchsorted_first_nohint(kind, v, x, order)
end

@inline function searchsorted_first(
        kind::StrategyKind, v::AbstractVector, x, hint::Integer;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    return _searchsorted_first_hinted(kind, v, x, hint, order)
end

# ---------------------------------------------------------------------------
# The dispatch switches. One per (polarity, hint-presence) pair. Each one
# is a single `if/elseif/.../end` over the enum value — the branch is
# well-predicted at runtime and the body inlines.
#
# The kernel-function names follow a consistent scheme:
#   `_kernel_last_<strategy>` / `_kernel_first_<strategy>`
# The "no hint" entry points for hint-using strategies fall back to
# BinaryBracket internally (the existing semantics), and the hinted
# entry points for hint-ignoring strategies (BinaryBracket, BisectThenSIMD)
# discard the hint.
# ---------------------------------------------------------------------------

@inline function _searchsorted_last_hinted(
        kind::StrategyKind, v::AbstractVector, x, hint::Integer,
        order::Base.Order.Ordering,
    )
    if kind === KIND_BINARY_BRACKET
        return _kernel_last_binary_bracket(v, x, order)
    elseif kind === KIND_LINEAR_SCAN
        return _kernel_last_linear_scan(v, x, hint, order)
    elseif kind === KIND_SIMD_LINEAR_SCAN
        return _kernel_last_simd_linear_scan(v, x, hint, order)
    elseif kind === KIND_BRACKET_GALLOP
        return _kernel_last_bracket_gallop(v, x, hint, order)
    elseif kind === KIND_EXP_FROM_LEFT
        return _kernel_last_exp_from_left(v, x, hint, order)
    elseif kind === KIND_INTERPOLATION_SEARCH
        return _kernel_last_interpolation_search(v, x, order)
    elseif kind === KIND_BIT_INTERPOLATION_SEARCH
        return _kernel_last_bit_interpolation_search(v, x, order)
    elseif kind === KIND_UNIFORM_STEP
        return _kernel_last_uniform_step(v, x, order)
    else
        # KIND_BISECT_THEN_SIMD — equality-search strategy; positional
        # dispatch falls back to BinaryBracket.
        return _kernel_last_binary_bracket(v, x, order)
    end
end

@inline function _searchsorted_last_nohint(
        kind::StrategyKind, v::AbstractVector, x,
        order::Base.Order.Ordering,
    )
    if kind === KIND_BINARY_BRACKET
        return _kernel_last_binary_bracket(v, x, order)
    elseif kind === KIND_LINEAR_SCAN
        # No hint → BinaryBracket fallback.
        return _kernel_last_binary_bracket(v, x, order)
    elseif kind === KIND_SIMD_LINEAR_SCAN
        return _kernel_last_binary_bracket(v, x, order)
    elseif kind === KIND_BRACKET_GALLOP
        return _kernel_last_binary_bracket(v, x, order)
    elseif kind === KIND_EXP_FROM_LEFT
        return _kernel_last_binary_bracket(v, x, order)
    elseif kind === KIND_INTERPOLATION_SEARCH
        return _kernel_last_interpolation_search(v, x, order)
    elseif kind === KIND_BIT_INTERPOLATION_SEARCH
        return _kernel_last_bit_interpolation_search(v, x, order)
    elseif kind === KIND_UNIFORM_STEP
        return _kernel_last_uniform_step(v, x, order)
    else
        return _kernel_last_binary_bracket(v, x, order)
    end
end

@inline function _searchsorted_first_hinted(
        kind::StrategyKind, v::AbstractVector, x, hint::Integer,
        order::Base.Order.Ordering,
    )
    if kind === KIND_BINARY_BRACKET
        return _kernel_first_binary_bracket(v, x, order)
    elseif kind === KIND_LINEAR_SCAN
        return _kernel_first_linear_scan(v, x, hint, order)
    elseif kind === KIND_SIMD_LINEAR_SCAN
        return _kernel_first_simd_linear_scan(v, x, hint, order)
    elseif kind === KIND_BRACKET_GALLOP
        return _kernel_first_bracket_gallop(v, x, hint, order)
    elseif kind === KIND_EXP_FROM_LEFT
        return _kernel_first_exp_from_left(v, x, hint, order)
    elseif kind === KIND_INTERPOLATION_SEARCH
        return _kernel_first_interpolation_search(v, x, order)
    elseif kind === KIND_BIT_INTERPOLATION_SEARCH
        return _kernel_first_bit_interpolation_search(v, x, order)
    elseif kind === KIND_UNIFORM_STEP
        return _kernel_first_uniform_step(v, x, order)
    else
        return _kernel_first_binary_bracket(v, x, order)
    end
end

@inline function _searchsorted_first_nohint(
        kind::StrategyKind, v::AbstractVector, x,
        order::Base.Order.Ordering,
    )
    if kind === KIND_BINARY_BRACKET
        return _kernel_first_binary_bracket(v, x, order)
    elseif kind === KIND_LINEAR_SCAN
        return _kernel_first_binary_bracket(v, x, order)
    elseif kind === KIND_SIMD_LINEAR_SCAN
        return _kernel_first_binary_bracket(v, x, order)
    elseif kind === KIND_BRACKET_GALLOP
        return _kernel_first_binary_bracket(v, x, order)
    elseif kind === KIND_EXP_FROM_LEFT
        return _kernel_first_binary_bracket(v, x, order)
    elseif kind === KIND_INTERPOLATION_SEARCH
        return _kernel_first_interpolation_search(v, x, order)
    elseif kind === KIND_BIT_INTERPOLATION_SEARCH
        return _kernel_first_bit_interpolation_search(v, x, order)
    elseif kind === KIND_UNIFORM_STEP
        return _kernel_first_uniform_step(v, x, order)
    else
        return _kernel_first_binary_bracket(v, x, order)
    end
end

# ---------------------------------------------------------------------------
# Per-strategy kind lookup. Methods live in `strategy_kind.jl`; used by
# the struct-valued `searchsorted_last` / `searchsorted_first` entry points and by
# callers that need to convert a strategy struct to its enum tag.
# ---------------------------------------------------------------------------

"""
    strategy_kind(s::SearchStrategy) -> StrategyKind

Map a singleton strategy struct to its enum tag. `Auto` returns its
stored resolved kind. `GuesserHint` (genuinely stateful, no singleton
tag) throws `ArgumentError`.
"""
function strategy_kind end

using FindFirstFunctions, StableRNGs, BenchmarkTools, Statistics, Printf

const F = FindFirstFunctions

# Strategies under test. BitInterp is the one we're vetting; the others are
# the alternatives `Auto` might pick or that a user might pin.
const STRATS = [
    ("BitInterp", F.BitInterpolationSearch()),
    ("Interp", F.InterpolationSearch()),
    ("Bracket", F.BracketGallop()),
    ("Exp", F.ExpFromLeft()),
    ("SIMD", F.SIMDLinearScan()),
    ("Auto", F.Auto()),
]

# Data shapes covering the regimes BitInterp could conceivably win.
function build_v(::Val{:uniform}, n, seed)
    return collect(range(1.0, Float64(n); length = n))
end
function build_v(::Val{:logspaced}, n, seed)
    return collect(exp.(range(0.0, log(1.0e6); length = n)))
end
function build_v(::Val{:logspaced_wide}, n, seed)
    # 10⁻³ to 10¹⁵ — ~18 decades, like a particle-physics interpolation table
    return collect(exp.(range(log(1.0e-3), log(1.0e15); length = n)))
end
function build_v(::Val{:geometric_dense}, n, seed)
    # Geometric with ratio chosen so the series spans 10⁶ — keeps Float64
    # range usable up to n ≈ 10⁷ while keeping the spacing tight.
    r = (1.0e6)^(1.0 / max(n - 1, 1))
    return collect(r .^ (0:(n - 1)))
end
function build_v(::Val{:geometric_sparse}, n, seed)
    # Geometric spanning 10¹² with sparser spacing.
    r = (1.0e12)^(1.0 / max(n - 1, 1))
    return collect(r .^ (0:(n - 1)))
end
function build_v(::Val{:power2}, n, seed)
    return collect(Float64(i)^2 for i in 1:n)
end
function build_v(::Val{:sqrt}, n, seed)
    return collect(sqrt(Float64(i)) for i in 1:n)
end
function build_v(::Val{:two_decade}, n, seed)
    # 80% of values in [1, 2], 20% in [2, 1e6] — extreme density-then-sparse
    h = (8n) ÷ 10
    a = collect(range(1.0, 2.0; length = h))
    b = collect(exp.(range(log(2.0), log(1.0e6); length = n - h)))
    return sort!(vcat(a[1:(end - 1)], b))
end
function build_v(::Val{:jittered_log}, n, seed)
    base = collect(exp.(range(0.0, log(1.0e6); length = n)))
    rng = StableRNG(seed)
    return sort!(base .* (1.0 .+ 0.01 .* (rand(rng, n) .- 0.5)))
end

function build_q(v, m, kind::Symbol, seed)
    rng = StableRNG(seed)
    if kind == :linear_uniform
        # m queries uniformly random in v's full LINEAR range
        return sort!(first(v) .+ rand(rng, m) .* (last(v) - first(v)))
    elseif kind == :log_uniform
        # m queries uniformly random in v's full LOG range — matches the
        # distribution of log-spaced v itself
        first(v) > 0 || error("log_uniform requires positive v")
        return sort!(
            exp.(log(first(v)) .+ rand(rng, m) .* (log(last(v)) - log(first(v))))
        )
    elseif kind == :dense_grid
        # Evenly-spaced linear grid
        return collect(range(first(v), last(v); length = m))
    elseif kind == :log_grid
        first(v) > 0 || error("log_grid requires positive v")
        return collect(exp.(range(log(first(v)), log(last(v)); length = m)))
    else
        error("unknown q kind: $kind")
    end
end

function bench_cell(v, q, strat, out, reps = 5)
    F.searchsortedlast!(out, v, q; strategy = strat)
    best = typemax(Float64)
    for _ in 1:reps
        t = @elapsed F.searchsortedlast!(out, v, q; strategy = strat)
        best = min(best, t)
    end
    return best * 1.0e9 / length(q)
end

function correctness_check(v, q, strat)
    out = Vector{Int}(undef, length(q))
    expected = searchsortedlast.(Ref(v), q)
    F.searchsortedlast!(out, v, q; strategy = strat)
    return out == expected
end

println("BitInterpolationSearch comprehensive sweep")
println("="^70)
println("Testing where BitInterp might win across spacing × density × n × m")
println()

# Multiple seeds for noise reduction
function run_sweep()
    v_kinds = (
        :uniform, :logspaced, :logspaced_wide,
        :geometric_dense, :geometric_sparse,
        :power2, :sqrt, :two_decade, :jittered_log,
    )
    q_kinds = (:linear_uniform, :log_uniform, :dense_grid, :log_grid)
    ns = (1024, 4096, 16_384, 65_536, 262_144, 1_048_576)
    ms = (4, 16, 64, 256, 1024, 4096, 16_384)

    rows = []
    bit_wins = 0
    bit_within10 = 0  # within 10% of best
    bit_within20 = 0  # within 20% of best
    total = 0

    for v_kind in v_kinds, q_kind in q_kinds, n in ns, m in ms
        m > n && continue
        v = build_v(Val(v_kind), n, 2026)
        # Some q_kinds require positive v
        if (q_kind == :log_uniform || q_kind == :log_grid) && first(v) <= 0
            continue
        end
        q = build_q(v, m, q_kind, 2027)
        out = Vector{Int}(undef, m)

        # Correctness first — bail loudly if mismatch.
        correctness_check(v, q, F.BitInterpolationSearch()) ||
            error("BitInterp correctness fail on $v_kind/$q_kind n=$n m=$m")

        times = Dict{String, Float64}()
        for (name, strat) in STRATS
            times[name] = bench_cell(v, q, strat, out)
        end
        push!(rows, (v_kind, q_kind, n, m, times))

        # Score
        explicit = [(n, t) for (n, t) in pairs(times) if n != "Auto"]
        best_t = minimum(t for (_, t) in explicit)
        bit_t = times["BitInterp"]
        if bit_t <= best_t
            bit_wins += 1
        end
        if bit_t <= 1.1 * best_t
            bit_within10 += 1
        end
        if bit_t <= 1.2 * best_t
            bit_within20 += 1
        end
        total += 1
    end

    println("Cells tested: $total")
    @printf(
        "BitInterp wins outright:   %d cells (%.1f%%)\n",
        bit_wins, 100 * bit_wins / total
    )
    @printf(
        "BitInterp within 10%% of best: %d cells (%.1f%%)\n",
        bit_within10, 100 * bit_within10 / total
    )
    @printf(
        "BitInterp within 20%% of best: %d cells (%.1f%%)\n",
        bit_within20, 100 * bit_within20 / total
    )
    println()

    # If BitInterp wins anywhere, show those cells.
    win_rows = [
        r for r in rows if begin
                explicit = [(n, t) for (n, t) in pairs(r[5]) if n != "Auto"]
                best_t = minimum(t for (_, t) in explicit)
                r[5]["BitInterp"] <= best_t
            end
    ]
    if !isempty(win_rows)
        println("Cells where BitInterp wins:")
        @printf(
            "  %-16s %-14s %8s %6s   %-10s vs second-best\n",
            "v_kind", "q_kind", "n", "m", "BitInterp"
        )
        for (v_kind, q_kind, n, m, times) in win_rows
            explicit = sort(
                [(name, t) for (name, t) in pairs(times) if name != "Auto"];
                by = x -> x[2]
            )
            second = explicit[2]
            @printf(
                "  %-16s %-14s %8d %6d   %5.1f ns/q  vs %s=%5.1f (%.2fx)\n",
                v_kind, q_kind, n, m, times["BitInterp"],
                second[1], second[2], second[2] / times["BitInterp"]
            )
        end
        println()
    end

    # Show the cells where BitInterp is closest to winning (top 10).
    closest = sort(
        rows; by = r -> begin
            explicit = [(n, t) for (n, t) in pairs(r[5]) if n != "Auto"]
            best_t = minimum(t for (_, t) in explicit)
            r[5]["BitInterp"] / best_t
        end
    )
    println("Closest 10 cells (BitInterp/best ratio):")
    @printf(
        "  %-16s %-14s %8s %6s   %-10s ratio winner\n",
        "v_kind", "q_kind", "n", "m", "BitInterp"
    )
    for (v_kind, q_kind, n, m, times) in closest[1:min(10, end)]
        explicit = [(name, t) for (name, t) in pairs(times) if name != "Auto"]
        best_t = minimum(t for (_, t) in explicit)
        winner = first(sort(explicit; by = x -> x[2]))
        @printf(
            "  %-16s %-14s %8d %6d   %5.1f ns/q  %.2fx  %s\n",
            v_kind, q_kind, n, m, times["BitInterp"],
            times["BitInterp"] / best_t, winner[1]
        )
    end

    return rows
end

@time run_sweep()

using SciMLTesting, FindFirstFunctions, JET, Test

run_qa(
    FindFirstFunctions;
    # Custom LLVM IR has no public Julia entry point; Base.llvmcall is the compiler
    # intrinsic required by the package's SIMD kernels.
    ei_kwargs = (; all_qualified_accesses_are_public = (; ignore = (:llvmcall,))),
)

# Equality-search public surface. `findfirstequal` handles unsorted vectors
# (with a SIMD specialization for `DenseVector{Int64}`); `findfirstsortedequal`
# handles sorted vectors via bisect-then-SIMD. The strategy-framework
# wrapper `findequal(strategy, v, x)` lives in `findequal.jl`.

"""
    findfirstequal(x, A) -> Union{Int, Nothing}

Find the first index in `A` where the value equals `x`. Returns `nothing`
if `x` does not occur in `A`.

This function does **not** assume `A` is sorted. For sorted vectors, see
[`findfirstsortedequal`](@ref) (a bisect-then-SIMD specialization on
`DenseVector{Int64}`) or [`findequal`](@ref) (the strategy-framework
equality wrapper that returns an `Int` with a sentinel).

On 64-bit platforms the `(x::Int64, A::DenseVector{Int64})` method uses a
custom LLVM IR SIMD scan (load 8 lanes, `icmp eq`, `cttz` on the mask) —
about 8× faster than the scalar `findfirst(==(x), v)` on modern x86-64;
on 32-bit platforms it uses a scalar loop. Every other element-type
and array-storage combination falls back to `findfirst(isequal(x), A)`.
"""
findfirstequal(vpivot, ivars) = findfirst(isequal(vpivot), ivars)
function findfirstequal(vpivot::Int64, ivars::DenseVector{Int64})
    GC.@preserve ivars begin
        ret = _findfirstequal(vpivot, pointer(ivars), Int64(length(ivars)))
    end
    return ret < 0 ? nothing : ret + 1
end

"""
    findfirstsortedequal(var::Int64, vars::DenseVector{Int64}) -> Union{Int64, Nothing}

Find the index of the first occurrence of `var` in the sorted vector
`vars`. Returns `nothing` if `var` does not occur. Specialized for
`DenseVector{Int64}` via a branchless binary bisection down to a small
basecase, followed by the same SIMD equality scan that backs
[`findfirstequal`](@ref) — faster than plain `findfirst(==(var), vars)`
or `searchsortedfirst` + post-check for typical Int64 vectors. Every
other element-type and array-storage combination (including native `Int`
on 32-bit platforms, where `Int` is not `Int64`) falls back to a generic
`searchsortedfirst` + equality post-check.

The strategy-framework equivalent is
[`findequal(BisectThenSIMD(), vars, var)`](@ref findequal); that wrapper
returns an `Int` with a sentinel (`firstindex(v) - 1`) for "not found",
which is type-stable and composes with the rest of the strategy
dispatch. Prefer `findequal` for new code; `findfirstsortedequal` remains
as the dedicated `Union{Int64, Nothing}`-returning name.
"""
function findfirstsortedequal(var, vars)
    i = searchsortedfirst(vars, var)
    return (i <= lastindex(vars) && isequal(@inbounds(vars[i]), var)) ? i : nothing
end
function findfirstsortedequal(
        var::Int64,
        vars::DenseVector{Int64},
        ::Val{basecase} = VERSION >= v"1.12" ? Val(8) : Val(128),
    ) where {basecase}
    len = length(vars)
    offset = 0
    @inbounds while len > basecase
        # Bisect with the predicate `vars[mid] < var` (strict). When true,
        # `var` is past the midpoint — drop the left half *and* the
        # midpoint itself. When false (`vars[mid] >= var`), `var` may be
        # at the midpoint, so keep `offset` and shrink the window to
        # `vars[offset+1 .. offset+half+1]` (inclusive of the midpoint).
        # The earlier `<=` predicate would have advanced past matching
        # midpoints, masking earlier duplicates of `var`.
        half = len >>> 1
        mid = offset + half + 1
        is_left_strictly_less = vars[mid] < var
        offset = ifelse(is_left_strictly_less, offset + half + 1, offset)
        len = ifelse(is_left_strictly_less, len - half - 1, half + 1)
    end
    # maybe occurs in vars[offset+1:offset+len]
    GC.@preserve vars begin
        ret = _findfirstequal(var, pointer(vars) + 8offset, Int64(len))
    end
    return ret < 0 ? nothing : ret + offset + 1
end

# `Guesser` correlated-lookup helper + the public `looks_linear` probe it
# uses + the `GuesserHint` strategy dispatch that plugs a `Guesser` into
# the v3 `searchsorted_last` / `searchsorted_first` API.

"""
    looks_linear(v; threshold = 1e-2)

Determine if the abscissae `v` are regularly distributed.
"""
function looks_linear(v; threshold = 1.0e-2)
    length(v) <= 2 && return true
    x_0, x_f = first(v), last(v)
    N = length(v)
    x_span = x_f - x_0
    mean_x_dist = x_span / (N - 1)
    norm_var = sum((x_i - x_0 - (i - 1) * mean_x_dist)^2 for (i, x_i) in enumerate(v)) /
        (N * x_span^2)
    return norm_var < threshold^2
end

"""
    Guesser(v::AbstractVector; looks_linear_threshold = 1e-2)

Wrapper of the searched vector `v` which makes an informed guess for the
next correlated lookup by either

  - exploiting that `v` is sufficiently evenly spaced (linear-extrapolation
    guess), or
  - using the previous outcome (the cached `idx_prev`).
"""
struct Guesser{T <: AbstractVector}
    v::T
    idx_prev::typeof(Ref(1))
    linear_lookup::Bool
end

function Guesser(v::AbstractVector; looks_linear_threshold = 1.0e-2)
    return Guesser(v, Ref(1), looks_linear(v; threshold = looks_linear_threshold))
end

function (g::Guesser)(x)
    (; v, idx_prev, linear_lookup) = g
    return if linear_lookup
        δx = x - first(v)
        iszero(δx) && return firstindex(v)
        f = δx / (last(v) - first(v))
        if isinf(f)
            f > 0 ? lastindex(v) : firstindex(v)
        else
            i_0, i_f = firstindex(v), lastindex(v)
            i_approx = f * (i_f - i_0) + i_0
            target_type = typeof(firstindex(v))
            if i_approx >= typemax(target_type)
                lastindex(v) + 1
            elseif i_approx <= typemin(target_type)
                firstindex(v) - 1
            else
                round(target_type, i_approx)
            end
        end
    else
        idx_prev[]
    end
end

# GuesserHint methods — stateful strategy, dispatches via its wrapper
# struct (not via a `StrategyKind`). The cost per call is one
# `guesser(x)` + one BracketGallop call + one `idx_prev[]` write.

@inline function searchsorted_last(
        s::GuesserHint, v::AbstractVector, x;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    @assert v === s.guesser.v
    out = searchsorted_last(KIND_BRACKET_GALLOP, v, x, s.guesser(x); order = order)
    s.guesser.idx_prev[] = out
    return out
end

@inline function searchsorted_first(
        s::GuesserHint, v::AbstractVector, x;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    @assert v === s.guesser.v
    out = searchsorted_first(KIND_BRACKET_GALLOP, v, x, s.guesser(x); order = order)
    s.guesser.idx_prev[] = out
    return out
end

# GuesserHint ignores any externally-supplied hint.
@inline searchsorted_last(
    s::GuesserHint, v::AbstractVector, x, ::Integer;
    order::Base.Order.Ordering = Base.Order.Forward,
) = searchsorted_last(s, v, x; order = order)
@inline searchsorted_first(
    s::GuesserHint, v::AbstractVector, x, ::Integer;
    order::Base.Order.Ordering = Base.Order.Forward,
) = searchsorted_first(s, v, x; order = order)

module FindFirstFunctions

# Public API surface for `using FindFirstFunctions`. The strategy types are
# zero-field singletons (except `GuesserHint` and `Auto`, which carry
# small isbits payloads), so exporting them only adds names to the
# caller's namespace — no runtime cost.
#
# v3 replaces the v2 `Base.searchsortedlast(::S, ...)` extensions with
# the FFF-owned `searchsorted_last` / `searchsorted_first` dispatchers, which accept
# a `StrategyKind` tag, a strategy struct, or a stateful strategy
# (`Auto`, `GuesserHint`). FFF no longer extends `Base.searchsortedlast`
# or `Base.searchsortedfirst`.
export
    # Abstract type + concrete singleton strategies (friendly strategy values).
    SearchStrategy,
    LinearScan, SIMDLinearScan, BracketGallop, ExpFromLeft,
    InterpolationSearch, BitInterpolationSearch,
    BinaryBracket, UniformStep, BisectThenSIMD,
    # Stateful strategies.
    GuesserHint, Auto,
    # Properties / helpers.
    SearchProperties,
    Guesser, looks_linear,
    # Enum + dispatchers.
    StrategyKind,
    KIND_BINARY_BRACKET, KIND_LINEAR_SCAN, KIND_SIMD_LINEAR_SCAN,
    KIND_BRACKET_GALLOP, KIND_EXP_FROM_LEFT,
    KIND_INTERPOLATION_SEARCH, KIND_BIT_INTERPOLATION_SEARCH,
    KIND_UNIFORM_STEP, KIND_BISECT_THEN_SIMD,
    searchsorted_last, searchsorted_first, strategy_kind,
    # Batched API.
    searchsortedfirst!, searchsortedlast!, searchsortedrange,
    # Equality search.
    findequal, findfirstequal, findfirstsortedequal

# Julia 1.12 changed how `Ptr{T}` arguments to `Base.llvmcall` are passed.
const USE_PTR = VERSION >= v"1.12.0-DEV.255"

# Source layout. Include order matters — each file may depend on names
# defined in earlier files.
include("simd_ir.jl")             # IR template + SIMD primitives
include("equality.jl")            # findfirstequal + findfirstsortedequal
include("kinds.jl")               # StrategyKind enum + searchsorted_last / searchsorted_first dispatchers
include("strategies.jl")          # SearchStrategy + concrete strategy types + SearchProperties + Auto
include("search_properties.jl")   # Linearity / NaN probes + populated SearchProperties constructor
include("kernels.jl")             # Per-strategy kernel functions called by the dispatchers
include("strategy_kind.jl")       # strategy struct → kind mapping + struct-valued search entry points
include("auto.jl")                # Auto helpers + _auto_resolve_kind + Auto dispatch
include("batched.jl")             # Batched API + Auto batched specialization
include("guesser.jl")             # looks_linear + Guesser + GuesserHint dispatch
include("findequal.jl")           # findequal + BisectThenSIMD shortcut
include("precompile.jl")          # PrecompileTools workload

end # module FindFirstFunctions

# `SearchProperties` populated constructor + the runtime probes it runs at
# construction time. The `SearchProperties` struct itself, the default
# constructor (`SearchProperties()` sentinel), and the `Auto` type that
# carries one as a field all live in `strategies.jl`.

# `has_nan` is only meaningful for floating-point eltypes; for other numeric
# types and non-numeric eltypes there is no NaN concept.
@inline _has_nan(v::AbstractVector{<:AbstractFloat}) = any(isnan, v)
@inline _has_nan(::AbstractVector) = false

# Auto's strict linearity tolerance. `SearchProperties(v)` uses the same
# default. Defined here rather than in `auto.jl` because `_sampled_looks_*`
# need it as a default arg; `auto.jl` re-uses the same constant.
const _AUTO_LINEAR_REL_TOLERANCE = 1.0e-3

# Sampled linearity check: probes v[1], v[k*n/10] for k = 1..9, v[n] and
# computes the maximum relative deviation of the 9 interior points from
# the straight line between v[1] and v[n]. Returns the max relative error
# (or `Inf` if `v` is unsuitable — too short, zero/infinite span, etc.).
#
# A single scan produces several different bool flags by comparing the
# returned error against different tolerances:
#
#   - `_AUTO_LINEAR_REL_TOLERANCE` (default 0.1%) gates `InterpolationSearch`
#     in Auto's batched dispatch.
#   - `_AUTO_LINEAR_LOOSE_TOLERANCE` (5%) for the large-gap regime.
#   - `_UNIFORM_REL_TOLERANCE` (~1e-12, a few ulp) flags
#     exactly-uniformly-spaced data so `SearchProperties` can set
#     `is_uniform` for any `AbstractVector` (not just `AbstractRange`).
#
# Cost is ~25 ns regardless of n — 11 reads + 9 multiply/add + 9 compares.
# Tight tolerance reliably distinguishes truly-uniform data from random
# sorted data even at large n (where order-statistic variance ≈ 1/sqrt(n)
# would fool a looser check).
@inline function _sampled_linear_err(
        v::AbstractVector{<:Number},
    )
    n = length(v)
    n < 11 && return Inf
    @inbounds begin
        v1, vn = v[1], v[n]
        span = vn - v1
        (iszero(span) || !isfinite(span)) && return Inf
        abs_span = abs(span)
        nm1 = n - 1
        max_err = 0.0
        for k in 1:9
            kk = 1 + (k * nm1) ÷ 10
            expected = v1 + (kk - 1) / nm1 * span
            rel_err = abs(v[kk] - expected) / abs_span
            rel_err > max_err && (max_err = rel_err)
        end
        return max_err
    end
end

# Non-numeric eltype: can't sample. Returns Inf so every tolerance check fails.
@inline _sampled_linear_err(::AbstractVector) = Inf

# AbstractRange is definitionally uniform — error is zero by construction.
@inline _sampled_linear_err(::AbstractRange) = 0.0

# Tolerance treating "uniform" as a few ulp of accumulated float roundoff.
# `collect(0.0:0.1:10.0)` has rel_err ≈ 1e-16 to 1e-15 from float-step
# imprecision; `1e-12` accepts it cleanly. Random / jittered data at any
# n has rel_err well above this. The constant is conservative — tightening
# further would risk false negatives on long Float ranges.
const _UNIFORM_REL_TOLERANCE = 1.0e-12

@inline _sampled_looks_linear(
    v::AbstractVector, tol::Float64 = _AUTO_LINEAR_REL_TOLERANCE,
) = _sampled_linear_err(v) <= tol

# Exact uniformity validation: checks EVERY element against the straight
# line between the endpoints, not just the 11 sampled points. `is_uniform`
# gates closed-form O(1) lookups whose answers are silently wrong when the
# flag is a false positive, so a sampled probe is not enough — data that is
# uniform at the sampled points but jittered between them must be rejected.
# Only run when the cheap sampled probe already passed, so the O(n) cost is
# paid exactly once at construction and only for plausibly-uniform data.
function _validated_uniform(v::AbstractVector{<:Real})
    n = length(v)
    n < 2 && return false
    @inbounds begin
        v1, vn = v[1], v[n]
        span = vn - v1
        (iszero(span) || !isfinite(span)) && return false
        nm1 = n - 1
        for i in 2:nm1
            expected = v1 + (i - 1) / nm1 * span
            abs(v[i] - expected) > _UNIFORM_REL_TOLERANCE * abs(span) &&
                return false
        end
    end
    return true
end

# Sampled "log-linear" probe: same 9-point probe as `_sampled_looks_linear`
# but tests whether `log(v)` is linear in array index. Used to detect
# geometric / log-spaced data where `BitInterpolationSearch` is a win.
# Requires all sampled points to be strictly positive and finite; otherwise
# returns false. The probe runs in ~30 ns (the `log` calls are not cheap
# but only 11 of them, all at fixed index positions).
@inline function _sampled_looks_log_linear(
        v::AbstractVector{<:Real},
        tol::Float64 = _AUTO_LINEAR_REL_TOLERANCE,
    )
    n = length(v)
    n < 11 && return false
    @inbounds begin
        v1, vn = v[1], v[n]
        (v1 <= 0 || vn <= 0 || !isfinite(v1) || !isfinite(vn)) && return false
        log_v1 = log(v1)
        log_vn = log(vn)
        span = log_vn - log_v1
        (iszero(span) || !isfinite(span)) && return false
        abs_span = abs(span)
        nm1 = n - 1
        for k in 1:9
            kk = 1 + (k * nm1) ÷ 10
            vk = v[kk]
            (vk <= 0 || !isfinite(vk)) && return false
            expected = log_v1 + (kk - 1) / nm1 * span
            rel_err = abs(log(vk) - expected) / abs_span
            rel_err > tol && return false
        end
    end
    return true
end

@inline _sampled_looks_log_linear(::AbstractVector, ::Float64 = _AUTO_LINEAR_REL_TOLERANCE) = false

"""
    SearchProperties(v::AbstractVector; linear_tolerance = 1.0e-3, is_uniform = nothing)

Run the linearity probe and (for floating-point eltypes) the NaN scan on `v`,
returning the populated [`SearchProperties{T}`](@ref) where `T` is the data
ratio type (e.g. `Float64` for `Vector{Int}` or `Vector{Float64}`,
`Float32` for `Vector{Float32}`). Cost is O(n) on floating-point vectors
because of the NaN scan; for integer eltypes the cost is O(1) (only the
sampled-linearity probe runs) unless the sampled probe flags the data as
uniform, in which case an exact O(n) validation scan confirms it.

`linear_tolerance` controls the maximum relative deviation accepted by the
sampled-linearity probe. The default `1e-3` (0.1%) matches `Auto`'s
un-cached probe behaviour. Loosen it (e.g. to `1e-2`) to accept noisier
"approximately linear" data — this widens the regime where `Auto` will pick
`InterpolationSearch` over `ExpFromLeft`. Tighten it (e.g. to `1e-4`) to be
more conservative.

`is_uniform` is a caller-supplied flag for `Vector`s that are exactly
uniformly spaced. Setting it `true` opts the vector into
[`UniformStep`](@ref)'s closed-form O(1) path via `Auto`. The default
`nothing` infers from the tight uniformity probe. When `true` (either
detected or supplied), `first_val` and `inv_step` are computed and stored
in the result so `UniformStep`'s closed-form path needs no per-query
division.
"""
function SearchProperties(
        v::AbstractVector{<:Real};
        linear_tolerance::Real = 1.0e-3,
        is_uniform::Union{Nothing, Bool} = nothing,
    )
    T = _ratio_type(eltype(v))
    tol = Float64(linear_tolerance)
    # One scan produces both `is_linear` and the uniformity-deviation
    # check. `is_uniform = nothing` (default) means "infer from the
    # probe"; an explicit Bool overrides.
    err = _sampled_linear_err(v)
    # The sampled probe is a cheap pre-filter; a positive is confirmed by
    # an exact full scan because `is_uniform` gates closed-form lookups
    # that would silently return wrong answers on a false positive. An
    # explicit caller-supplied Bool skips both probes.
    detected_uniform = err <= _UNIFORM_REL_TOLERANCE && _validated_uniform(v)
    flag_uniform = is_uniform === nothing ? detected_uniform : is_uniform
    first_val, inv_step = if flag_uniform && length(v) >= 2
        # Closed-form `inv_step` from sampled endpoints. Promotes Int → Float64.
        @inbounds T(v[1]), T(length(v) - 1) / T(v[end] - v[1])
    else
        zero(T), zero(T)
    end
    return SearchProperties{T}(
        true,
        err <= tol,
        _has_nan(v),
        _sampled_looks_log_linear(v, tol),
        flag_uniform,
        first_val,
        inv_step,
    )
end

# Non-Real numeric eltype (e.g. Unitful `Quantity`, `Complex`): scalar
# conversion `T(::Quantity)` is unsafe (dimensional / non-Real), so we
# can't bake `first_val` / `inv_step` into the struct. Run the linearity
# probe (which only requires `Number` arithmetic) to populate
# `is_linear` / `has_nan` / `is_log_linear`, but leave `is_uniform = false`
# so the closed-form UniformStep kernel is never invoked.
function SearchProperties(
        v::AbstractVector{<:Number};
        linear_tolerance::Real = 1.0e-3,
        is_uniform::Union{Nothing, Bool} = nothing,
    )
    tol = Float64(linear_tolerance)
    err = _sampled_linear_err(v)
    return SearchProperties{Float64}(
        true,
        err <= tol,
        _has_nan(v),
        _sampled_looks_log_linear(v, tol),
        false,                       # never uniform — closed-form unsafe.
        0.0, 0.0,
    )
end

# Non-numeric eltype: `Float64` default T, `has_props = false`. Probes are
# meaningless on non-Number data, so the result is the sentinel value.
function SearchProperties(
        v::AbstractVector;
        linear_tolerance::Real = 1.0e-3,
        is_uniform::Union{Nothing, Bool} = nothing,
    )
    return SearchProperties()
end

"""
    SearchProperties(v::AbstractRange; linear_tolerance = 1.0e-3)

Specialised constructor for `AbstractRange{<:Real}`. Skips every runtime
probe — every property is known statically from the type:

  - `is_linear = true` — ranges are linear in index by construction.
  - `is_uniform = true` — ranges have exact uniform spacing.
  - `has_nan = false` — `AbstractRange{<:Real}` values are computed from
    `first(r) + (i - 1) * step(r)`; barring `first(r)` or `step(r)`
    themselves being NaN, the values are all finite. For the rare
    pathological `LinRange(NaN, …, …)` case the caller is on their own.
  - `is_log_linear = false` — a range that's linear in index is *not*
    log-linear in value (the values are arithmetically, not
    geometrically, spaced). The flag would only be `true` for ranges of
    `exp(x)` values, which Julia represents as a `Vector`, not an
    `AbstractRange`.

The `first_val` and `inv_step` fields are populated from `first(r)` and
`1/step(r)` to skip the per-query division in `UniformStep`'s closed-form
path.

`linear_tolerance` is accepted for signature compatibility but ignored
— the probes are skipped.
"""
function SearchProperties(
        v::AbstractRange{<:Real};
        linear_tolerance::Real = 1.0e-3,
    )
    T = _ratio_type(eltype(v))
    first_val, inv_step = if length(v) >= 1
        f = T(first(v))
        s = T(step(v))
        if iszero(s)
            f, zero(T)
        else
            f, one(T) / s
        end
    else
        zero(T), zero(T)
    end
    return SearchProperties{T}(
        true, true, false, false, true, first_val, inv_step,
    )
end

# In-place batched sorted-search API: `searchsortedfirst!` /
# `searchsortedlast!` and `searchsortedrange`, plus the internal
# `_batched!` dispatchers and the Auto-specific specialization that turns
# Auto's decision tree into a single dispatch on a concrete kind.

"""
    searchsortedlast!(idx_out, v, queries; strategy = Auto(), order = Base.Order.Forward,
                       queries_sorted = nothing)

In-place batched `Base.searchsortedlast`. Writes
one index per element of `queries` into `idx_out` (which must be the same
length).

If `queries` is sorted under `order`, the previous result is used as a
hint for the next query, so the total cost is O(length(v) + length(queries))
under `strategy = BracketGallop()`.

If `queries` is not sorted, falls back to per-element `searchsortedlast`
with no hint regardless of `strategy`.

The `queries_sorted` kwarg controls the runtime `issorted(queries)` check:

  - `nothing` (default): run `issorted(queries; order = order)` on every call.
  - `true`: skip the check and take the sorted-loop path unconditionally.
  - `false`: skip the check and take the unsorted-loop path unconditionally.

Returns `idx_out`.
"""
function searchsortedlast!(
        idx_out::AbstractVector{<:Integer},
        v::AbstractVector,
        queries::AbstractVector;
        strategy::SearchStrategy = Auto(),
        order::Base.Order.Ordering = Base.Order.Forward,
        queries_sorted::Union{Nothing, Bool} = nothing,
    )
    if length(idx_out) != length(queries)
        throw(
            DimensionMismatch(
                "idx_out and queries must have the same length"
            )
        )
    end
    return _searchsortedlast_batched!(
        idx_out, v, queries, strategy, order, queries_sorted
    )
end

"""
    searchsortedfirst!(idx_out, v, queries; strategy = Auto(), order = Base.Order.Forward,
                        queries_sorted = nothing)

In-place batched `Base.searchsortedfirst`. See
[`searchsortedlast!`](@ref) for behavior.
"""
function searchsortedfirst!(
        idx_out::AbstractVector{<:Integer},
        v::AbstractVector,
        queries::AbstractVector;
        strategy::SearchStrategy = Auto(),
        order::Base.Order.Ordering = Base.Order.Forward,
        queries_sorted::Union{Nothing, Bool} = nothing,
    )
    if length(idx_out) != length(queries)
        throw(
            DimensionMismatch(
                "idx_out and queries must have the same length"
            )
        )
    end
    return _searchsortedfirst_batched!(
        idx_out, v, queries, strategy, order, queries_sorted
    )
end

# Sorted inner loop parameterized on a `StrategyKind` — concrete kernel
# dispatch happens inside `searchsorted_last` via the enum switch.
function _searchsortedlast_sorted_loop_kind!(
        idx_out, v::AbstractVector, queries::AbstractVector,
        kind::StrategyKind, order::Base.Order.Ordering,
    )
    hint = firstindex(v) - 1
    @inbounds for k in eachindex(queries)
        q = queries[k]
        hint = if hint < firstindex(v)
            searchsorted_last(kind, v, q; order = order)
        else
            searchsorted_last(kind, v, q, hint; order = order)
        end
        idx_out[k] = hint
    end
    return idx_out
end

function _searchsortedfirst_sorted_loop_kind!(
        idx_out, v::AbstractVector, queries::AbstractVector,
        kind::StrategyKind, order::Base.Order.Ordering,
    )
    hint = firstindex(v) - 1
    @inbounds for k in eachindex(queries)
        q = queries[k]
        hint = if hint < firstindex(v)
            searchsorted_first(kind, v, q; order = order)
        else
            searchsorted_first(kind, v, q, hint; order = order)
        end
        idx_out[k] = hint
    end
    return idx_out
end

# Sorted inner loop parameterized on a strategy *struct* (for GuesserHint
# and for the struct-valued `searchsorted_last(::S, ...)` path).
function _searchsortedlast_sorted_loop!(
        idx_out, v::AbstractVector, queries::AbstractVector,
        strategy::SearchStrategy, order::Base.Order.Ordering,
    )
    hint = firstindex(v) - 1
    @inbounds for k in eachindex(queries)
        q = queries[k]
        hint = if hint < firstindex(v)
            searchsorted_last(strategy, v, q; order = order)
        else
            searchsorted_last(strategy, v, q, hint; order = order)
        end
        idx_out[k] = hint
    end
    return idx_out
end

function _searchsortedfirst_sorted_loop!(
        idx_out, v::AbstractVector, queries::AbstractVector,
        strategy::SearchStrategy, order::Base.Order.Ordering,
    )
    hint = firstindex(v) - 1
    @inbounds for k in eachindex(queries)
        q = queries[k]
        hint = if hint < firstindex(v)
            searchsorted_first(strategy, v, q; order = order)
        else
            searchsorted_first(strategy, v, q, hint; order = order)
        end
        idx_out[k] = hint
    end
    return idx_out
end

function _searchsortedlast_unsorted_loop!(
        idx_out, v::AbstractVector, queries::AbstractVector,
        order::Base.Order.Ordering,
    )
    @inbounds for k in eachindex(queries)
        idx_out[k] = searchsortedlast(v, queries[k], order)
    end
    return idx_out
end

function _searchsortedfirst_unsorted_loop!(
        idx_out, v::AbstractVector, queries::AbstractVector,
        order::Base.Order.Ordering,
    )
    @inbounds for k in eachindex(queries)
        idx_out[k] = searchsortedfirst(v, queries[k], order)
    end
    return idx_out
end

@inline function _take_sorted_path(
        queries, order::Base.Order.Ordering, queries_sorted::Union{Nothing, Bool},
    )
    return queries_sorted === nothing ?
        issorted(queries; order = order) : queries_sorted
end

# Generic strategy path: singleton struct routes through its kind; other
# struct strategies (GuesserHint) route through their multimethod.
function _searchsortedlast_batched!(
        idx_out, v::AbstractVector, queries::AbstractVector,
        strategy::SearchStrategy, order::Base.Order.Ordering,
        queries_sorted::Union{Nothing, Bool},
    )
    return if _take_sorted_path(queries, order, queries_sorted)
        _searchsortedlast_sorted_loop_strategy_dispatch!(
            idx_out, v, queries, strategy, order
        )
    else
        _searchsortedlast_unsorted_loop!(idx_out, v, queries, order)
    end
end

function _searchsortedfirst_batched!(
        idx_out, v::AbstractVector, queries::AbstractVector,
        strategy::SearchStrategy, order::Base.Order.Ordering,
        queries_sorted::Union{Nothing, Bool},
    )
    return if _take_sorted_path(queries, order, queries_sorted)
        _searchsortedfirst_sorted_loop_strategy_dispatch!(
            idx_out, v, queries, strategy, order
        )
    else
        _searchsortedfirst_unsorted_loop!(idx_out, v, queries, order)
    end
end

# Dispatch helper: route singleton struct → kind loop, stateful struct →
# struct loop. Both inline.
@inline function _searchsortedlast_sorted_loop_strategy_dispatch!(
        idx_out, v, queries, strategy::SearchStrategy, order,
    )
    return _searchsortedlast_sorted_loop!(idx_out, v, queries, strategy, order)
end
@inline _searchsortedlast_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::BinaryBracket, order,
) = _searchsortedlast_sorted_loop_kind!(idx_out, v, queries, KIND_BINARY_BRACKET, order)
@inline _searchsortedlast_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::LinearScan, order,
) = _searchsortedlast_sorted_loop_kind!(idx_out, v, queries, KIND_LINEAR_SCAN, order)
@inline _searchsortedlast_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::SIMDLinearScan, order,
) = _searchsortedlast_sorted_loop_kind!(idx_out, v, queries, KIND_SIMD_LINEAR_SCAN, order)
@inline _searchsortedlast_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::BracketGallop, order,
) = _searchsortedlast_sorted_loop_kind!(idx_out, v, queries, KIND_BRACKET_GALLOP, order)
@inline _searchsortedlast_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::ExpFromLeft, order,
) = _searchsortedlast_sorted_loop_kind!(idx_out, v, queries, KIND_EXP_FROM_LEFT, order)
@inline _searchsortedlast_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::InterpolationSearch, order,
) = _searchsortedlast_sorted_loop_kind!(idx_out, v, queries, KIND_INTERPOLATION_SEARCH, order)
@inline _searchsortedlast_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::BitInterpolationSearch, order,
) = _searchsortedlast_sorted_loop_kind!(idx_out, v, queries, KIND_BIT_INTERPOLATION_SEARCH, order)
@inline _searchsortedlast_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::UniformStep, order,
) = _searchsortedlast_sorted_loop_kind!(idx_out, v, queries, KIND_UNIFORM_STEP, order)
@inline _searchsortedlast_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::BisectThenSIMD, order,
) = _searchsortedlast_sorted_loop_kind!(idx_out, v, queries, KIND_BISECT_THEN_SIMD, order)

@inline function _searchsortedfirst_sorted_loop_strategy_dispatch!(
        idx_out, v, queries, strategy::SearchStrategy, order,
    )
    return _searchsortedfirst_sorted_loop!(idx_out, v, queries, strategy, order)
end
@inline _searchsortedfirst_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::BinaryBracket, order,
) = _searchsortedfirst_sorted_loop_kind!(idx_out, v, queries, KIND_BINARY_BRACKET, order)
@inline _searchsortedfirst_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::LinearScan, order,
) = _searchsortedfirst_sorted_loop_kind!(idx_out, v, queries, KIND_LINEAR_SCAN, order)
@inline _searchsortedfirst_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::SIMDLinearScan, order,
) = _searchsortedfirst_sorted_loop_kind!(idx_out, v, queries, KIND_SIMD_LINEAR_SCAN, order)
@inline _searchsortedfirst_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::BracketGallop, order,
) = _searchsortedfirst_sorted_loop_kind!(idx_out, v, queries, KIND_BRACKET_GALLOP, order)
@inline _searchsortedfirst_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::ExpFromLeft, order,
) = _searchsortedfirst_sorted_loop_kind!(idx_out, v, queries, KIND_EXP_FROM_LEFT, order)
@inline _searchsortedfirst_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::InterpolationSearch, order,
) = _searchsortedfirst_sorted_loop_kind!(idx_out, v, queries, KIND_INTERPOLATION_SEARCH, order)
@inline _searchsortedfirst_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::BitInterpolationSearch, order,
) = _searchsortedfirst_sorted_loop_kind!(idx_out, v, queries, KIND_BIT_INTERPOLATION_SEARCH, order)
@inline _searchsortedfirst_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::UniformStep, order,
) = _searchsortedfirst_sorted_loop_kind!(idx_out, v, queries, KIND_UNIFORM_STEP, order)
@inline _searchsortedfirst_sorted_loop_strategy_dispatch!(
    idx_out, v, queries, ::BisectThenSIMD, order,
) = _searchsortedfirst_sorted_loop_kind!(idx_out, v, queries, KIND_BISECT_THEN_SIMD, order)

# ---------------------------------------------------------------------------
# Specialized batched-Auto: pick a kind from the n/m ratio + linearity probe,
# then call the kind-parameterized sorted loop directly.
# ---------------------------------------------------------------------------

function _searchsortedlast_batched!(
        idx_out, v::AbstractVector, queries::AbstractVector,
        s::Auto, order::Base.Order.Ordering,
        queries_sorted::Union{Nothing, Bool},
    )
    if _auto_is_uniform(v, s.props)
        # If props is populated, use the closed-form props-aware kernel
        # (no per-query division). Otherwise fall back to the range-based
        # UniformStep kernel (uses `step(r)`).
        if s.props.has_props && s.props.is_uniform
            @inbounds for k in eachindex(queries)
                idx_out[k] = _kernel_last_uniform_step_props(
                    s.props, v, queries[k], order,
                )
            end
        else
            @inbounds for k in eachindex(queries)
                idx_out[k] = searchsorted_last(KIND_UNIFORM_STEP, v, queries[k]; order = order)
            end
        end
        return idx_out
    end
    m = length(queries)
    m == 0 && return idx_out
    if m == 1
        @inbounds idx_out[firstindex(idx_out)] =
            searchsortedlast(v, queries[firstindex(queries)], order)
        return idx_out
    end
    if !_take_sorted_path(queries, order, queries_sorted)
        return _searchsortedlast_unsorted_loop!(idx_out, v, queries, order)
    end
    gap, skewed = _estimate_avg_gap(v, queries, m)
    kind = _auto_batched_kind(v, s.props, gap, skewed, m)
    return _searchsortedlast_sorted_loop_kind!(idx_out, v, queries, kind, order)
end

function _searchsortedfirst_batched!(
        idx_out, v::AbstractVector, queries::AbstractVector,
        s::Auto, order::Base.Order.Ordering,
        queries_sorted::Union{Nothing, Bool},
    )
    if _auto_is_uniform(v, s.props)
        if s.props.has_props && s.props.is_uniform
            @inbounds for k in eachindex(queries)
                idx_out[k] = _kernel_first_uniform_step_props(
                    s.props, v, queries[k], order,
                )
            end
        else
            @inbounds for k in eachindex(queries)
                idx_out[k] = searchsorted_first(KIND_UNIFORM_STEP, v, queries[k]; order = order)
            end
        end
        return idx_out
    end
    m = length(queries)
    m == 0 && return idx_out
    if m == 1
        @inbounds idx_out[firstindex(idx_out)] =
            searchsortedfirst(v, queries[firstindex(queries)], order)
        return idx_out
    end
    if !_take_sorted_path(queries, order, queries_sorted)
        return _searchsortedfirst_unsorted_loop!(idx_out, v, queries, order)
    end
    gap, skewed = _estimate_avg_gap(v, queries, m)
    kind = _auto_batched_kind(v, s.props, gap, skewed, m)
    return _searchsortedfirst_sorted_loop_kind!(idx_out, v, queries, kind, order)
end

# Batched Auto's kind picker: returns a `StrategyKind` instead of
# branching to different loop specializations, so the loop is
# kind-parameterized and type-stable.
@inline function _auto_batched_kind(
        v::AbstractVector, props::SearchProperties, gap::Integer,
        skewed::Bool, m::Integer,
    )
    if gap <= _AUTO_BATCH_LINEAR_GAP
        return KIND_LINEAR_SCAN
    end
    if gap <= _auto_simd_gap_max(v) && _auto_simd_eligible(v, props)
        return KIND_SIMD_LINEAR_SCAN
    end
    if !skewed &&
            gap >= _AUTO_INTERP_MIN_GAP &&
            length(v) >= _AUTO_INTERP_MIN_N &&
            m >= _AUTO_INTERP_MIN_M &&
            _auto_interp_eligible(v, props, gap)
        return KIND_INTERPOLATION_SEARCH
    end
    if gap >= _AUTO_GALLOP_GAP_MIN
        return KIND_BRACKET_GALLOP
    end
    return KIND_EXP_FROM_LEFT
end

# ---------------------------------------------------------------------------
# Range search through the strategy dispatch
# ---------------------------------------------------------------------------

"""
    searchsortedrange(strategy, v, lo, hi[, hint]; order = Base.Order.Forward)
        -> UnitRange{Int}

Return the index range of all entries `v[i]` satisfying `lo ≤ v[i] ≤ hi`
under `order`. Equivalent to
`searchsorted_first(strategy, v, lo[, hint]; order) :
 searchsorted_last(strategy, v, hi[, hint]; order)`.

When a `hint` is supplied it seeds the `lo` search directly; the `hi`
search is seeded with `max(first_idx, hint)`, since the upper endpoint
can never precede the lower one. Strategies that ignore the hint treat
the hinted form as a pass-through.
"""
@inline function searchsortedrange(
        strategy::SearchStrategy, v::AbstractVector, lo, hi;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    first_idx = searchsorted_first(strategy, v, lo; order = order)
    last_idx = searchsorted_last(strategy, v, hi; order = order)
    return first_idx:last_idx
end

@inline function searchsortedrange(
        strategy::SearchStrategy, v::AbstractVector, lo, hi, hint::Integer;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    first_idx = searchsorted_first(strategy, v, lo, hint; order = order)
    last_idx = searchsorted_last(
        strategy, v, hi, max(first_idx, hint); order = order
    )
    return first_idx:last_idx
end

# Kind-tagged equivalent.
@inline function searchsortedrange(
        kind::StrategyKind, v::AbstractVector, lo, hi;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    first_idx = searchsorted_first(kind, v, lo; order = order)
    last_idx = searchsorted_last(kind, v, hi; order = order)
    return first_idx:last_idx
end

@inline function searchsortedrange(
        kind::StrategyKind, v::AbstractVector, lo, hi, hint::Integer;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    first_idx = searchsorted_first(kind, v, lo, hint; order = order)
    last_idx = searchsorted_last(kind, v, hi, max(first_idx, hint); order = order)
    return first_idx:last_idx
end

# AirspeedVelocity-driven benchmark suite. Each `SUITE[...]` entry is a
# `BenchmarkGroup` (or `@benchmarkable`) that AirspeedVelocity will time on
# both the PR branch and the base branch, then diff. Keep individual cells
# fast (< 200 ms target) so the CI run finishes in a few minutes.

using BenchmarkTools
using FindFirstFunctions
using StableRNGs

const SUITE = BenchmarkGroup()

# Helper: build a sorted Float64 vector with the given pattern.
function _make_v(kind, n, seed = 2026)
    rng = StableRNG(seed)
    return if kind === :uniform
        collect(range(0.0, Float64(n); length = n))
    elseif kind === :logspaced
        collect(exp.(range(0.0, log(1.0e6); length = n)))
    elseif kind === :random_sorted
        sort!(rand(rng, n) .* n)
    else
        error("unknown v kind $kind")
    end
end

function _make_q(v, m, kind, seed = 2027)
    rng = StableRNG(seed)
    return if kind === :dense
        collect(range(first(v), last(v); length = m))
    elseif kind === :sparse
        sort!(first(v) .+ rand(rng, m) .* (last(v) - first(v)))
    elseif kind === :clustered
        j = max(1, length(v) ÷ 4)
        lo = v[j]
        hi = v[min(j + 1, length(v))]
        span = hi - lo
        sort!(lo .+ rand(rng, m) .* max(span, 1.0))
    else
        error("unknown q kind $kind")
    end
end

# ---------------------------------------------------------------------------
# Per-strategy single-query micro-benchmarks (Int64, n=1024, hint near answer)
# ---------------------------------------------------------------------------
SUITE["per_query"] = BenchmarkGroup()
let v = collect(Int64, 1:1024), x = Int64(500), hint = 480
    for (name, strategy) in [
            ("LinearScan", LinearScan()),
            ("SIMDLinearScan", SIMDLinearScan()),
            ("BracketGallop", BracketGallop()),
            ("ExpFromLeft", ExpFromLeft()),
            ("InterpolationSearch", InterpolationSearch()),
            ("BinaryBracket", BinaryBracket()),
            ("Auto", Auto()),
        ]
        SUITE["per_query"][name] = @benchmarkable(
            searchsortedlast($strategy, $v, $x, $hint),
            evals = 1, samples = 200,
        )
    end
end

# ---------------------------------------------------------------------------
# Batched in-place benchmarks: a small grid of (v_kind, q_kind, n, m).
# Auto vs hand-picked strategies, plus the queries_sorted = true fast path.
# ---------------------------------------------------------------------------
SUITE["batched"] = BenchmarkGroup()
for v_kind in (:uniform, :logspaced, :random_sorted),
        q_kind in (:dense, :sparse, :clustered),
        (n, m) in ((1024, 64), (16_384, 256), (65_536, 4096))

    v = _make_v(v_kind, n)
    q = _make_q(v, m, q_kind)
    out = Vector{Int}(undef, m)

    key = "$(v_kind)/$(q_kind)/n=$n/m=$m"
    grp = BenchmarkGroup()
    grp["Auto"] = @benchmarkable(
        FindFirstFunctions.searchsortedlast!($out, $v, $q; strategy = Auto()),
        evals = 1, samples = 50,
    )
    grp["Auto+sorted"] = @benchmarkable(
        FindFirstFunctions.searchsortedlast!(
            $out, $v, $q;
            strategy = Auto(), queries_sorted = true,
        ),
        evals = 1, samples = 50,
    )
    grp["Auto+props"] = @benchmarkable(
        FindFirstFunctions.searchsortedlast!(
            $out, $v, $q;
            strategy = Auto(SearchProperties($v)),
        ),
        evals = 1, samples = 50,
    )
    SUITE["batched"][key] = grp
end

# ---------------------------------------------------------------------------
# SearchProperties construction cost (probe + NaN scan on Float64)
# ---------------------------------------------------------------------------
SUITE["props_construct"] = BenchmarkGroup()
for (name, v) in [
        ("uniform_64k", collect(range(0.0, 100.0; length = 65_536))),
        ("logspaced_64k", collect(exp.(range(0.0, log(1.0e6); length = 65_536)))),
        ("int64_64k", collect(Int64, 1:65_536)),
    ]
    SUITE["props_construct"][name] = @benchmarkable(
        SearchProperties($v),
        evals = 1, samples = 50,
    )
end

# ---------------------------------------------------------------------------
# Equality search comparison
# ---------------------------------------------------------------------------
SUITE["equality"] = BenchmarkGroup()
let v = collect(Int64, 1:65_536), x = Int64(50_000)
    SUITE["equality"]["findequal_BinaryBracket"] = @benchmarkable(
        findequal(BinaryBracket(), $v, $x),
        evals = 1, samples = 200,
    )
    SUITE["equality"]["findequal_BisectThenSIMD"] = @benchmarkable(
        findequal(BisectThenSIMD(), $v, $x),
        evals = 1, samples = 200,
    )
    SUITE["equality"]["findfirstsortedequal"] = @benchmarkable(
        findfirstsortedequal($x, $v),
        evals = 1, samples = 200,
    )
end

# Sorted-search strategy type hierarchy. The singleton strategy structs
# (`LinearScan`, `BracketGallop`, …) are friendly names for the
# `StrategyKind` tags — passing one to `searchsorted_last` / `searchsorted_first`
# forwards through `strategy_kind` and constant-folds (see
# `strategy_kind.jl`). The stateful strategies — `Auto` and
# `GuesserHint` — stay on the multimethod path because they carry
# per-instance data.

"""
    SearchStrategy

Abstract supertype for sorted-search strategies. Two flavours of
concrete subtype:

  - **Singleton strategies** (`LinearScan`, `SIMDLinearScan`,
    `BracketGallop`, `ExpFromLeft`, `InterpolationSearch`,
    `BitInterpolationSearch`, `BinaryBracket`, `UniformStep`,
    `BisectThenSIMD`) are zero-field structs. Each one has a matching
    `StrategyKind` enum value; pass either the struct or its enum tag to
    [`searchsorted_last`](@ref) / [`searchsorted_first`](@ref). The struct
    form forwards through [`strategy_kind`](@ref) and constant-folds for a
    literal strategy, so it compiles to the same code as the enum tag.
  - **Stateful strategies** (`Auto`, `GuesserHint`) carry per-instance
    data. They dispatch via their own `searchsorted_last` / `searchsorted_first`
    multimethods.

Strategies can also be passed to the batched
[`searchsortedlast!`](@ref) / [`searchsortedfirst!`](@ref) APIs.
"""
abstract type SearchStrategy end

"""
    LinearScan <: SearchStrategy

Walk ±1 from the hint. Best when the target is within a few positions of the
hint. Falls back to [`BinaryBracket`](@ref) when no hint is supplied.

Maps to `KIND_LINEAR_SCAN`.
"""
struct LinearScan <: SearchStrategy end

"""
    SIMDLinearScan <: SearchStrategy

Variant of [`LinearScan`](@ref) whose forward walk is lowered to 8-wide
SIMD chunks via custom LLVM IR. Specialized for `DenseVector{Int64}` and
`DenseVector{Float64}`; for any other element type, falls back to plain
[`LinearScan`](@ref). The backward walk (when the hint is past the
answer) uses the scalar `LinearScan` path regardless of element type.

Maps to `KIND_SIMD_LINEAR_SCAN`.

Wins on long forward walks (≥ 8 elements past the hint). For walks of
1–3 elements `LinearScan` is comparable — the SIMD chunk has constant
setup overhead. Worst case is O(n / 8) which is still linear, so
`SIMDLinearScan` is only `Auto`-relevant for small `n` or small-gap
batches where plain `LinearScan` would have been picked anyway.

Caveats:
  - Element type must be exactly `Int64` or `Float64`.
  - Sorted-Float64 vectors containing `NaN` produce undefined results.
  - Falls back to [`BinaryBracket`](@ref) when no hint is supplied.
  - Falls back to [`LinearScan`](@ref) for non-`Forward` orderings.
"""
struct SIMDLinearScan <: SearchStrategy end

"""
    BracketGallop <: SearchStrategy

Expand an exponential bracket bidirectionally from the hint, then
binary-search inside the bracket. Effectively O(1) when the target is near
the hint; never worse than ~2 log₂ n comparisons.

Maps to `KIND_BRACKET_GALLOP`. Falls back to [`BinaryBracket`](@ref) when
no hint is supplied.
"""
struct BracketGallop <: SearchStrategy end

"""
    ExpFromLeft <: SearchStrategy

Exponential search forward from the hint (interpreted as a left bound), then
binary search in the final bracket. Best for batched sorted queries where
each next query's hint is the previous result.

Maps to `KIND_EXP_FROM_LEFT`. Falls back to [`BinaryBracket`](@ref) when
no hint is supplied.
"""
struct ExpFromLeft <: SearchStrategy end

"""
    InterpolationSearch <: SearchStrategy

Guesses an index by linearly extrapolating `x` between `v[lo]` and `v[hi]`,
then refines with a bounded binary search.

Maps to `KIND_INTERPOLATION_SEARCH`. Ignores any hint. Falls back to
[`BinaryBracket`](@ref) for non-numeric element types.
"""
struct InterpolationSearch <: SearchStrategy end

"""
    BitInterpolationSearch <: SearchStrategy

Variant of [`InterpolationSearch`](@ref) that reinterprets `DenseVector{Float64}`
as `DenseVector{UInt64}` before computing the extrapolation guess. Wins on
log-spaced (geometric) data.

Maps to `KIND_BIT_INTERPOLATION_SEARCH`.

Constraints:
  - `DenseVector{Float64}` only.
  - Requires `v[1] > 0` and the query `x > 0`.
  - Forward / Reverse orderings only.

**Opt-in only** — `Auto` does not pick this strategy. Falls back to
[`InterpolationSearch`](@ref) for non-Float64 dense eltypes, and to
[`BinaryBracket`](@ref) for non-positive or non-finite Float64 data.
"""
struct BitInterpolationSearch <: SearchStrategy end

"""
    BinaryBracket <: SearchStrategy

Plain `Base.searchsortedlast` / `Base.searchsortedfirst`. Ignores any hint.

Maps to `KIND_BINARY_BRACKET`.
"""
struct BinaryBracket <: SearchStrategy end

"""
    UniformStep <: SearchStrategy

O(1) direct-arithmetic lookup for uniformly-spaced vectors.

Maps to `KIND_UNIFORM_STEP`. Specialized for `AbstractRange{<:Real}`; for
other vector types, falls back to [`BinaryBracket`](@ref). Ignores any hint.
"""
struct UniformStep <: SearchStrategy end

"""
    BisectThenSIMD <: SearchStrategy

Equality-search strategy. Binary-bisects `v` down to a small basecase,
then SIMD-scans the basecase for exact equality with `x`. Specialised for
`DenseVector{Int64}` + `Int64` queries.

Maps to `KIND_BISECT_THEN_SIMD`. Meant for use with [`findequal`](@ref
FindFirstFunctions.findequal), not with `searchsortedfirst` /
`searchsortedlast` — in the positional API it falls back to
[`BinaryBracket`](@ref).
"""
struct BisectThenSIMD <: SearchStrategy end

"""
    GuesserHint(guesser::Guesser) <: SearchStrategy

Uses a [`Guesser`](@ref) to produce an integer guess for `x`, then
dispatches to [`BracketGallop`](@ref) from that guess. The `Guesser`
already decides between linear-extrapolation lookup and using the
previous result as a guess; this strategy plugs that logic into the
strategy dispatch hierarchy.

**Stateful strategy.** `GuesserHint` carries the `Guesser` (which carries
`idx_prev::Ref{Int}` and `linear_lookup::Bool`), so it cannot be reduced
to a `StrategyKind` tag. It dispatches via its own
`searchsorted_last(::GuesserHint, ...)` / `searchsorted_first(::GuesserHint, ...)`
methods.

Use this strategy with the per-query and batched APIs whenever you have a
`Guesser` attached to a vector.
"""
struct GuesserHint{G} <: SearchStrategy
    guesser::G
end

"""
    SearchProperties{T}

Cached, non-allocating facts about a sorted vector. Pass to [`Auto`](@ref)
via `Auto(props)` to skip the per-call probes that the default `Auto()` runs
on every batched call.

Default-constructed (`SearchProperties()`) is the "no information" sentinel:
`has_props` is `false`, the other fields are unspecified and ignored by
`Auto`. Construct via `SearchProperties(v::AbstractVector)` to populate the
fields by running the probes once.

`T` is the **data ratio type** — the type of `oneunit(eltype(v)) /
oneunit(eltype(v))`, so e.g. `SearchProperties{Float64}` for
`Vector{Int}` (because `Int/Int` promotes to `Float64`) or `Vector{Float64}`,
`SearchProperties{Float32}` for `Vector{Float32}`. For non-`Number` eltypes
the default is `Float64` and `has_props = false`.

Currently consumed by `Auto`:

  - `is_linear` — gates `InterpolationSearch` in batched dispatch.
  - `has_nan` (Float64 only) — gates `SIMDLinearScan` eligibility.
  - `is_uniform` — short-circuits to [`UniformStep`](@ref) when set, with
    `first_val` and `inv_step` baked in for closed-form O(1) lookup.

When `is_uniform = true`, `first_val` and `inv_step` hold the precomputed
data needed by `UniformStep`'s closed-form path
(`idx = floor((x - first_val) * inv_step) + 1`). When `is_uniform = false`
they are `zero(T)` and never consulted.

The `is_log_linear` field is populated for callers that want to manually
pin [`BitInterpolationSearch`](@ref); `Auto` does not consume it.
"""
struct SearchProperties{T}
    has_props::Bool
    is_linear::Bool
    has_nan::Bool
    is_log_linear::Bool
    is_uniform::Bool
    first_val::T
    inv_step::T
end

# Data ratio type used by SearchProperties{T}: `1/oneunit(eltype(v))` promotion.
# `Int → Float64`, `Float64 → Float64`, `Float32 → Float32`.
@inline _ratio_type(::Type{T}) where {T <: AbstractFloat} = T
@inline _ratio_type(::Type{T}) where {T <: Number} = typeof(oneunit(T) / oneunit(T))
@inline _ratio_type(::Type) = Float64

SearchProperties() = SearchProperties{Float64}(
    false, false, false, false, false, 0.0, 0.0,
)

"""
    Auto <: SearchStrategy
    Auto()
    Auto(props::SearchProperties)
    Auto(v::AbstractVector)
    Auto(v::AbstractVector, props::SearchProperties)

Stateful strategy that resolves to a concrete [`StrategyKind`](@ref) at
construction time. The resolution uses static information available at
construction: `props` (if supplied) plus `v` (if supplied).

**Per-query** (`searchsorted_last(Auto(), v, x[, hint])`): forwards directly to the
stored kind. `Auto()` defaults to `KIND_BINARY_BRACKET` (safe choice
when nothing is known about `v`); `Auto(v)` resolves to a faster kind
based on `length(v)`, `props.is_uniform`, etc. Callers that want the
v2-era "pick at every query based on length and hint" behaviour should
explicitly construct `Auto(v)` for each new `v`.

**Batched sorted** (`searchsortedlast!(out, v, queries; strategy = Auto())`):
the batched dispatcher re-resolves the kind from `(v, queries)` even
when `Auto()` carries the default kind — the gap-based decision tree
requires the queries, which aren't available at Auto-construction time.

**Cached properties.** Passing a populated [`SearchProperties`](@ref) via
`Auto(props)` or `Auto(v, props)` short-circuits the per-call probes. The
cached path is behaviour-equivalent to `Auto(v)` when `props` is up to
date for `v`; the caller is responsible for re-computing `props` if `v`
mutates.

# Fields

  - `kind::StrategyKind` — resolved kind. Use this field directly in
    hot loops via `searchsorted_last(auto.kind, v, x, hint)` to skip the
    `auto.props` field load entirely.
  - `props::SearchProperties` — cached properties used by the batched
    decision tree.
"""
struct Auto{T} <: SearchStrategy
    kind::StrategyKind
    props::SearchProperties{T}
end

Auto() = Auto{Float64}(KIND_BINARY_BRACKET, SearchProperties())
Auto(props::SearchProperties{T}) where {T} =
    Auto{T}(_default_kind_from_props(props), props)
Auto(v::AbstractVector) = Auto(v, SearchProperties(v))
function Auto(v::AbstractVector, props::SearchProperties{T}) where {T}
    return Auto{T}(_auto_resolve_kind(v, props), props)
end

# When props alone is available (no `v`), the best we can do is pick
# `UniformStep` if `props.is_uniform`. Otherwise fall back to the safe
# default.
@inline function _default_kind_from_props(props::SearchProperties)
    return props.has_props && props.is_uniform ?
        KIND_UNIFORM_STEP : KIND_BINARY_BRACKET
end

# Per-query Auto resolution: when v is known. Concrete `_auto_resolve_kind`
# logic lives in `auto.jl` — these forward-declared symbols are looked up
# lazily at call time, so the include order works out.
function _auto_resolve_kind end

# Kernel functions for each singleton strategy. Each kernel is a free
# function that performs the strategy's algorithm directly — no method
# dispatch, no Union returns, no wrapper struct.
#
# The kernels are called from the enum dispatcher in `kinds.jl`. `Auto`
# and `GuesserHint` also call them (directly, by kind, for `Auto`; via
# the kind dispatcher, for `GuesserHint`).

# ===========================================================================
# Bracket helpers — backing `BracketGallop`
# ===========================================================================

# Expanding-binary-search bracket around a guess. The `searchsortedlast`
# polarity: when `x == v[guess]`, the answer is `>= guess` (gallop right).
function bracketstrictlymonotonic(
        v::AbstractVector,
        x,
        guess::T,
        o::Base.Order.Ordering,
    )::NTuple{2, keytype(v)} where {T <: Integer}
    bottom = firstindex(v)
    top = lastindex(v)
    if guess < bottom || guess > top
        return bottom, top
    else
        u = T(1)
        lo, hi = guess, min(guess + u, top)
        @inbounds if Base.Order.lt(o, x, v[lo])
            while lo > bottom && Base.Order.lt(o, x, v[lo])
                lo, hi = max(bottom, lo - u), lo
                u += u
            end
        else
            while hi < top && !Base.Order.lt(o, x, v[hi])
                lo, hi = hi, min(top, hi + u)
                u += u
            end
        end
    end
    return lo, hi
end

# Companion to `bracketstrictlymonotonic` for the `searchsortedfirst`
# polarity. When `x == v[lo]` the answer is `<= lo` (look for earlier
# duplicates) — so we use the inverted polarity `lt(o, v[lo], x)`.
function bracketstrictlymonotonic_first(
        v::AbstractVector,
        x,
        guess::T,
        o::Base.Order.Ordering,
    )::NTuple{2, keytype(v)} where {T <: Integer}
    bottom = firstindex(v)
    top = lastindex(v)
    if guess < bottom || guess > top
        return bottom, top
    else
        u = T(1)
        lo, hi = guess, min(guess + u, top)
        @inbounds if !Base.Order.lt(o, v[lo], x)
            while lo > bottom && !Base.Order.lt(o, v[lo], x)
                lo, hi = max(bottom, lo - u), lo
                u += u
            end
        else
            while hi < top && Base.Order.lt(o, v[hi], x)
                lo, hi = hi, min(top, hi + u)
                u += u
            end
        end
    end
    return lo, hi
end

# ===========================================================================
# Exponential-search helpers — backing `ExpFromLeft`
# ===========================================================================

# Finds the smallest index `y` in `[lo, hi]` with `!lt(order, v[y], x)`.
Base.@propagate_inbounds function searchsortedfirstexp(
        v::AbstractVector,
        x,
        lo::Integer = firstindex(v),
        hi::Integer = lastindex(v),
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    for i in 0:4
        ind = lo + i
        ind > hi && return ind
        !Base.Order.lt(order, v[ind], x) && return ind
    end
    n = 3
    tn2 = 2^n
    tn2m1 = 2^(n - 1)
    ind = lo + tn2
    while ind <= hi
        !Base.Order.lt(order, v[ind], x) &&
            return searchsortedfirst(v, x, lo + tn2 - tn2m1, ind, order)
        tn2 *= 2
        tn2m1 *= 2
        ind = lo + tn2
    end
    return searchsortedfirst(v, x, lo + tn2 - tn2m1, hi, order)
end

# Finds the largest `y` in `[lo, hi]` with `!lt(order, x, v[y])`.
Base.@propagate_inbounds function searchsortedlastexp(
        v::AbstractVector,
        x,
        lo::Integer = firstindex(v),
        hi::Integer = lastindex(v),
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    for i in 0:4
        ind = lo + i
        ind > hi && return hi
        Base.Order.lt(order, x, v[ind]) && return ind - 1
    end
    n = 3
    tn2 = 2^n
    tn2m1 = 2^(n - 1)
    ind = lo + tn2
    while ind <= hi
        Base.Order.lt(order, x, v[ind]) &&
            return searchsortedlast(v, x, lo + tn2 - tn2m1, ind, order)
        tn2 *= 2
        tn2m1 *= 2
        ind = lo + tn2
    end
    return searchsortedlast(v, x, lo + tn2 - tn2m1, hi, order)
end

# ===========================================================================
# Kernel: BinaryBracket — plain `Base.searchsortedlast` / `Base.searchsortedfirst`.
# ===========================================================================

@inline _kernel_last_binary_bracket(v::AbstractVector, x, order::Base.Order.Ordering) =
    searchsortedlast(v, x, order)
@inline _kernel_first_binary_bracket(v::AbstractVector, x, order::Base.Order.Ordering) =
    searchsortedfirst(v, x, order)

# ===========================================================================
# Kernel: LinearScan — walk ±1 from the hint.
# ===========================================================================

function _kernel_last_linear_scan(
        v::AbstractVector, x, hint::Integer, order::Base.Order.Ordering,
    )
    lo, hi = firstindex(v), lastindex(v)
    if hi < lo
        return lo - 1   # empty vector
    end
    i = clamp(hint, lo, hi)
    @inbounds if Base.Order.lt(order, x, v[i])
        # v[i] > x → retreat
        while i > lo
            i -= 1
            !Base.Order.lt(order, x, v[i]) && return i
        end
        return lo - 1   # x precedes all of v
    else
        # v[i] ≤ x → try to advance
        while i < hi
            Base.Order.lt(order, x, v[i + 1]) && return i
            i += 1
        end
        return hi
    end
end

function _kernel_first_linear_scan(
        v::AbstractVector, x, hint::Integer, order::Base.Order.Ordering,
    )
    lo, hi = firstindex(v), lastindex(v)
    if hi < lo
        return lo
    end
    i = clamp(hint, lo, hi)
    @inbounds if Base.Order.lt(order, v[i], x)
        # v[i] < x → advance
        while i < hi
            i += 1
            !Base.Order.lt(order, v[i], x) && return i
        end
        return hi + 1   # x exceeds all of v
    else
        # v[i] ≥ x → try to retreat
        while i > lo
            !Base.Order.lt(order, v[i - 1], x) && (i -= 1; continue)
            return i
        end
        return lo
    end
end

# ===========================================================================
# Kernel: SIMDLinearScan — specialized forward walk for DenseVector{Int64}
# and DenseVector{Float64}. Falls back to scalar LinearScan otherwise.
# ===========================================================================

@inline function _simdscan_last_specialized(
        v::Union{DenseVector{Int64}, DenseVector{Float64}},
        x, hint::Integer,
        order::Base.Order.Ordering,
    )
    lo = firstindex(v)
    hi = lastindex(v)
    hi < lo && return lo - 1
    i = clamp(hint, lo, hi)
    @inbounds vi = v[i]
    if Base.Order.lt(order, x, vi)
        # `v[i]` is past the answer in this ordering — backward walk (scalar).
        while i > lo
            i -= 1
            @inbounds !Base.Order.lt(order, x, v[i]) && return i
        end
        return lo - 1
    end
    i == hi && return hi
    start = i + 1
    len = hi - start + 1
    offset = if order === Base.Order.Forward
        GC.@preserve v _simd_first_gt(x, pointer(v, start), Int64(len))
    else
        GC.@preserve v _simd_first_lt(x, pointer(v, start), Int64(len))
    end
    return offset < 0 ? hi : (start + offset) - 1
end

@inline function _simdscan_first_specialized(
        v::Union{DenseVector{Int64}, DenseVector{Float64}},
        x, hint::Integer,
        order::Base.Order.Ordering,
    )
    lo = firstindex(v)
    hi = lastindex(v)
    hi < lo && return lo
    i = clamp(hint, lo, hi)
    @inbounds vi = v[i]
    if Base.Order.lt(order, vi, x)
        i == hi && return hi + 1
        start = i + 1
        len = hi - start + 1
        offset = if order === Base.Order.Forward
            GC.@preserve v _simd_first_ge(x, pointer(v, start), Int64(len))
        else
            GC.@preserve v _simd_first_le(x, pointer(v, start), Int64(len))
        end
        return offset < 0 ? hi + 1 : start + offset
    end
    while i > lo
        @inbounds Base.Order.lt(order, v[i - 1], x) && return i
        i -= 1
    end
    return lo
end

# Whether the ordering is one of the two ordering singletons SIMD supports.
@inline function _simd_supported_order(order::Base.Order.Ordering)
    return order === Base.Order.Forward || order === Base.Order.Reverse
end

# Static-dispatch entry: Int64 and Float64 dense vectors get the SIMD path
# (under supported orderings); everything else falls back to scalar LinearScan.
@inline function _kernel_last_simd_linear_scan(
        v::DenseVector{Int64}, x::Int64, hint::Integer, order::Base.Order.Ordering,
    )
    _simd_supported_order(order) ||
        return _kernel_last_linear_scan(v, x, hint, order)
    return _simdscan_last_specialized(v, x, hint, order)
end
@inline function _kernel_last_simd_linear_scan(
        v::DenseVector{Float64}, x::Float64, hint::Integer, order::Base.Order.Ordering,
    )
    _simd_supported_order(order) ||
        return _kernel_last_linear_scan(v, x, hint, order)
    return _simdscan_last_specialized(v, x, hint, order)
end
@inline _kernel_last_simd_linear_scan(
    v::AbstractVector, x, hint::Integer, order::Base.Order.Ordering,
) = _kernel_last_linear_scan(v, x, hint, order)

@inline function _kernel_first_simd_linear_scan(
        v::DenseVector{Int64}, x::Int64, hint::Integer, order::Base.Order.Ordering,
    )
    _simd_supported_order(order) ||
        return _kernel_first_linear_scan(v, x, hint, order)
    return _simdscan_first_specialized(v, x, hint, order)
end
@inline function _kernel_first_simd_linear_scan(
        v::DenseVector{Float64}, x::Float64, hint::Integer, order::Base.Order.Ordering,
    )
    _simd_supported_order(order) ||
        return _kernel_first_linear_scan(v, x, hint, order)
    return _simdscan_first_specialized(v, x, hint, order)
end
@inline _kernel_first_simd_linear_scan(
    v::AbstractVector, x, hint::Integer, order::Base.Order.Ordering,
) = _kernel_first_linear_scan(v, x, hint, order)

# ===========================================================================
# Kernel: BracketGallop — bracketstrictlymonotonic + bounded binary search.
# ===========================================================================

@inline function _kernel_last_bracket_gallop(
        v::AbstractVector, x, hint::Integer, order::Base.Order.Ordering,
    )
    lo, hi = bracketstrictlymonotonic(v, x, hint, order)
    return searchsortedlast(v, x, lo, hi, order)
end

@inline function _kernel_first_bracket_gallop(
        v::AbstractVector, x, hint::Integer, order::Base.Order.Ordering,
    )
    lo, hi = bracketstrictlymonotonic_first(v, x, hint, order)
    return searchsortedfirst(v, x, lo, hi, order)
end

# ===========================================================================
# Kernel: ExpFromLeft — galloping forward from a left-bound hint.
# ===========================================================================

function _kernel_first_exp_from_left(
        v::AbstractVector, x, hint::Integer, order::Base.Order.Ordering,
    )
    lo = firstindex(v)
    hi = lastindex(v)
    if isempty(v)
        return lo
    end
    h = clamp(hint, lo, hi)
    @inbounds if !Base.Order.lt(order, v[h], x)
        return searchsortedfirst(v, x, order)
    end
    return searchsortedfirstexp(v, x, h, hi, order)
end

function _kernel_last_exp_from_left(
        v::AbstractVector, x, hint::Integer, order::Base.Order.Ordering,
    )
    lo = firstindex(v)
    hi = lastindex(v)
    if isempty(v)
        return lo - 1
    end
    h = clamp(hint, lo, hi)
    @inbounds if Base.Order.lt(order, x, v[h])
        return searchsortedlast(v, x, order)
    end
    return searchsortedlastexp(v, x, h, hi, order)
end

# ===========================================================================
# Kernel: InterpolationSearch — extrapolate a guess + bounded binary search.
# ===========================================================================

@inline function _interp_guess(v::AbstractVector, x, lo::Integer, hi::Integer)
    @inbounds vlo = v[lo]
    @inbounds vhi = v[hi]
    span = vhi - vlo
    iszero(span) && return lo
    f = (x - vlo) / span
    if !isfinite(f)
        return f > 0 ? hi : lo
    end
    g = lo + round(Int, f * (hi - lo))
    return clamp(g, lo, hi)
end

function _kernel_last_interpolation_search_numeric(
        v::AbstractVector{<:Number}, x::Number, order::Base.Order.Ordering,
    )
    lo, hi = firstindex(v), lastindex(v)
    hi < lo && return lo - 1
    g = _interp_guess(v, x, lo, hi)
    return _kernel_last_bracket_gallop(v, x, g, order)
end

function _kernel_first_interpolation_search_numeric(
        v::AbstractVector{<:Number}, x::Number, order::Base.Order.Ordering,
    )
    lo, hi = firstindex(v), lastindex(v)
    hi < lo && return lo
    g = _interp_guess(v, x, lo, hi)
    return _kernel_first_bracket_gallop(v, x, g, order)
end

@inline _kernel_last_interpolation_search(
    v::AbstractVector{<:Number}, x::Number, order::Base.Order.Ordering,
) = _kernel_last_interpolation_search_numeric(v, x, order)
@inline _kernel_last_interpolation_search(
    v::AbstractVector, x, order::Base.Order.Ordering,
) = _kernel_last_binary_bracket(v, x, order)

@inline _kernel_first_interpolation_search(
    v::AbstractVector{<:Number}, x::Number, order::Base.Order.Ordering,
) = _kernel_first_interpolation_search_numeric(v, x, order)
@inline _kernel_first_interpolation_search(
    v::AbstractVector, x, order::Base.Order.Ordering,
) = _kernel_first_binary_bracket(v, x, order)

# ===========================================================================
# Kernel: BitInterpolationSearch — InterpolationSearch on IEEE bit pattern
# of positive Float64.
# ===========================================================================

@inline function _bit_interp_guess_f64(
        v::DenseVector{Float64}, x::Float64, lo::Integer, hi::Integer,
        order::Base.Order.Ordering,
    )
    @inbounds vlo_bits = reinterpret(UInt64, v[lo])
    @inbounds vhi_bits = reinterpret(UInt64, v[hi])
    xu = reinterpret(UInt64, x)
    return if order === Base.Order.Forward
        span = vhi_bits - vlo_bits
        if iszero(span)
            lo
        elseif xu <= vlo_bits
            lo
        elseif xu >= vhi_bits
            hi
        else
            num = xu - vlo_bits
            f = Float64(num) / Float64(span)
            clamp(lo + round(Int, f * (hi - lo)), lo, hi)
        end
    else
        span = vlo_bits - vhi_bits
        if iszero(span)
            lo
        elseif xu >= vlo_bits
            lo
        elseif xu <= vhi_bits
            hi
        else
            num = vlo_bits - xu
            f = Float64(num) / Float64(span)
            clamp(lo + round(Int, f * (hi - lo)), lo, hi)
        end
    end
end

@inline function _bit_interp_eligible(v::DenseVector{Float64}, x::Float64, lo, hi, order)
    _simd_supported_order(order) || return false
    @inbounds return v[lo] > 0.0 && isfinite(v[lo]) &&
        v[hi] > 0.0 && isfinite(v[hi]) &&
        x > 0.0 && isfinite(x)
end

function _kernel_last_bit_interpolation_search_f64(
        v::DenseVector{Float64}, x::Float64, order::Base.Order.Ordering,
    )
    lo, hi = firstindex(v), lastindex(v)
    hi < lo && return lo - 1
    _bit_interp_eligible(v, x, lo, hi, order) ||
        return _kernel_last_binary_bracket(v, x, order)
    g = _bit_interp_guess_f64(v, x, lo, hi, order)
    return _kernel_last_bracket_gallop(v, x, g, order)
end

function _kernel_first_bit_interpolation_search_f64(
        v::DenseVector{Float64}, x::Float64, order::Base.Order.Ordering,
    )
    lo, hi = firstindex(v), lastindex(v)
    hi < lo && return lo
    _bit_interp_eligible(v, x, lo, hi, order) ||
        return _kernel_first_binary_bracket(v, x, order)
    g = _bit_interp_guess_f64(v, x, lo, hi, order)
    return _kernel_first_bracket_gallop(v, x, g, order)
end

@inline _kernel_last_bit_interpolation_search(
    v::DenseVector{Float64}, x::Float64, order::Base.Order.Ordering,
) = _kernel_last_bit_interpolation_search_f64(v, x, order)
@inline _kernel_last_bit_interpolation_search(
    v::AbstractVector, x, order::Base.Order.Ordering,
) = _kernel_last_interpolation_search(v, x, order)

@inline _kernel_first_bit_interpolation_search(
    v::DenseVector{Float64}, x::Float64, order::Base.Order.Ordering,
) = _kernel_first_bit_interpolation_search_f64(v, x, order)
@inline _kernel_first_bit_interpolation_search(
    v::AbstractVector, x, order::Base.Order.Ordering,
) = _kernel_first_interpolation_search(v, x, order)

# ===========================================================================
# Kernel: UniformStep — O(1) closed-form lookup for AbstractRange.
# ===========================================================================

@inline _uniformstep_supported_order(::Base.Order.ForwardOrdering) = true
@inline _uniformstep_supported_order(::Base.Order.ReverseOrdering) = true
@inline _uniformstep_supported_order(::Base.Order.Ordering) = false

@inline function _uniformstep_searchsortedlast(
        r::AbstractRange, x, order::Base.Order.Ordering,
    )
    isempty(r) && return firstindex(r) - 1
    s = step(r)
    iszero(s) && return lastindex(r)
    diff = x - first(r)
    if diff isa AbstractFloat && !isfinite(diff)
        return isnan(diff) ? (firstindex(r) - 1) :
            (diff > 0) ⊻ (s < 0) ? lastindex(r) : firstindex(r) - 1
    end
    nm1 = length(r) - 1
    f = fld(diff, s)
    i = if f < 0
        firstindex(r) - 1
    elseif f >= nm1
        lastindex(r)
    else
        firstindex(r) + Int(f)
    end
    @inbounds if i < lastindex(r) && !Base.Order.lt(order, x, r[i + 1])
        return i + 1
    elseif i >= firstindex(r) && i <= lastindex(r) && Base.Order.lt(order, x, r[i])
        return i - 1
    end
    return i
end

@inline function _uniformstep_searchsortedfirst(
        r::AbstractRange, x, order::Base.Order.Ordering,
    )
    isempty(r) && return firstindex(r)
    s = step(r)
    iszero(s) && return firstindex(r)
    diff = x - first(r)
    if diff isa AbstractFloat && !isfinite(diff)
        return isnan(diff) ? (lastindex(r) + 1) :
            (diff > 0) ⊻ (s < 0) ? lastindex(r) + 1 : firstindex(r)
    end
    nm1 = length(r) - 1
    f = cld(diff, s)
    i = if f <= 0
        firstindex(r)
    elseif f > nm1
        lastindex(r) + 1
    else
        firstindex(r) + Int(f)
    end
    @inbounds if i > firstindex(r) && i <= lastindex(r) + 1 &&
            !Base.Order.lt(order, r[i - 1], x)
        return i - 1
    end
    @inbounds if i <= lastindex(r) && Base.Order.lt(order, r[i], x)
        return i + 1
    end
    return i
end

@inline _kernel_last_uniform_step(
    v::AbstractRange, x, order::Base.Order.Ordering,
) = _uniformstep_supported_order(order) ?
    _uniformstep_searchsortedlast(v, x, order) :
    _kernel_last_binary_bracket(v, x, order)
@inline _kernel_last_uniform_step(
    v::AbstractVector, x, order::Base.Order.Ordering,
) = _kernel_last_binary_bracket(v, x, order)

@inline _kernel_first_uniform_step(
    v::AbstractRange, x, order::Base.Order.Ordering,
) = _uniformstep_supported_order(order) ?
    _uniformstep_searchsortedfirst(v, x, order) :
    _kernel_first_binary_bracket(v, x, order)
@inline _kernel_first_uniform_step(
    v::AbstractVector, x, order::Base.Order.Ordering,
) = _kernel_first_binary_bracket(v, x, order)

# ===========================================================================
# Props-aware UniformStep — closed-form O(1) lookup using a precomputed
# `inv_step` baked into `SearchProperties{T}`. The per-query float
# division `fld(diff, step)` is hoisted to
# `SearchProperties` construction time, leaving the hot path with one
# subtract, one multiply, one truncate, plus a bounds clamp and a one-step
# roundoff correction.
#
# Both `Forward` and `Reverse` orderings are supported — the sign of
# `inv_step` carries the direction. Any other ordering falls back to
# BinaryBracket.
# ===========================================================================

# Truncate a guess coordinate `f` to an `Int` offset. The caller has already
# clamped `f` to `[0, nm1)` (last) / `(0, nm1]` (first), so on the hardware
# floats the fast `unsafe_trunc` is in-range and skips a redundant check.
# Other ordered-`Real` ratio types — `Rational`, AD `Dual`, `BigFloat`, … —
# do not all define `unsafe_trunc`, so fall back to the checked
# `floor(Int, ·)` / `ceil(Int, ·)`, which every such type supports and which
# is exact for the in-range `f`. The hardware-float union is spelled out
# rather than via the non-public `Base.IEEEFloat` alias.
const _HardwareFloat = Union{Float16, Float32, Float64}
@inline _uniform_floor_index(f::_HardwareFloat) = unsafe_trunc(Int, floor(f))
@inline _uniform_floor_index(f) = floor(Int, f)
@inline _uniform_ceil_index(f::_HardwareFloat) = unsafe_trunc(Int, ceil(f))
@inline _uniform_ceil_index(f) = ceil(Int, f)

@inline function _kernel_last_uniform_step_props(
        props::SearchProperties, v::AbstractVector, x, order::Base.Order.Ordering,
    )
    _uniformstep_supported_order(order) ||
        return _kernel_last_binary_bracket(v, x, order)
    isempty(v) && return firstindex(v) - 1
    diff = x - props.first_val
    if diff isa AbstractFloat && !isfinite(diff)
        # NaN → "x precedes nothing"; ±Inf direction depends on sign of step.
        # `inv_step < 0` iff the range is decreasing.
        return isnan(diff) ? (firstindex(v) - 1) :
            (diff > 0) ⊻ (props.inv_step < 0) ? lastindex(v) :
            firstindex(v) - 1
    end
    nm1 = length(v) - 1
    f = diff * props.inv_step
    # Clamp in the float domain before truncating: `f` can exceed
    # `typemax(Int)` for finite extreme `x`, where `unsafe_trunc` is UB.
    # `f` is NaN when `diff == 0` and `inv_step == Inf` (caller-supplied
    # `is_uniform = true` on a zero-span vector).
    isnan(f) && return _kernel_last_binary_bracket(v, x, order)
    i = if f < 0
        firstindex(v) - 1
    elseif f >= nm1
        lastindex(v)
    else
        firstindex(v) + _uniform_floor_index(f)
    end
    # Walk to the true cell. For exactly-uniform data this takes at most
    # one step (float roundoff); it also keeps the result correct when
    # `is_uniform` came from the sampled probe but the data is not
    # uniform between the sampled points.
    @inbounds while i < lastindex(v) && !Base.Order.lt(order, x, v[i + 1])
        i += 1
    end
    @inbounds while i >= firstindex(v) && Base.Order.lt(order, x, v[i])
        i -= 1
    end
    return i
end

@inline function _kernel_first_uniform_step_props(
        props::SearchProperties, v::AbstractVector, x, order::Base.Order.Ordering,
    )
    _uniformstep_supported_order(order) ||
        return _kernel_first_binary_bracket(v, x, order)
    isempty(v) && return firstindex(v)
    diff = x - props.first_val
    if diff isa AbstractFloat && !isfinite(diff)
        return isnan(diff) ? (lastindex(v) + 1) :
            (diff > 0) ⊻ (props.inv_step < 0) ? lastindex(v) + 1 :
            firstindex(v)
    end
    nm1 = length(v) - 1
    f = diff * props.inv_step
    isnan(f) && return _kernel_first_binary_bracket(v, x, order)
    i = if f <= 0
        firstindex(v)
    elseif f > nm1
        lastindex(v) + 1
    else
        firstindex(v) + _uniform_ceil_index(f)
    end
    @inbounds while i > firstindex(v) && !Base.Order.lt(order, v[i - 1], x)
        i -= 1
    end
    @inbounds while i <= lastindex(v) && Base.Order.lt(order, v[i], x)
        i += 1
    end
    return i
end

using FindFirstFunctions, StableRNGs, BenchmarkTools, Statistics, Printf

const F = FindFirstFunctions

# --------------------------------------------------------------------------
# Strategy registry — every strategy that competes in the sorted-batched
# regime. BinaryBracket is excluded from the per-cell winner pool because it
# never wins under any reasonable workload (no hint = full binary search
# per query); it's only useful as a fallback. Auto's actual choices are
# LinearScan / SIMDLinearScan / ExpFromLeft / InterpolationSearch.
# --------------------------------------------------------------------------
const STRATS = [
    ("LinearScan", F.LinearScan()),
    ("SIMDLinearScan", F.SIMDLinearScan()),
    ("BracketGallop", F.BracketGallop()),
    ("ExpFromLeft", F.ExpFromLeft()),
    ("InterpolationSearch", F.InterpolationSearch()),
]

# --------------------------------------------------------------------------
# v patterns (sorted vectors of length n)
# --------------------------------------------------------------------------
function make_v(::Val{:uniform}, ::Type{T}, n, seed) where {T <: AbstractFloat}
    return collect(T, range(zero(T), T(n); length = n))
end
function make_v(::Val{:uniform}, ::Type{T}, n, seed) where {T <: Integer}
    return collect(T, T(1):T(n))
end
function make_v(::Val{:jittered}, ::Type{T}, n, seed) where {T <: AbstractFloat}
    rng = StableRNG(seed)
    base = collect(range(0.0, Float64(n); length = n))
    return convert(Vector{T}, sort!(base .+ 0.1 .* (rand(rng, n) .- 0.5)))
end
function make_v(::Val{:jittered}, ::Type{T}, n, seed) where {T <: Integer}
    rng = StableRNG(seed)
    raw = sort!(unique!(rand(rng, T(1):T(2n), n)))
    return convert(Vector{T}, raw)
end
function make_v(::Val{:logspaced}, ::Type{T}, n, seed) where {T <: AbstractFloat}
    return collect(T, exp.(range(0.0, log(1.0e6); length = n)))
end
function make_v(::Val{:logspaced}, ::Type{T}, n, seed) where {T <: Integer}
    raw = sort!(unique!(round.(T, exp.(range(0.0, log(Float64(10n)); length = n)))))
    return convert(Vector{T}, raw)
end
function make_v(::Val{:twoscale}, ::Type{T}, n, seed) where {T <: AbstractFloat}
    h = n ÷ 2
    return convert(
        Vector{T},
        sort!(vcat(range(0.0, 0.1n; length = h), range(0.1n, Float64(n); length = n - h)))
    )
end
function make_v(::Val{:twoscale}, ::Type{T}, n, seed) where {T <: Integer}
    h = n ÷ 2
    a = round.(T, range(1.0, 0.1n; length = h))
    b = round.(T, range(0.1n + 1, Float64(n); length = n - h))
    return convert(Vector{T}, sort!(vcat(a, b)))
end
function make_v(::Val{:random_sorted}, ::Type{T}, n, seed) where {T <: AbstractFloat}
    return convert(Vector{T}, sort!(rand(StableRNG(seed), n) .* n))
end
function make_v(::Val{:random_sorted}, ::Type{T}, n, seed) where {T <: Integer}
    return convert(Vector{T}, sort!(rand(StableRNG(seed), T(1):T(10n), n)))
end

# --------------------------------------------------------------------------
# query patterns
# --------------------------------------------------------------------------
function _to_eltype(v, xs)
    T = eltype(v)
    return T <: Integer ? convert(Vector{T}, round.(T, xs)) : convert(Vector{T}, xs)
end
function make_q(::Val{:dense}, v, m, seed)
    raw = collect(range(Float64(first(v)), Float64(last(v)); length = m))
    return _to_eltype(v, raw)
end
function make_q(::Val{:sparse}, v, m, seed)
    rng = StableRNG(seed)
    span = Float64(last(v)) - Float64(first(v))
    raw = sort!(Float64(first(v)) .+ rand(rng, m) .* span)
    return _to_eltype(v, raw)
end
function make_q(::Val{:clustered}, v, m, seed)
    rng = StableRNG(seed)
    j = max(1, length(v) ÷ 4)
    lo = Float64(v[j])
    hi = Float64(v[min(j + 1, length(v))])
    span = hi - lo
    raw = sort!(lo .+ rand(rng, m) .* max(span, 1.0))
    return _to_eltype(v, raw)
end
function make_q(::Val{:sorted_random}, v, m, seed)
    rng = StableRNG(seed)
    span = Float64(last(v)) - Float64(first(v))
    raw = sort!(Float64(first(v)) .+ rand(rng, m) .* span)
    return _to_eltype(v, raw)
end

# --------------------------------------------------------------------------
# Bench a single (v, queries, strategy) cell. Returns time in nanoseconds.
# Uses a fixed-repeat loop to avoid BenchmarkTools per-call overhead, which
# dominates fast strategies on small m.
# --------------------------------------------------------------------------
function bench_one(v, queries, strat, out, reps::Int = 5)
    # Warm up
    F.searchsortedlast!(out, v, queries; strategy = strat)
    # Measure
    best = typemax(Float64)
    for _ in 1:reps
        t = @elapsed F.searchsortedlast!(out, v, queries; strategy = strat)
        best = min(best, t)
    end
    return best * 1.0e9 / length(queries)   # ns per query
end

# --------------------------------------------------------------------------
# Full sweep
# --------------------------------------------------------------------------
function run_sweep(;
        v_kinds = (:uniform, :jittered, :logspaced, :twoscale, :random_sorted),
        q_kinds = (:dense, :sparse, :clustered, :sorted_random),
        ns = (256, 1024, 4096, 16_384, 65_536),
        ms = (4, 16, 64, 256, 1024, 4096),
        eltypes = (Int64, Float64),
        seed = 2026,
    )
    rows = []
    cell_idx = 0
    n_cells = length(v_kinds) * length(q_kinds) * length(ns) * length(ms) * length(eltypes)

    for T in eltypes, v_kind in v_kinds, q_kind in q_kinds, n in ns, m in ms
        m > n && continue
        cell_idx += 1
        v = make_v(Val(v_kind), T, n, seed)
        q = make_q(Val(q_kind), v, m, seed + 1)
        out = Vector{Int}(undef, m)

        # Build SearchProperties for the cached-Auto comparison
        props = F.SearchProperties(v)

        times = Dict{String, Float64}()
        for (name, strat) in STRATS
            t = bench_one(v, q, strat, out)
            times[name] = t
        end
        # Auto (un-cached) and Auto (cached)
        times["Auto"] = bench_one(v, q, F.Auto(), out)
        times["Auto+props"] = bench_one(v, q, F.Auto(props), out)

        push!(
            rows, (
                eltype = string(T),
                v_kind = string(v_kind),
                q_kind = string(q_kind),
                n = n,
                m = m,
                times = times,
            )
        )

        if cell_idx % 25 == 0
            best_explicit = minimum(times[s] for s in first.(STRATS))
            @printf(
                "  [%4d/%4d] %s/%s/%s n=%d m=%d  best=%.0f ns/q  Auto=%.0f  Auto+p=%.0f\n",
                cell_idx, n_cells, T, v_kind, q_kind, n, m,
                best_explicit, times["Auto"], times["Auto+props"]
            )
        end
    end
    return rows
end

# --------------------------------------------------------------------------
# Analyze: per-cell winner, Auto slack vs best
# --------------------------------------------------------------------------
function analyze(rows)
    strat_names = first.(STRATS)
    summary = Dict{String, Int}()
    auto_slacks = Float64[]
    auto_cached_slacks = Float64[]

    for r in rows
        # Find the per-cell winner among the explicit strategies.
        per_cell = [(s, r.times[s]) for s in strat_names]
        best_t = minimum(p[2] for p in per_cell)
        best_name = first(per_cell[argmin([p[2] for p in per_cell])])
        summary[best_name] = get(summary, best_name, 0) + 1
        push!(auto_slacks, r.times["Auto"] / best_t)
        push!(auto_cached_slacks, r.times["Auto+props"] / best_t)
    end

    println()
    println("Per-cell winners (across $(length(rows)) cells):")
    for name in strat_names
        n = get(summary, name, 0)
        @printf("  %-22s %5d cells (%5.1f%%)\n", name, n, 100 * n / length(rows))
    end

    println()
    @printf("Auto slack (Auto-time / per-cell-best-time):\n")
    @printf(
        "  median %.2fx, mean %.2fx, p90 %.2fx, p95 %.2fx, max %.2fx\n",
        median(auto_slacks), mean(auto_slacks),
        quantile(auto_slacks, 0.9), quantile(auto_slacks, 0.95),
        maximum(auto_slacks)
    )
    @printf("Auto(props) slack:\n")
    @printf(
        "  median %.2fx, mean %.2fx, p90 %.2fx, p95 %.2fx, max %.2fx\n",
        median(auto_cached_slacks), mean(auto_cached_slacks),
        quantile(auto_cached_slacks, 0.9), quantile(auto_cached_slacks, 0.95),
        maximum(auto_cached_slacks)
    )

    return summary, auto_slacks, auto_cached_slacks
end

function print_worst_cells(rows, k = 20)
    strat_names = first.(STRATS)
    println()
    println("Worst Auto-slack cells (current Auto picks strategy that's much slower than optimal):")
    @printf(
        "  %-7s %-15s %-15s %6s %6s   %-20s slack(Auto) slack(Auto+p)\n",
        "eltype", "v_kind", "q_kind", "n", "m", "best (time)"
    )
    scored = [
        (r, r.times["Auto"] / minimum(r.times[s] for s in strat_names))
            for r in rows
    ]
    sort!(scored; by = x -> -x[2])
    for (r, slack) in scored[1:min(k, length(scored))]
        best_t = minimum(r.times[s] for s in strat_names)
        best_name = strat_names[argmin([r.times[s] for s in strat_names])]
        slack_cached = r.times["Auto+props"] / best_t
        @printf(
            "  %-7s %-15s %-15s %6d %6d   %-15s %.0fns  %5.2fx     %5.2fx\n",
            r.eltype, r.v_kind, r.q_kind, r.n, r.m, best_name, best_t,
            slack, slack_cached
        )
    end
    return
end

println("FindFirstFunctions Auto algorithm benchmark sweep")
println("="^70)
println("Strategies:")
for (name, _) in STRATS
    println("  ", name)
end
println("Plus: Auto(), Auto(SearchProperties(v))")
println()
println("Starting sweep...")
println()

@time rows = run_sweep()

println()
println("Sweep complete.")
println()

analyze(rows)
print_worst_cells(rows, 30)

open(joinpath(@__DIR__, "results.csv"), "w") do io
    header = ["eltype", "v_kind", "q_kind", "n", "m"]
    append!(header, first.(STRATS))
    push!(header, "Auto", "Auto+props")
    println(io, join(header, ","))
    for r in rows
        cols = String[r.eltype, r.v_kind, r.q_kind, string(r.n), string(r.m)]
        for s in first.(STRATS)
            push!(cols, string(r.times[s]))
        end
        push!(cols, string(r.times["Auto"]))
        push!(cols, string(r.times["Auto+props"]))
        println(io, join(cols, ","))
    end
end
println("\nRaw data: bench/results.csv")

# Auto strategy — resolves a `StrategyKind` from `(v, props)` at
# construction time. Per-query dispatch is then a one-line forward to
# `searchsorted_last` / `searchsorted_first` on the stored kind. The batched dispatch
# (in `batched.jl`) re-resolves the kind from `(v, queries)` because the
# gap heuristic needs the queries.
#
# This file owns:
#   - The crossover constants (`_AUTO_LINEAR_THRESHOLD`, etc.)
#   - The helper predicates (`_auto_is_uniform`, `_auto_simd_eligible`,
#     `_estimate_avg_gap`, `_auto_interp_eligible`, …)
#   - `_auto_resolve_kind(v, props)` — forward-declared in `strategies.jl`
#   - The per-query `searchsorted_last(::Auto, ...)` / `searchsorted_first(::Auto, ...)`
#     methods.

# Per-query Auto threshold: under this length, the bracket-search bookkeeping
# costs more than a worst-case linear walk.
const _AUTO_LINEAR_THRESHOLD = 16

# Batched-Auto crossover: at gap ≤ 4 LinearScan beats ExpFromLeft.
const _AUTO_BATCH_LINEAR_GAP = 4

# Sparse-on-large-linear: InterpolationSearch beats ExpFromLeft.
const _AUTO_INTERP_MIN_GAP = 8
const _AUTO_INTERP_MIN_N = 1024
const _AUTO_INTERP_MIN_M = 2

# Very-sparse override: looser linearity tolerance at large gaps.
const _AUTO_INTERP_LOOSE_GAP = 256
const _AUTO_LINEAR_LOOSE_TOLERANCE = 5.0e-2

# SIMDLinearScan eligibility window. The threshold is eltype-parameterized.
@inline _auto_simd_gap_max(::DenseVector{Int64}) = 64
@inline _auto_simd_gap_max(::DenseVector{Float64}) = 64
@inline _auto_simd_gap_max(::AbstractVector) = 0   # not SIMD-eligible

# When InterpolationSearch isn't eligible and the gap is large,
# BracketGallop beats ExpFromLeft.
const _AUTO_GALLOP_GAP_MIN = 16

# Returns `(gap, skewed)`: the estimated average step in `v`'s index space
# between consecutive query results, plus a flag that's true when the
# queries' distribution is non-uniform within their span.
@inline function _estimate_avg_gap(
        v::AbstractVector{<:Number}, queries::AbstractVector{<:Number}, m::Integer,
    )
    n = length(v)
    n <= 1 && return (0, false)
    @inbounds span_v = v[end] - v[1]
    if iszero(span_v) || !isfinite(span_v)
        return (n ÷ max(1, m), false)
    end
    @inbounds span_q = queries[end] - queries[1]
    skewed = false
    if m >= 10
        @inbounds mid_q = queries[firstindex(queries) + m ÷ 2]
        @inbounds expected_mid = (
            queries[firstindex(queries)] +
                queries[lastindex(queries)]
        ) / 2
        if !iszero(span_q) &&
                abs(mid_q - expected_mid) > 0.2 * abs(span_q)
            skewed = true
        end
    end
    ratio = span_q / span_v
    ratio = clamp(ratio, zero(ratio), one(ratio))
    return (floor(Int, n * ratio / max(1, m)), skewed)
end

# Non-numeric eltypes.
@inline _estimate_avg_gap(
    v::AbstractVector, ::AbstractVector, m::Integer,
) = (length(v) ÷ max(1, m), false)

# SIMD eligibility for the batched Auto dispatch.
@inline _auto_simd_eligible(v::DenseVector{Int64}, ::SearchProperties) = true
@inline function _auto_simd_eligible(v::DenseVector{Float64}, p::SearchProperties)
    return p.has_props ? !p.has_nan : true
end
@inline _auto_simd_eligible(::AbstractVector, ::SearchProperties) = false

# Uniformity check. `AbstractRange{<:Real}` is always uniform; for non-Real
# range eltypes (e.g. Unitful `StepRange{Quantity}`) the props-aware
# closed-form path is unsafe, so we fall through to the `is_uniform` flag
# in `props` — which is `false` for non-Real numeric eltypes (set by the
# `SearchProperties(::AbstractVector{<:Number})` overload).
@inline _auto_is_uniform(::AbstractRange{<:Real}, ::SearchProperties) = true
@inline _auto_is_uniform(::AbstractVector, p::SearchProperties) =
    p.has_props && p.is_uniform

# InterpolationSearch eligibility: two-tier linearity check.
@inline function _auto_interp_eligible(v, props::SearchProperties, gap::Integer)
    if gap >= _AUTO_INTERP_LOOSE_GAP
        return _sampled_looks_linear(v, _AUTO_LINEAR_LOOSE_TOLERANCE)
    end
    return props.has_props ? props.is_linear : _sampled_looks_linear(v)
end

# `_auto_resolve_kind` is forward-declared in `strategies.jl` so `Auto(v)`
# can call it from the struct's constructor. The body lives here so it can
# use the helpers above. This is *construction-time* resolution — the hint
# isn't known yet, so we pick a kind that handles every hint configuration
# robustly.
@inline function _auto_resolve_kind(v::AbstractVector, props::SearchProperties)
    if _auto_is_uniform(v, props)
        return KIND_UNIFORM_STEP
    elseif length(v) <= _AUTO_LINEAR_THRESHOLD
        return KIND_LINEAR_SCAN
    else
        return KIND_BRACKET_GALLOP
    end
end

# ---------------------------------------------------------------------------
# Per-query Auto dispatch. The stored kind handles every hint configuration
# robustly — `BracketGallop` falls back to a full search when the hint is
# absent or out of range; `LinearScan` (picked for short `v`) clamps the
# hint and walks. So `searchsorted_last(::Auto, v, x, hint)` is a one-line
# forward to the kind dispatcher.
#
# Special case: when `kind === KIND_UNIFORM_STEP` and `props` is
# populated, we route to the props-aware kernel that uses the precomputed
# `inv_step` from `props`, skipping the per-query float division in the
# plain (`fld`-based) `UniformStep` kernel. An `Auto` holding the
# sentinel `SearchProperties()` has `inv_step = 0`, which would silently
# degrade the closed-form guess to a linear walk — the `has_props` guard
# sends it to the `fld`-based kind kernel instead, matching the guard in
# the batched path.
# ---------------------------------------------------------------------------

# Hinted form: forward to the kind dispatcher.
@inline function searchsorted_last(
        s::Auto, v::AbstractVector, x, hint::Integer;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    return if s.kind === KIND_UNIFORM_STEP && s.props.has_props
        _kernel_last_uniform_step_props(s.props, v, x, order)
    else
        searchsorted_last(s.kind, v, x, hint; order = order)
    end
end

@inline function searchsorted_first(
        s::Auto, v::AbstractVector, x, hint::Integer;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    return if s.kind === KIND_UNIFORM_STEP && s.props.has_props
        _kernel_first_uniform_step_props(s.props, v, x, order)
    else
        searchsorted_first(s.kind, v, x, hint; order = order)
    end
end

# No-hint form: same forward. The kind's no-hint dispatch handles
# fall-through to BinaryBracket for hint-using strategies.
@inline function searchsorted_last(
        s::Auto, v::AbstractVector, x;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    return if s.kind === KIND_UNIFORM_STEP && s.props.has_props
        _kernel_last_uniform_step_props(s.props, v, x, order)
    else
        searchsorted_last(s.kind, v, x; order = order)
    end
end

@inline function searchsorted_first(
        s::Auto, v::AbstractVector, x;
        order::Base.Order.Ordering = Base.Order.Forward,
    )
    return if s.kind === KIND_UNIFORM_STEP && s.props.has_props
        _kernel_first_uniform_step_props(s.props, v, x, order)
    else
        searchsorted_first(s.kind, v, x; order = order)
    end
end

# FindFirstFunctions.jl

FindFirstFunctions.jl is a library of accelerated `findfirst`-style and
sorted-search routines. The package provides:

  - A **strategy-dispatched** sorted-search API: a single pair of
    `Base.searchsortedfirst` / `Base.searchsortedlast` overloads that take a
    [`SearchStrategy`](@ref FindFirstFunctions.SearchStrategy) as the first
    positional argument.
  - **Batched** in-place lookups
    [`searchsortedfirst!`](@ref FindFirstFunctions.searchsortedfirst!) /
    [`searchsortedlast!`](@ref FindFirstFunctions.searchsortedlast!) that pick
    a strategy automatically.
  - **Guessers** that supply per-vector hints based on linear extrapolation
    or a cached previous result.
  - **Equality search** via [`findfirstequal`](@ref FindFirstFunctions.findfirstequal)
    and [`findfirstsortedequal`](@ref FindFirstFunctions.findfirstsortedequal).

## Installation

```julia
using Pkg
Pkg.add("FindFirstFunctions")
```

## Guide

  - [Interface and extension rules](@ref) — the public API surface, the
    contract a `SearchStrategy` subtype must satisfy, and how to add a new
    one.
  - [Search strategies](@ref) — catalog of the built-in strategies, when each
    one is fast, and when it falls back to plain binary search.
  - [Guessers](@ref) — the [`Guesser`](@ref FindFirstFunctions.Guesser) type
    and how to plug it into the strategy dispatch via
    [`GuesserHint`](@ref FindFirstFunctions.GuesserHint).
  - [Auto: heuristics and benchmarks](@ref) — what
    [`Auto`](@ref FindFirstFunctions.Auto) picks in every regime, the
    crossover constants, and the benchmark script that validates them.
  - [Equality search](@ref) — the dedicated equality routines
    [`findfirstequal`](@ref FindFirstFunctions.findfirstequal) and
    [`findfirstsortedequal`](@ref FindFirstFunctions.findfirstsortedequal),
    which live outside the strategy framework because their return type is
    `Union{Int, Nothing}`.

## Quick example

```julia
using FindFirstFunctions

v = collect(0.0:0.1:10.0)
queries = sort!(rand(100) .* 10)

# Single query with a hint.
i = searchsorted_last(BracketGallop(), v, 3.14, 30)

# Batched, with strategy chosen by Auto.
idx = Vector{Int}(undef, length(queries))
searchsortedlast!(idx, v, queries)
```

## Contributing

  - Please refer to the
    [SciML ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://sciml.github.io/ColPrac/stable/)
    for guidance on PRs, issues, and other matters relating to contributing to SciML.

  - See the [SciML Style Guide](https://github.com/SciML/SciMLStyle) for common coding practices and other style decisions.
  - There are a few community forums:
    
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Slack](https://julialang.org/slack/)
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Zulip](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
      + On the [Julia Discourse forums](https://discourse.julialang.org)
      + See also [SciML Community page](https://sciml.ai/community/)

## Reproducibility

```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```

```@example
using Pkg # hide
Pkg.status() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>and using this machine and Julia version.</summary>
```

```@example
using InteractiveUtils # hide
versioninfo() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```

```@example
using Pkg # hide
Pkg.status(; mode = PKGMODE_MANIFEST) # hide
```

```@raw html
</details>
```

```@eval
using TOML
using Markdown
version = TOML.parse(read("../../Project.toml", String))["version"]
name = TOML.parse(read("../../Project.toml", String))["name"]
link_manifest = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
                "/assets/Manifest.toml"
link_project = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
               "/assets/Project.toml"
Markdown.parse("""You can also download the
[manifest]($link_manifest)
file and the
[project]($link_project)
file.
""")
```

# Interface and extension rules

This page documents the public sorted-search API surface and the contract a
custom [`SearchStrategy`](@ref FindFirstFunctions.SearchStrategy) subtype
must satisfy.

## Public API surface

The sorted-search public API is the pair of FFF-owned generic functions
dispatched on a strategy as the first positional argument:

```julia
searchsorted_first(strategy, v, x[, hint]; order = Base.Order.Forward)
searchsorted_last(strategy, v, x[, hint]; order = Base.Order.Forward)
```

`strategy` is a [`StrategyKind`](@ref FindFirstFunctions.StrategyKind) enum
value (`KIND_BRACKET_GALLOP`, …), a singleton strategy struct
(`BracketGallop()`, … — forwards through
[`strategy_kind`](@ref FindFirstFunctions.strategy_kind) and constant-folds
for a literal argument), or a stateful strategy (`Auto`, `GuesserHint`).

The in-place batched variants:

```julia
searchsortedfirst!(idx_out, v, queries; strategy = Auto(), order = Base.Order.Forward)
searchsortedlast!(idx_out, v, queries; strategy = Auto(), order = Base.Order.Forward)
```

FindFirstFunctions does not extend `Base.searchsortedfirst` /
`Base.searchsortedlast` — all strategy dispatch happens through the
FFF-owned names above, which compose with the same `Base.Order` orderings.

```@docs
FindFirstFunctions.searchsortedfirst!
FindFirstFunctions.searchsortedlast!
FindFirstFunctions.searchsortedrange
```

## Rules of the interface

  1. **Hint is optional and is an `Integer`.** When supplied it must be a
     valid index into `v` (`firstindex(v) ≤ hint ≤ lastindex(v)`). An
     out-of-range hint is silently treated as "no hint" by every built-in
     strategy. A strategy is allowed to ignore the hint entirely
     ([`InterpolationSearch`](@ref FindFirstFunctions.InterpolationSearch),
     [`BinaryBracket`](@ref FindFirstFunctions.BinaryBracket)).
  2. **Strategies are singletons or wrappers.** `LinearScan`, `BracketGallop`,
     `ExpFromLeft`, `InterpolationSearch`, and `BinaryBracket` are
     zero-field singletons mapped to their `StrategyKind` tag by
     `strategy_kind`. [`Auto`](@ref FindFirstFunctions.Auto) carries a
     resolved kind plus a `SearchProperties` payload;
     [`GuesserHint`](@ref FindFirstFunctions.GuesserHint) is a thin wrapper
     around a [`Guesser`](@ref FindFirstFunctions.Guesser). New strategies
     should follow the same pattern: parameters that change *behaviour*
     belong on the type; parameters that change *cost only* should be tuned
     internally.
  3. **No mutation of `v` or `x`.** A strategy never writes to the searched
     vector or to the query. The only state that may change across calls is
     hint state carried by the strategy itself (e.g. `GuesserHint` updates
     `guesser.idx_prev`).
  4. **Order is honored.** Every strategy accepts an `order::Base.Order.Ordering`
     keyword and returns indices consistent with `Base.searchsortedfirst` /
     `Base.searchsortedlast` under that ordering. Strategies that are only
     efficient under `Forward` ordering (e.g. `InterpolationSearch`,
     `ExpFromLeft`) fall back to `BinaryBracket` for non-`Forward` orderings.
  5. **`AbstractRange` is already O(1).** `Base.searchsortedfirst(r::AbstractRange, x)`
     has a closed-form implementation. Strategies do not need range fast
     paths — the `BinaryBracket` fallback already calls into Base's
     range-aware method.

## Anatomy of a strategy

A built-in singleton strategy consists of a `StrategyKind` enum value, a
pair of kernel functions (`_kernel_last_<name>` / `_kernel_first_<name>` in
`src/kernels.jl`), and branches in the four dispatch switches in
`src/kinds.jl` (hinted/unhinted × last/first). The "no hint" branch of a
hint-using strategy falls back to `BinaryBracket`; the hinted branch of a
hint-ignoring strategy discards the hint.

A custom strategy defined outside the package cannot add an enum value
(the enum is closed), so it provides its own `searchsorted_last` / `searchsorted_first`
methods instead — these are more specific than the generic
`SearchStrategy` fallback and take precedence:

```julia
# Required: the hinted form (the strategy's reason for existing).
FindFirstFunctions.searchsorted_last(::MyStrategy, v, x, hint::Integer; order) = ...
FindFirstFunctions.searchsorted_first(::MyStrategy, v, x, hint::Integer; order) = ...

# Required: the unhinted form. Most strategies just fall back to BinaryBracket.
FindFirstFunctions.searchsorted_last(::MyStrategy, v, x; order) =
    FindFirstFunctions.searchsorted_last(FindFirstFunctions.KIND_BINARY_BRACKET, v, x; order)
FindFirstFunctions.searchsorted_first(::MyStrategy, v, x; order) =
    FindFirstFunctions.searchsorted_first(FindFirstFunctions.KIND_BINARY_BRACKET, v, x; order)
```

If your strategy ignores the hint, define just the unhinted form and have the
hinted form delegate to it (see `BinaryBracket` and `InterpolationSearch` in
the source).

## How to add a new strategy

Two steps.

### 1. Define the strategy type

Pick a name that describes the *algorithm*, not the use case. Make it a
subtype of [`SearchStrategy`](@ref FindFirstFunctions.SearchStrategy):

```julia
"""
    MyStrategy <: FindFirstFunctions.SearchStrategy

One sentence on what it does. One sentence on when it wins. One sentence on
when it falls back.
"""
struct MyStrategy <: FindFirstFunctions.SearchStrategy end
```

If your strategy carries state (like `GuesserHint`), make it a parametric
struct:

```julia
struct MyStrategy{S} <: FindFirstFunctions.SearchStrategy
    state::S
end
```

### 2. Implement the dispatch methods

At minimum, the hinted forms:

```julia
function FindFirstFunctions.searchsorted_last(
        ::MyStrategy, v::AbstractVector, x, hint::Integer;
        order::Base.Order.Ordering = Base.Order.Forward
    )
    # Algorithm body. Must return the same index that
    # `Base.searchsortedlast(v, x, order)` would.
    ...
end

function FindFirstFunctions.searchsorted_first(
        ::MyStrategy, v::AbstractVector, x, hint::Integer;
        order::Base.Order.Ordering = Base.Order.Forward
    )
    ...
end
```

Plus unhinted forms (typically fallbacks):

```julia
FindFirstFunctions.searchsorted_last(s::MyStrategy, v::AbstractVector, x; order = Base.Order.Forward) =
    FindFirstFunctions.searchsorted_last(FindFirstFunctions.KIND_BINARY_BRACKET, v, x; order = order)
FindFirstFunctions.searchsorted_first(s::MyStrategy, v::AbstractVector, x; order = Base.Order.Forward) =
    FindFirstFunctions.searchsorted_first(FindFirstFunctions.KIND_BINARY_BRACKET, v, x; order = order)
```

When a strategy contributes to the package itself, add a `StrategyKind`
enum value, the kernel pair, the four dispatch-switch branches, and a
`strategy_kind` method instead — see `src/kinds.jl` and
`src/strategy_kind.jl`.

### Correctness check

Every strategy must return the same answer as plain `Base.searchsortedlast` /
`Base.searchsortedfirst` for every `(v, x[, hint])` triple. Test with random
inputs against `Base`:

```julia
using Test, Random
using FindFirstFunctions: searchsorted_last, searchsorted_first
Random.seed!(0)
for trial in 1:10_000
    v = sort!(randn(rand(1:1000)))
    x = randn()
    hint = rand(1:length(v))
    @test searchsorted_last(MyStrategy(), v, x, hint) == searchsortedlast(v, x)
    @test searchsorted_first(MyStrategy(), v, x, hint) == searchsortedfirst(v, x)
end
```

### Hooking into `Auto`

`Auto`'s decision tree lives in `_auto_resolve_kind` (construction-time)
and `_auto_batched_kind` (batched). It is **not extensible from outside** —
new strategies do not register themselves with `Auto` automatically. If you
believe `Auto` should pick your strategy in some regime, open an issue with
benchmark numbers across the regime grid in
[Auto: heuristics and benchmarks](@ref).

# Equality search

This page documents the package's equality-search routines —
[`findfirstequal`](@ref FindFirstFunctions.findfirstequal) and
[`findfirstsortedequal`](@ref FindFirstFunctions.findfirstsortedequal). They
answer a *different* question from the [Search strategies](@ref) covered
elsewhere:

  - **Sorted-search** strategies answer "*where would `x` insert?*". The
    return value is always an in-range index — the bracketing position.
  - **Equality** search answers "*does `x` exist, and if so at what index?*".
    The return value is `nothing` if `x` is not present.

These two surfaces live side-by-side because the second cannot be expressed
as a `SearchStrategy` — its return type differs (`Union{Int, Nothing}` vs.
in-range `Int`), and the unsorted variant doesn't even require a sorted
input.

For a strategy-framework-compatible *sorted* equality search that returns
`Int` with a sentinel (so it composes with the rest of the strategy
dispatch), see [`findequal`](@ref FindFirstFunctions.findequal) on the
[Search strategies](@ref) page. `findequal(BisectThenSIMD(), v, x)` is the
strategy entry point that internally calls into the same algorithm as
`findfirstsortedequal`.

## API reference

```@docs
FindFirstFunctions.findfirstequal
FindFirstFunctions.findfirstsortedequal
```

## When to use which

| Question | Vector | Recommended |
|---|---|---|
| Does `x` occur in this *unsorted* vector? | any | [`findfirstequal`](@ref FindFirstFunctions.findfirstequal) |
| Does `x` occur in this *sorted* vector? | `DenseVector{Int64}` + `Int64` | [`findfirstsortedequal`](@ref FindFirstFunctions.findfirstsortedequal) (or `findequal(BisectThenSIMD(), v, x)` for the sentinel-returning variant) |
| Does `x` occur in this *sorted* vector? | other eltypes | [`findequal`](@ref FindFirstFunctions.findequal) with any strategy |
| Where would `x` insert into this sorted vector? | any | `searchsorted_first(strategy, v, x[, hint])` |

## SIMD primitives

Both equality functions are backed by the same SIMD-equality LLVM IR
scaffolding used internally throughout the package (`load <8 x i64>`,
`icmp eq`, `cttz` on the bitmask of the 8-wide compare). The IR template
`FindFirstFunctions._simd_scan_ir` (internal) generates this for the equality
predicate; the same template generates the `>` / `>=` variants for
[`SIMDLinearScan`](@ref FindFirstFunctions.SIMDLinearScan).

The SIMD path is `Int64`-only — the LLVM IR is keyed off `i64` element
width and 8-byte stride. Every other element type and storage layout
falls through to a scalar `findfirst(==(x), v)` path. Specifically:

  - `findfirstequal(x::Int64, v::DenseVector{Int64})` — full SIMD scan.
  - `findfirstequal(x, v)` (generic) — `findfirst(isequal(x), v)`.
  - `findfirstsortedequal(x::Int64, v::DenseVector{Int64})` — branchless
    binary bisection to a small basecase, then SIMD equality scan within
    the basecase window. The bisection uses a strict `<` predicate so
    that earlier duplicates are not skipped (a previous version of the
    routine used `<=` and could return a later duplicate; fixed in 2.0).

## Sentinel vs. `Nothing`

The two equality APIs differ in how they report "not found":

```julia
findfirstequal(x, v)        # -> Union{Int, Nothing}, `nothing` on miss
findfirstsortedequal(x, v)  # -> Union{Int, Nothing}, `nothing` on miss
findequal(strategy, v, x)   # -> Int, firstindex(v) - 1 on miss
```

`findequal`'s sentinel is type-stable and composes with the rest of the
strategy dispatch — that's the recommended choice for new sorted-equality
code. The two `findfirst*equal` names continue to return
`Union{Int, Nothing}` for backwards compatibility with callers and pattern
matching against `nothing`.

# Guessers

A [`Guesser`](@ref FindFirstFunctions.Guesser) is a small wrapper around a
sorted vector that produces an integer index hint for a given query, using
one of two strategies decided at construction time:

  - **Linear-extrapolation lookup**, when `v` is approximately uniformly
    spaced. The guess is `firstindex(v) + round((x - v[1]) / (v[end] - v[1]) * (length(v) - 1))`.
    Cost is O(1) per call, independent of `length(v)`.
  - **Cached previous result**, otherwise. The guesser hands back its
    `idx_prev` field. Useful for callers that issue temporally-correlated
    queries — the previous answer is a good seed for `BracketGallop`.

The Guesser does **not** perform the actual search. To use it as a search
strategy, wrap it in [`GuesserHint`](@ref FindFirstFunctions.GuesserHint).

## Construction

```@docs
FindFirstFunctions.Guesser
```

The threshold passed via `looks_linear_threshold` is the same threshold used
by [`looks_linear`](@ref FindFirstFunctions.looks_linear) (which the Guesser
calls under the hood). The default `1e-2` accepts everything from exact
linear ranges through evenly-spaced grids with mild jitter, but rejects
log-spaced or piecewise-spaced data.

```@docs
FindFirstFunctions.looks_linear
```

## Calling a Guesser

`guesser(x)` returns an integer index hint, but does **not** update any
state. The returned hint may be outside `axes(v)` if `x` is past either end
of `v`; callers should treat the hint as advisory and clamp.

```julia
v = collect(0.0:0.1:10.0)
g = Guesser(v)
g(3.14)   # → 32, an O(1) extrapolation guess
```

For irregular data the same call returns `g.idx_prev[]` — the last index
written by a [`GuesserHint`](@ref FindFirstFunctions.GuesserHint) search (or
`1` if no search has run yet).

## Plugging into the strategy dispatch

[`GuesserHint`](@ref FindFirstFunctions.GuesserHint) is the strategy adapter
that turns a `Guesser` into a `SearchStrategy`. It:

  1. Calls `guesser(x)` to obtain an integer guess.
  2. Dispatches to [`BracketGallop`](@ref FindFirstFunctions.BracketGallop)
     from that guess.
  3. Writes the resulting index back into `guesser.idx_prev`.

```@docs
FindFirstFunctions.GuesserHint
```

Per-call cost is one `guesser(x)` evaluation (O(1)) plus one `BracketGallop`
(O(1) when the guess is close) plus one `idx_prev[]` write.

The vector passed to `searchsortedfirst` / `searchsortedlast` must be the
same object the Guesser wraps — `GuesserHint` asserts `v === s.guesser.v` to
catch the obvious misuse.

```julia
v = collect(0.0:0.1:10.0)
g = Guesser(v)
strat = GuesserHint(g)

i = searchsorted_last(strat, v, 3.14)
@assert g.idx_prev[] == i   # the guesser caches the last result
```

`GuesserHint` ignores any externally-supplied hint — the Guesser carries its
own hint state, and accepting a foreign hint would defeat the cache.

## Pattern: correlated lookups for interpolation

The intended use is a wrapper struct that owns both the sorted vector and a
matching `Guesser`. Every query against the wrapper feeds through
`GuesserHint`:

```julia
struct Interp{V}
    v::V
    g::Guesser{V}
end
Interp(v) = Interp(v, Guesser(v))

function find_segment(itp::Interp, x)
    return searchsorted_last(GuesserHint(itp.g), itp.v, x)
end
```

After warmup, repeated calls to `find_segment` with temporally correlated
`x` cost O(1): the previous result is one slot away from the current
answer, so the `BracketGallop` inside `GuesserHint` returns after a couple
of comparisons.

## When not to use a Guesser

  - **One-shot queries.** Construct cost is O(n) for the `looks_linear`
    probe — wasted if you only intend to search once. Use
    [`BinaryBracket`](@ref FindFirstFunctions.BinaryBracket) or pass `Auto()`
    with no hint.
  - **Sorted batches.** The batched
    [`searchsortedlast!`](@ref FindFirstFunctions.searchsortedlast!) /
    [`searchsortedfirst!`](@ref FindFirstFunctions.searchsortedfirst!) APIs
    already do `prev_result`-style hinting internally; they don't need a
    Guesser and they pick a faster strategy when the sweep is dense.
  - **Strictly random queries against irregular `v`.** `looks_linear` returns
    false, so the Guesser degrades to returning `idx_prev[]`, which is
    useless for random queries. `BracketGallop` from `idx_prev` is fine but
    `Auto`-on-a-batch does the same thing without the Guesser overhead.

# Search strategies

The strategies form the parameter space of the sorted-search API. The
entry points are [`searchsorted_last`](@ref FindFirstFunctions.searchsorted_last) /
[`searchsorted_first`](@ref FindFirstFunctions.searchsorted_first), and a
strategy can be passed to them two ways:

  - **As a [`StrategyKind`](@ref FindFirstFunctions.StrategyKind) enum
    value** (e.g. `KIND_BRACKET_GALLOP`). One enum value per singleton
    strategy; runtime `if/elseif` dispatch into the matching kernel; ~0 ns
    of overhead in hot loops; the inferred return type is concrete
    regardless of which kind is picked at runtime. Use this when the
    strategy is chosen from runtime data.
  - **As a singleton strategy struct** (e.g. `BracketGallop()`). The
    struct forwards through
    [`strategy_kind`](@ref FindFirstFunctions.strategy_kind), which
    constant-folds for a literal strategy argument — so for a literal
    strategy the struct form compiles to exactly the same code as the enum
    form.

FindFirstFunctions does **not** extend `Base.searchsortedlast` /
`Base.searchsortedfirst`. The v2 API that did is removed in v3; these
FFF-owned functions are the only search entry points.

The stateful strategies — [`Auto`](@ref FindFirstFunctions.Auto) and
[`GuesserHint`](@ref FindFirstFunctions.GuesserHint) — carry per-instance
data and so cannot be expressed as singleton enum tags. They dispatch
via their own multimethods.

```@docs
FindFirstFunctions.SearchStrategy
FindFirstFunctions.StrategyKind
FindFirstFunctions.searchsorted_last
FindFirstFunctions.searchsorted_first
FindFirstFunctions.strategy_kind
```

## Kind ↔ strategy mapping

| Enum tag | Strategy struct | Kernel function |
|---|---|---|
| `KIND_BINARY_BRACKET` | `BinaryBracket` | `_kernel_last_binary_bracket` / `_kernel_first_binary_bracket` |
| `KIND_LINEAR_SCAN` | `LinearScan` | `_kernel_last_linear_scan` / `_kernel_first_linear_scan` |
| `KIND_SIMD_LINEAR_SCAN` | `SIMDLinearScan` | `_kernel_last_simd_linear_scan` / `_kernel_first_simd_linear_scan` |
| `KIND_BRACKET_GALLOP` | `BracketGallop` | `_kernel_last_bracket_gallop` / `_kernel_first_bracket_gallop` |
| `KIND_EXP_FROM_LEFT` | `ExpFromLeft` | `_kernel_last_exp_from_left` / `_kernel_first_exp_from_left` |
| `KIND_INTERPOLATION_SEARCH` | `InterpolationSearch` | `_kernel_last_interpolation_search` / `_kernel_first_interpolation_search` |
| `KIND_BIT_INTERPOLATION_SEARCH` | `BitInterpolationSearch` | `_kernel_last_bit_interpolation_search` / `_kernel_first_bit_interpolation_search` |
| `KIND_UNIFORM_STEP` | `UniformStep` | `_kernel_last_uniform_step` / `_kernel_first_uniform_step` |
| `KIND_BISECT_THEN_SIMD` | `BisectThenSIMD` | (positional dispatch falls back to BinaryBracket; equality dispatch goes through `findfirstsortedequal`) |

```@docs
FindFirstFunctions.KIND_BINARY_BRACKET
FindFirstFunctions.KIND_LINEAR_SCAN
FindFirstFunctions.KIND_SIMD_LINEAR_SCAN
FindFirstFunctions.KIND_BRACKET_GALLOP
FindFirstFunctions.KIND_EXP_FROM_LEFT
FindFirstFunctions.KIND_INTERPOLATION_SEARCH
FindFirstFunctions.KIND_BIT_INTERPOLATION_SEARCH
FindFirstFunctions.KIND_UNIFORM_STEP
FindFirstFunctions.KIND_BISECT_THEN_SIMD
```

Stateful strategies that do **not** have an enum tag and stay on the
multimethod path:

  - [`Auto`](@ref FindFirstFunctions.Auto): carries a `StrategyKind` field
    plus a [`SearchProperties`](@ref FindFirstFunctions.SearchProperties)
    cache. `Auto`'s `searchsorted_last` is a one-line forward to the stored
    kind; the batched dispatch re-resolves the kind from
    `(v, queries)` because the gap heuristic needs the queries.
  - [`GuesserHint`](@ref FindFirstFunctions.GuesserHint): carries a
    [`Guesser`](@ref FindFirstFunctions.Guesser) (with its `idx_prev::Ref{Int}`
    and `linear_lookup::Bool`). Dispatches via its own
    `searchsorted_last(::GuesserHint, ...)` / `searchsorted_first(::GuesserHint, ...)`
    methods.

## When to pick which

For most callers the answer is: pass [`Auto`](@ref FindFirstFunctions.Auto)
(the default in the batched API) and let it choose. The table below is for
callers who already know their access pattern and want to pin a strategy.

| Strategy | Best when | Cost when hint hits | Cost worst case | Uses hint? |
|---|---|---|---|---|
| [`LinearScan`](@ref FindFirstFunctions.LinearScan) | answer is within a handful of slots of the hint | O(1) | O(n) | yes |
| [`SIMDLinearScan`](@ref FindFirstFunctions.SIMDLinearScan) | `DenseVector{Int64}` or `DenseVector{Float64}`, forward walk past the hint | O(1) | O(n/8) | yes |
| [`BracketGallop`](@ref FindFirstFunctions.BracketGallop) | answer may be either side of the hint, distance unknown | O(1) | ~2 log₂ n | yes |
| [`ExpFromLeft`](@ref FindFirstFunctions.ExpFromLeft) | sorted batch — hint is `prev_result`, answer is monotonically ≥ hint | O(1) | O(log n) | yes (as lower bound) |
| [`InterpolationSearch`](@ref FindFirstFunctions.InterpolationSearch) | `v` is uniformly spaced and numeric | O(1) | O(log n) | no |
| [`BitInterpolationSearch`](@ref FindFirstFunctions.BitInterpolationSearch) | `DenseVector{Float64}` and log-spaced (geometric) — opt-in, `Auto` does not pick | O(1) | O(log n) | no |
| [`BinaryBracket`](@ref FindFirstFunctions.BinaryBracket) | no hint available, or fallback | O(log n) | O(log n) | no |
| [`UniformStep`](@ref FindFirstFunctions.UniformStep) | `v isa AbstractRange` (or known-uniformly-spaced) | O(1) | O(1) | no |
| [`GuesserHint`](@ref FindFirstFunctions.GuesserHint) | repeated correlated lookups against the same `v` | O(1) | ~2 log₂ n | self-provided |
| [`Auto`](@ref FindFirstFunctions.Auto) | unknown access pattern | varies | varies | yes if supplied |

All hint-consuming strategies fall back to `BinaryBracket` when no hint is
supplied or when the hint is out of range. `InterpolationSearch` additionally
falls back to `BinaryBracket` for non-numeric element types.

## Migrating from v2 (`Base.searchsortedlast(::S, ...)`) to v3

The v2 `Base.searchsortedlast(::S, ...)` / `Base.searchsortedfirst(::S, ...)`
methods are removed in v3. The migration is a mechanical rename —
`searchsortedlast` → `searchsorted_last`, `searchsortedfirst` → `searchsorted_first` —
with the strategy argument unchanged:

```julia
# v2 (removed)
searchsortedlast(BracketGallop(), v, x, hint)
searchsortedfirst(InterpolationSearch(), v, x)
searchsortedlast(Auto(v), v, x, hint)
searchsortedfirst(GuesserHint(g), v, x)

# v3
searchsorted_last(BracketGallop(), v, x, hint)
searchsorted_first(InterpolationSearch(), v, x)
searchsorted_last(Auto(v), v, x, hint)
searchsorted_first(GuesserHint(g), v, x)
```

Hot loops that pick the strategy from runtime data should use the
`StrategyKind` enum form (`searchsorted_last(KIND_BRACKET_GALLOP, v, x, hint)`);
for a literal singleton strategy the struct form compiles to exactly the
same code.

The batched API (`searchsortedlast!`, `searchsortedfirst!`,
`searchsortedrange`) and the equality API (`findequal`,
`findfirstequal`, `findfirstsortedequal`) are FFF-owned names and are
unchanged.

## Reference

```@docs
FindFirstFunctions.LinearScan
FindFirstFunctions.SIMDLinearScan
FindFirstFunctions.BracketGallop
FindFirstFunctions.ExpFromLeft
FindFirstFunctions.InterpolationSearch
FindFirstFunctions.BitInterpolationSearch
FindFirstFunctions.BinaryBracket
FindFirstFunctions.BisectThenSIMD
FindFirstFunctions.UniformStep
FindFirstFunctions.Auto
FindFirstFunctions.SearchProperties
```

## Equality search through the strategy framework

Strategies answer positional questions ("where would `x` insert?"). Equality
asks a different question ("is `x` at exactly which index?"). The
[`findequal`](@ref FindFirstFunctions.findequal) wrapper builds the latter
on top of the former: every strategy gets an equality variant for free.

```@docs
FindFirstFunctions.findequal
```

The sentinel for "not found" is `firstindex(v) - 1` (`= 0` for 1-based
vectors). Type-stable `Int` return, no `Union` with `Nothing`. Callers can
test for absence with `i < firstindex(v)`.

`findequal` routes most strategies through `searchsorted_first + post-check`
generically, so `findequal(BracketGallop(), v, x, hint)`,
`findequal(SIMDLinearScan(), v, x, hint)`,
`findequal(GuesserHint(g), v, x)`, `findequal(KIND_BRACKET_GALLOP, v, x, hint)`,
etc. all just work.

The [`BisectThenSIMD`](@ref FindFirstFunctions.BisectThenSIMD) strategy
short-circuits the post-check path on `DenseVector{Int64}` by dispatching
into [`findfirstsortedequal`](@ref FindFirstFunctions.findfirstsortedequal)
directly — same custom LLVM IR scan, exposed through the strategy framework.

`GuesserHint` is documented on the [Guessers](@ref) page.

## Notes on individual strategies

### LinearScan

Walks `±1` from the hint until the answer is bracketed. Cheapest possible
search when the hint is right next to the answer — two comparisons. The only
strategy whose worst case is O(n), so it should only be picked when the
caller has strong evidence that the hint is close.

For `length(v) ≤ 16`, `LinearScan` is faster than `BracketGallop` even from a
bad hint because the bracket bookkeeping costs more than a worst-case walk
across a vector that short. `Auto`'s resolution rule picks `KIND_LINEAR_SCAN`
below that threshold.

### SIMDLinearScan

Same algorithm as `LinearScan`, with the **forward** walk past the hint
lowered to 8-wide SIMD chunks via custom LLVM IR. The backward walk (when
the hint is past the answer) uses the scalar `LinearScan` path — the SIMD
primitive is only defined in the forward direction.

Specialized for `DenseVector{Int64}` and `DenseVector{Float64}`. Any other
element type falls back to the scalar `LinearScan` walk. The dispatch is
*static* — there's no runtime type test on a hot path.

Caveats:

  - **Element types**: `Int64` and `Float64` only.
  - **NaN**: a `NaN` element in a `Float64` vector compares as `false` —
    the SIMD scan silently skips it. Sorted `Float64` vectors containing
    `NaN` aren't well-defined under any total order.
  - **Order**: `Forward` and `Reverse` only.
  - **No hint**: falls back to [`BinaryBracket`](@ref FindFirstFunctions.BinaryBracket).
  - **Auto does not pick this strategy** by default in the per-query path.
    The batched dispatch picks it inside a gap window where the SIMD chunk
    pays for itself.

### BitInterpolationSearch

`InterpolationSearch` with the extrapolation guess computed on the IEEE
bit pattern of `v` rather than the float values themselves. Wins on
log-spaced (geometric) data — sometimes O(1) versus O(log n) refinement
cost.

**Opt-in only.** `Auto` does not pick `BitInterpolationSearch`.

Falls back to plain `InterpolationSearch` on non-Float64 dense eltypes,
and to `BinaryBracket` for non-positive or non-finite Float64 data.

### BracketGallop

Galloping search around the hint: expand `[lo, hi]` outward by doubling steps
until `x` is bracketed, then binary-search inside `[lo, hi]`. Direction is
inferred from `v[hint]` vs. `x`, so the hint can be either above or below the
answer. Worst case is ~2 log₂ n — about twice plain binary search — and it
matches O(1) when the hint is close.

This is the workhorse hinted strategy and the natural choice for
`get_idx`-style callers where the hint is a cached previous result.

### ExpFromLeft

Exponential search forward from a hint interpreted as a *lower bound*. The
algorithm probes `v[lo], v[lo+1], …, v[lo+4]` linearly, then `v[lo+8],
v[lo+16], …` exponentially, then binary-searches inside the final bracket.

Used by `Auto`'s batched dispatch when the queries are sorted: each call
passes `hint = previous_result`, which by sortedness satisfies the "answer ≥
hint" precondition.

### InterpolationSearch

Computes a guess via linear extrapolation between `v[lo]` and `v[hi]`, then
refines with a bounded binary search around that guess. On uniformly-spaced
numeric data the first guess is the right answer — O(1) per query
independent of `n`.

Two restrictions:

  - **Numeric eltype**: non-numeric eltypes fall back to `BinaryBracket`.
  - **Forward ordering only**: non-`Forward` orderings fall back to
    `BinaryBracket`.

The hint is ignored — the guess is computed fresh from the endpoints.

### BinaryBracket

Plain `Base.searchsortedlast` / `Base.searchsortedfirst`. Provided as a
strategy so callers can opt out of hint-based behaviour explicitly, and so
other strategies have a well-defined name to fall back to. Ignores any
hint.

### Auto

See [Auto: heuristics and benchmarks](@ref) for the full decision tree and
the benchmark sweep that produced its crossover constants.

In v3, `Auto` carries a stored `StrategyKind` plus a `SearchProperties`
cache:

  - `Auto()` defaults to `KIND_BINARY_BRACKET`. Safe but no faster than
    plain `Base.searchsortedlast`.
  - `Auto(v)` resolves the kind from `length(v)` and `SearchProperties(v)`.
    Picks `KIND_UNIFORM_STEP` for `AbstractRange` / detected-uniform
    vectors, `KIND_LINEAR_SCAN` for short vectors, `KIND_BRACKET_GALLOP`
    otherwise.
  - `Auto(v, props)` is the same with a pre-computed `props` cache.

The per-query `searchsorted_last(::Auto, v, x, hint)` is a one-line forward to
`searchsorted_last(s.kind, v, x, hint)`. The batched
`searchsortedlast!(out, v, queries; strategy = Auto())` re-resolves the
kind from `(v, queries)` to consult the gap heuristic.

## Equality routines

The package exposes two `Union{Int, Nothing}`-returning equality routines —
[`findfirstequal`](@ref FindFirstFunctions.findfirstequal) (unsorted SIMD
scan) and [`findfirstsortedequal`](@ref FindFirstFunctions.findfirstsortedequal)
(sorted bisect-then-SIMD scan). See the [Equality search](@ref Equality-search) page for
the full documentation.

# Auto: heuristics and benchmarks

[`Auto`](@ref FindFirstFunctions.Auto) is the default strategy for the
batched API. This page documents the decision tree it follows, the
crossover constants embedded in it, and the benchmark sweep used to
validate them. The numbers below are reproducible on any machine — the
script at the end of the page generates the comparison grid.

## What `Auto` decides

The decision differs between per-query and batched callers.

### Per-query: `searchsorted_last(Auto(v), v, x[, hint])`

The kind is resolved once, at construction, and every per-query call
forwards to it:

```
Auto()  (no data)                            →  KIND_BINARY_BRACKET
Auto(v) and props.is_uniform                 →  KIND_UNIFORM_STEP   # props-aware closed form
Auto(v) and length(v) ≤ 16                   →  KIND_LINEAR_SCAN    # _AUTO_LINEAR_THRESHOLD
Auto(v) otherwise                            →  KIND_BRACKET_GALLOP
```

`Auto` never picks `InterpolationSearch` or `ExpFromLeft` in the per-query
path. Both pay setup costs (endpoint reads for `InterpolationSearch`, 5
linear probes for `ExpFromLeft`) that the per-query path can't amortize.

### Batched: `searchsortedlast!(out, v, queries; strategy = Auto())`

The decision is driven by a single number: the expected average **gap** in
`v`'s index space between consecutive query results. For sorted numeric
queries this is `floor(n * span(queries) / span(v) / m)`; for non-numeric
or pathologically-spaced data it falls back to `n ÷ m`.

```
m == 0                                       →  return out unchanged
m == 1                                       →  one direct unhinted call
queries unsorted                             →  unhinted Base.searchsortedlast loop
gap ≤ 4                                      →  LinearScan
4 < gap ≤ _auto_simd_gap_max(v)
        AND SIMD-eligible (Int64/Float64)    →  SIMDLinearScan
gap ≥ 8 AND n ≥ 1024 AND m ≥ 2
        AND not skewed
        AND linearity probe accepts          →  InterpolationSearch
gap ≥ 16                                     →  BracketGallop
otherwise                                    →  ExpFromLeft
```

`_auto_simd_gap_max(v)` is 64 for `DenseVector{Int64}` and `DenseVector{Float64}`,
and 0 (never picked) for any other element type. For Float64 the SIMD path
requires `v` to be NaN-free; if a populated `SearchProperties(v)` is attached
to `Auto`, the cached `has_nan` flag is consulted, otherwise no-NaN is assumed
(the same trust contract `Base.searchsortedlast` uses for sortedness of `v`).

The "linearity probe accepts" check is tiered:

  - For `_AUTO_INTERP_MIN_GAP ≤ gap < _AUTO_INTERP_LOOSE_GAP` (8 to 256):
    strict 0.1% sampled tolerance — only truly uniform data passes.
  - For `gap ≥ _AUTO_INTERP_LOOSE_GAP` (≥ 256): loose 5% tolerance — at
    these gap sizes, `InterpolationSearch`'s cache benefit compensates for
    a worse guess, and the bounded-binary-search refinement is still
    O(log n). This unlocks `InterpolationSearch` on approximately linear
    data like sorted random or mildly jittered vectors at large `n`.

The "skewed" check guards `InterpolationSearch` from the opposite direction:
if the queries are clustered into one region of their span (median query
more than 20% off the midpoint of the query span), `Auto` falls through to
`BracketGallop` / `ExpFromLeft`, because consecutive queries land in the
same neighbourhood and the previous-result hint is worth more than the
linear-extrapolation guess. Skew detection is gated on `m ≥ 10` — for
smaller `m` the median sampling variance overwhelms the signal.

The `BracketGallop` fallback at `gap ≥ _AUTO_GALLOP_GAP_MIN` (= 16) exists
because, at large gaps, `ExpFromLeft`'s five up-front linear probes are
guaranteed to miss — the answer is much more than 5 elements past the
previous-result hint. `BracketGallop` skips that wasted preamble and starts
doubling from one position past `hint`.

## Crossover constants

The constants are defined at the top of `src/FindFirstFunctions.jl` and
reproduced here so they are easy to find from the docs:

| Constant | Value | What it gates |
|---|---|---|
| `_AUTO_LINEAR_THRESHOLD` | 16 | Per-query `LinearScan` vs `BracketGallop` crossover on hinted calls. |
| `_AUTO_BATCH_LINEAR_GAP` | 4 | Batched `LinearScan` ceiling. |
| `_AUTO_SIMD_GAP_MAX` (Int64 / Float64) | 64 / 64 | Maximum gap for `SIMDLinearScan` on dense Int64 / Float64. |
| `_AUTO_GALLOP_GAP_MIN` | 16 | Above this gap, prefer `BracketGallop` over `ExpFromLeft` when `InterpolationSearch` isn't picked. |
| `_AUTO_INTERP_MIN_GAP` | 8 | Minimum gap below which `InterpolationSearch` is never picked. |
| `_AUTO_INTERP_MIN_N` | 1024 | Minimum `length(v)` below which `InterpolationSearch` is never picked. |
| `_AUTO_INTERP_MIN_M` | 2 | Minimum `length(queries)`; single-query batches skip the heuristic entirely. |
| `_AUTO_INTERP_LOOSE_GAP` | 256 | At this gap, the linearity probe switches to the loose tolerance. |
| `_AUTO_LINEAR_REL_TOLERANCE` | 1.0e-3 | Strict-tier tolerance of the sampled-linearity probe. |
| `_AUTO_LINEAR_LOOSE_TOLERANCE` | 5.0e-2 | Loose-tier tolerance, used for `gap ≥ _AUTO_INTERP_LOOSE_GAP`. |

These are not user-tunable from outside — they shipped with the version of
the package documented here. Tightening or loosening them requires a PR
with new benchmark numbers across the regime grid below.

## Why each branch is there

**`gap ≤ 4 → LinearScan`.** `ExpFromLeft` issues 5 unconditional linear
probes at the start of every call. When the gap is 0 or 1, those probes
are wasted. `LinearScan` walks the same handful of indices with no
bracketing overhead and wins by ~30%. The crossover is empirically at gap
≈ 4 on AVX2 hardware; below that, `LinearScan` is strictly faster.

**`InterpolationSearch` only on linear `v`.** On uniformly-spaced numeric
data, `InterpolationSearch`'s first guess is the answer — one comparison
per query, independent of `n`. On irregular data the guess is bad and the
binary-search fallback runs over the whole vector, costing ~14× more than
`ExpFromLeft` on log-spaced data and ~4× more on two-scale (piecewise
dense+sparse) data. The 0.1% tolerance on the linearity probe is what
keeps it in the linear regime where it wins.

**`ExpFromLeft` is the default sparse-batched choice.** Across every
non-linear `v` pattern tested, `ExpFromLeft` from `prev_result` is within
20% of the per-cell optimum. It handles `gap = 5` (3-5 linear probes,
hit) just as well as `gap = 10⁴` (doubling search across 14 levels) with
no setup cost worth speaking of.

**Skew override.** Even on linear `v`, when consecutive queries land in
the same region (clustered queries), `prev_result` is closer to the
current answer than the linear-extrapolation guess from the endpoints.
`ExpFromLeft` wins in that regime by ~2-3×.

## Reproducing the benchmarks

The full sweep lives at [`bench/auto_sweep.jl`](https://raw.githubusercontent.com/SciML/FindFirstFunctions.jl/main/bench/auto_sweep.jl)
with the regime grid pre-configured. Run with
`julia --project=bench bench/auto_sweep.jl`. It evaluates every shipped
strategy against every regime cell, computes the per-cell winner, and
reports `Auto`'s slack distribution against that optimum. An analysis
helper at [`bench/analyze.jl`](https://raw.githubusercontent.com/SciML/FindFirstFunctions.jl/main/bench/analyze.jl)
reads the resulting `bench/results.csv` and prints per-strategy
win-by-regime tables.

The inline script below is the minimum-viable version of the same sweep —
copy into a file and execute if you want to validate the numbers without
cloning the repository.

```julia
using BenchmarkTools, FindFirstFunctions, Random, Statistics

const STRATEGIES = (
    LinearScan(), BracketGallop(), ExpFromLeft(),
    InterpolationSearch(), BinaryBracket(),
)
const STRAT_NAMES = ("LinearScan", "BracketGallop", "ExpFromLeft",
                     "InterpolationSearch", "BinaryBracket")

# ----- v patterns ------------------------------------------------------------
make_v(:uniform,   n) = collect(range(0.0, 1.0; length = n))
make_v(:jittered,  n) = begin
    rng = Xoshiro(0)
    base = collect(range(0.0, 1.0; length = n))
    sort!(base .+ 0.01 .* (rand(rng, n) .- 0.5) ./ n)
end
make_v(:logspaced, n) = collect(exp.(range(log(1.0), log(1.0e6); length = n)))
make_v(:twoscale,  n) = begin
    h = n ÷ 2
    sort!(vcat(range(0.0, 0.1; length = h),
               range(0.1, 1.0; length = n - h)))
end
make_v(:random,    n) = sort!(rand(Xoshiro(0), n))

# ----- query patterns --------------------------------------------------------
make_q(:dense,     v, m) = collect(range(v[1], v[end]; length = m))
make_q(:sparse,    v, m) = begin
    rng = Xoshiro(1)
    sort!(rand(rng, m) .* (v[end] - v[1]) .+ v[1])
end
make_q(:clustered, v, m) = begin
    # all queries inside one segment of v
    j = length(v) ÷ 4
    sort!(rand(Xoshiro(2), m) .* (v[j + 1] - v[j]) .+ v[j])
end
make_q(:sorted_rand, v, m) = sort!(rand(Xoshiro(3), m) .* (v[end] - v[1]) .+ v[1])

# ----- bench one cell --------------------------------------------------------
function bench_cell(v_kind, q_kind, n, m)
    v = make_v(Val(v_kind), n)
    queries = make_q(Val(q_kind), v, m)
    out = Vector{Int}(undef, m)
    times = Float64[]
    for s in STRATEGIES
        t = @belapsed FindFirstFunctions.searchsortedlast!(
            $out, $v, $queries; strategy = $s
        )
        push!(times, t)
    end
    t_auto = @belapsed FindFirstFunctions.searchsortedlast!(
        $out, $v, $queries; strategy = Auto()
    )
    return times, t_auto
end

# wrap so we can dispatch on Val(:uniform), etc.
make_v(::Val{K}, n) where {K} = make_v(K, n)
make_q(::Val{K}, v, m) where {K} = make_q(K, v, m)

# ----- sweep -----------------------------------------------------------------
function run_sweep()
    ns        = (64, 256, 1024, 4096, 16384, 65536)
    ms        = (1, 4, 16, 64, 256, 1024, 4096)
    v_kinds   = (:uniform, :jittered, :logspaced, :twoscale, :random)
    q_kinds   = (:dense, :sparse, :clustered, :sorted_rand)

    println("v_kind\tq_kind\tn\tm\tAuto/best\tbest_strat\tAuto_pick_strat")
    autoslack = Float64[]
    for v_kind in v_kinds, q_kind in q_kinds, n in ns, m in ms
        m > n && continue
        times, t_auto = bench_cell(v_kind, q_kind, n, m)
        best, j = findmin(times)
        ratio = t_auto / best
        push!(autoslack, ratio)
        println(string(v_kind, "\t", q_kind, "\t", n, "\t", m,
                       "\t", round(ratio; digits = 2),
                       "\t", STRAT_NAMES[j]))
    end
    println()
    println("Auto-vs-best ratio summary:")
    println("  median ", round(median(autoslack); digits = 3))
    println("  mean   ", round(mean(autoslack);   digits = 3))
    println("  p90    ", round(quantile(autoslack, 0.9); digits = 3))
    println("  max    ", round(maximum(autoslack); digits = 3))
end

run_sweep()
```

### Headline results

The 2.0 sweep covers 1080 cells across 5 `v` patterns × 4 query patterns ×
5 `n` sizes × 6 `m` sizes × 2 element types (`Int64`, `Float64`), measured
on AVX2 hardware.

| Metric | `Auto()` | `Auto(SearchProperties(v))` |
|---|---|---|
| median slack | 1.04× | 1.03× |
| mean slack | 1.09× | 1.08× |
| p90 slack | 1.33× | 1.31× |
| p95 slack | 1.38× | 1.38× |
| max slack | 2.18× | 2.09× |

Per-cell winner distribution across the sweep:

  - LinearScan: 47% of cells (small-gap regime, all eltypes)
  - SIMDLinearScan: 25% of cells (medium-gap regime, Int64/Float64 dense)
  - InterpolationSearch: 13% of cells (large-gap regime, ~linear v)
  - ExpFromLeft: 8% of cells (small-medium-gap regime, non-SIMD eltypes)
  - BracketGallop: 8% of cells (large-gap regime, non-linear v)

The cells where `Auto` slack is highest are boundary cells at `m = 4` where
the per-cell winner is a measurement artefact (each measurement amortises
over only 4 queries, so per-call setup noise dominates). The bulk of the
distribution sits well below 1.5×.

### Reading the comparison table

For each cell the script prints `Auto/best` (a ratio ≥ 1) along with the
per-cell winner and `Auto`'s actual pick. `Auto/best = 1.0` means `Auto`
picked the winner; `Auto/best = 1.5` means whatever `Auto` picked was 50%
slower than the per-cell winner. Investigate any row where the ratio
exceeds 1.5 — those are candidate cells for tightening one of the
constants in the table above.

## Caching with `SearchProperties`

Every call to `searchsortedlast!(out, v, queries; strategy = Auto())` against
the same `v` re-runs the same probes — `_sampled_looks_linear(v)` reads 11
elements (~25 ns), and the cost is per-call regardless of how many times
you've already searched `v`. For callers issuing many short batches against
a single sorted vector (interpolation segment lookups being the obvious
case), caching the probes once and reusing the result is a real win.

The cache is a small `isbits` struct, [`SearchProperties`](@ref
FindFirstFunctions.SearchProperties), that `Auto` accepts via
`Auto(props)`:

```julia
using FindFirstFunctions

v = collect(0.0:0.001:100.0)
props = SearchProperties(v)            # run probes once
strat = Auto(props)                    # `Auto` holding the cached facts

# Every subsequent searchsortedlast!/searchsortedfirst! call skips the
# linearity probe inside Auto.
queries = sort!(rand(8) .* 100.0)
out = Vector{Int}(undef, length(queries))
searchsortedlast!(out, v, queries; strategy = strat)
```

`SearchProperties` is `isbits` — it travels in registers and copies are
free. `Auto(props)` is itself zero-allocation; the resulting `Auto` is a
single concrete struct, not a parametric type, so call sites stay
type-stable without specialization explosions.

Currently consumed: `props.is_linear` (replaces Auto's
`_sampled_looks_linear` probe in the batched path). The other fields
(`has_props`, `has_nan`) are populated by `SearchProperties(v)` for forward
compatibility but no strategy reads them yet. Construction cost is O(1) for
integer eltypes (only the sampled-linearity probe runs) and O(n) for
floating-point eltypes (additionally `any(isnan, v)`).

Trust contract: the cache is not invalidated automatically. If `v` mutates
after `SearchProperties(v)`, the caller must reconstruct the cache. Lying
to `Auto` via a hand-constructed `SearchProperties(true, true, false)` on
genuinely non-linear data is correctness-preserving (the chosen
`InterpolationSearch` falls through to `BracketGallop` from a bad guess —
slow but still O(log n)), so the worst case of a stale cache is a
performance regression, not wrong answers.

## When `Auto` is wrong for you

If your workload sits in a corner that `Auto` doesn't read well, pin the
strategy directly:

```julia
# Sorted batch over a known-linear range, large m and n: skip the probe.
searchsortedlast!(out, v, queries; strategy = InterpolationSearch())

# Sorted batch but queries are guaranteed adjacent: don't pay for the
# 5 linear probes in ExpFromLeft.
searchsortedlast!(out, v, queries; strategy = LinearScan())

# No hint and the access pattern is random: skip Auto's probes entirely.
searchsortedlast!(out, v, queries; strategy = BinaryBracket())
```

The strategy types are zero-allocation singletons, so pinning is free at
runtime and just removes the heuristic from the hot path.
